DECLARE SUB initedges ()
DECLARE SUB mergewall (x1%, x2%, sectnum%, locking%)
DECLARE SUB showedges (y%)
CONST xdim = 320

COMMON SHARED edgecnt%
DIM SHARED edgex%(xdim + 1), edgesect%(xdim + 1)

SCREEN 13
RANDOMIZE TIMER

DO
   CALL initedges
   CALL showedges(0)
  
   FOR z% = 1 TO 72
      x1% = INT(320 * RND)
      x2% = INT(320 * RND)
      IF x1% > x2% THEN SWAP x1%, x2%
     
      CALL mergewall(x1%, x2%, z% + 31, INT(1.1 * RND))
     
      showedges (z%)
   NEXT z%
  
   z$ = INPUT$(1)
LOOP WHILE z$ <> CHR$(27)

SUB initedges
   edgex%(0) = 0: edgesect%(0) = -1
   edgex%(1) = 320
   edgecnt% = 2
END SUB

SUB mergewall (x1%, x2%, sectnum%, locking%)
   IF locking% <> 0 THEN locking% = 16384
  
   z1% = 0
   WHILE (edgex%(z1% + 1) AND 16383) < x1%
      z1% = z1% + 1
   WEND
   z2% = z1%
   WHILE (edgex%(z2% + 1) AND 16383) < x2%
      z2% = z2% + 1
   WEND

   secondsect% = edgesect%(z2%)
   secondlock% = (edgex%(z2%) AND 16384)

   IF z2% > z1% THEN
      FOR z% = z2% TO z1% + 1 STEP -1
         IF (edgex%(z%) AND 16384) = 0 THEN
            IF (edgex%(z% - 1) AND 16384) <> 0 THEN
               edgesect%(z%) = sectnum%
               edgex%(z%) = edgex%(z%) + 16384
            ELSE
               edgecnt% = edgecnt% - 1
               FOR zx% = z% TO edgecnt% - 1          'delete z%
                  edgex%(zx%) = edgex%(zx% + 1)
                  edgesect%(zx%) = edgesect%(zx% + 1)
               NEXT zx%
               z2% = z2% - 1
            END IF
         END IF
      NEXT z%
   END IF
  
   IF (edgex%(z1%) AND 16384) = 0 THEN
      FOR z% = edgecnt% TO z1% + 2 STEP -1    'insert z1%+1
         edgex%(z%) = edgex%(z% - 1)
         edgesect%(z%) = edgesect%(z% - 1)
      NEXT z%
      edgecnt% = edgecnt% + 1
      z2% = z2% + 1
      edgex%(z1% + 1) = x1% + locking%
      edgesect%(z1% + 1) = sectnum%
   END IF
  
   IF (edgex%(z2%) AND 16384) = 0 THEN
      FOR z% = edgecnt% TO z2% + 2 STEP -1   'insert z2%+1
         edgex%(z%) = edgex%(z% - 1)
         edgesect%(z%) = edgesect%(z% - 1)
      NEXT z%
      edgecnt% = edgecnt% + 1
      edgex%(z2% + 1) = x2% + secondlock%
      edgesect%(z2% + 1) = secondsect%
   END IF

END SUB

SUB showedges (y%)
   FOR z% = 0 TO edgecnt% - 2
      LINE (edgex%(z%) AND 16383, y% * 2)-((edgex%(z% + 1) AND 16383) - 1, y% * 2 + 1), edgesect%(z%), BF
      IF (edgex%(z%) AND 16384) <> 0 THEN
         LINE (edgex%(z%) AND 16383, y% * 2)-(edgex%(z%) AND 16383, y% * 2 + 1), edgesect%(z%) + 72
         LINE ((edgex%(z% + 1) AND 16383) - 1, y% * 2)-((edgex%(z% + 1) AND 16383) - 1, y% * 2 + 1), edgesect%(z%) + 72
         IF edgesect%(z%) = y% + 31 THEN LINE (edgex%(z%) AND 16383, y% * 2)-((edgex%(z% + 1) AND 16383) - 1, y% * 2), edgesect%(z%) + 72
         FOR x% = (edgex%(z%) AND 16383) + 1 TO (edgex%(z% + 1) AND 16383) - 2 STEP 2
            PSET (x%, y% * 2), edgesect%(z%) + 72
            PSET (x% + 1, y% * 2 + 1), edgesect%(z%) + 72
         NEXT x%
      END IF
   NEXT z%
END SUB

