DECLARE SUB qfillpoly (meshnum%, areanum%, col%)
DECLARE FUNCTION scale& (eax&, ebx&, ecx&)
DECLARE SUB getmesh ()
DECLARE FUNCTION mulscale& (eax&, ebx&, ecx&)
DECLARE FUNCTION divscale& (eax&, ebx&, ecx&)
DECLARE SUB splitmesh2 (meshnum%, x1&, y1&, x2&, y2&)
DECLARE SUB getsplitline (x1&, y1&, x2&, y2&)

CONST XDIM = 640
CONST YDIM = 350
CONST MAXPOINTS = 1024
CONST MAXMESHS = 1024
CONST MAXLOOPS = 1024
CONST MAXSPLITCNT = 1024
CONST SCRMODE = 9

DIM SHARED regs%(7)

DIM SHARED mesh%(MAXMESHS), nummeshs%, lockmode%
DIM SHARED numpoints%, numedges%, numareas%
DIM SHARED px&(MAXPOINTS), py&(MAXPOINTS)
DIM SHARED point2%(MAXPOINTS), tval&(MAXPOINTS)
DIM SHARED p1%(MAXPOINTS), p2%(MAXPOINTS), a1%(MAXPOINTS), a2%(MAXPOINTS)

DIM SHARED split1%(MAXSPLITCNT), splitag1%(MAXSPLITCNT)
DIM SHARED split2%(MAXSPLITCNT), splitag2%(MAXSPLITCNT)

DIM SHARED lastx&(YDIM)

SCREEN SCRMODE: RANDOMIZE TIMER

DO
   CLS
   nummeshs% = 0: numpoints% = 0
   CALL getmesh
   FOR z% = 0 TO numpoints% - 1
      px&(z%) = px&(z%) \ 65536
      py&(z%) = py&(z%) \ 65536
      p1%(z%) = z%: p2%(z%) = point2%(z%)
      a1%(z%) = 1: a2%(z%) = 0
      'a1%(z%) = z% + 1: a2%(z%) = 0
   NEXT z%
   numedges% = numpoints%
     
   numareas% = 0
     
      'Add a point and make trianges like a jerk
   'cx& = 0: cy& = 0
   'FOR z% = 0 TO numpoints% - 1
   '   cx& = cx& + px&(z%): cy& = cy& + py&(z%)
   'NEXT z%
   'px&(numpoints%) = cx& \ numpoints%
   'py&(numpoints%) = cy& \ numpoints%
   'FOR z% = 0 TO numpoints% - 1
   '   p1%(numedges%) = p2%(z%): p2%(numedges%) = numpoints%
   '   a1%(numedges%) = p1%(z%) + 1: a2%(numedges%) = p2%(z%) + 1
   '   numedges% = numedges% + 1
   '   numareas% = numareas% + 1
   'NEXT z%
   'numpoints% = numpoints% + 1

   mesh%(0) = 0: mesh%(1) = numedges%: nummeshs% = 1
 
   DO
      CALL getsplitline(x1&, y1&, x2&, y2&)
      CALL splitmesh2(nummeshs% - 1, x1&, y1&, x2&, y2&)
   LOOP

   IF numpoints% > 0 THEN DO: LOOP WHILE INKEY$ = ""
LOOP WHILE z$ <> CHR$(27)

FUNCTION divscale& (eax&, ebx&, ecx&)
   'divscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 99                                cdq
   '66 0f a5 c2                          shld    edx,eax,cl
   '66 d3 e0                             shl     eax,cl
   '66 f7 fb                             idiv    ebx

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(divscale&): offset& = VARPTR(divscale&)

   DIM asmprog%(27)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &H99
   POKE p& + 28, &H66: POKE p& + 29, &HF: POKE p& + 30, &HA5: POKE p& + 31, &HC2
   POKE p& + 32, &H66: POKE p& + 33, &HD3: POKE p& + 34, &HE0
   POKE p& + 35, &H66: POKE p& + 36, &HF7: POKE p& + 37, &HFB
   POKE p& + 38, &H26: POKE p& + 39, &HA3: POKE p& + 40, offset& AND 255: POKE p& + 41, (offset& \ 256) AND 255
   POKE p& + 42, &H66: POKE p& + 43, &HC1: POKE p& + 44, &HE8: POKE p& + 45, &H10
   POKE p& + 46, &H26: POKE p& + 47, &HA3: POKE p& + 48, (offset& + 2) AND 255: POKE p& + 49, ((offset& + 2) \ 256) AND 255
   POKE p& + 50, &H5D                                         'pop bp
   POKE p& + 51, &HCA: POKE p& + 52, &H2: POKE p& + 53, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

SUB getmesh
   SCREEN SCRMODE, , 0, 0: pag% = 0
   mousx& = XDIM * 65536 \ 2: mousy& = YDIM * 65536 \ 2: bstatus% = 0
   DO
         'GET MOUSE INPUT
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      mousx& = mousx& + regs%(2) * 65536 \ 2
      mousy& = mousy& + regs%(3) * 65536 \ 2
      IF mousx& < 4 * 65536 THEN mousx& = 4 * 65536
      IF mousy& < 4 * 65536 THEN mousy& = 4 * 65536
      IF mousx& >= (XDIM - 4) * 65536 THEN mousx& = (XDIM - 4) * 65536
      IF mousy& >= (YDIM - 4) * 65536 THEN mousy& = (YDIM - 4) * 65536
      regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
      obstatus% = bstatus%: bstatus% = regs%(0)

         'SET POINT TO MOUSE POSITION
      px&(numpoints%) = mousx&
      py&(numpoints%) = mousy&
      IF lockmode% <> 0 THEN
         px&(numpoints%) = ((mousx& + 524288) AND &HFFF00000)
         py&(numpoints%) = ((mousy& + 524288) AND &HFFF00000)
      END IF
      point2%(numpoints%) = mesh%(nummeshs%)

         'GET KEYBOARD INPUT
      z$ = INKEY$
      IF z$ = "l" OR z$ = "L" THEN lockmode% = 1 - lockmode%
      IF z$ = " " OR (bstatus% AND 1) <> 0 THEN
         bad% = 0
         IF numpoints% > mesh%(nummeshs%) THEN
            IF ABS(px&(numpoints% - 1) - px&(numpoints%)) <= 2 * 65536 THEN
               IF ABS(py&(numpoints% - 1) - py&(numpoints%)) <= 2 * 65536 THEN bad% = 1
            END IF
         END IF
         IF bad% = 0 THEN
            point2%(numpoints%) = numpoints% + 1
            numpoints% = numpoints% + 1
         END IF
      END IF
      IF z$ = CHR$(8) THEN
         IF numpoints% > mesh%(nummeshs%) THEN
            numpoints% = numpoints% - 1
         ELSEIF nummeshs% > 0 THEN
            numpoints% = numpoints% - 1
            nummeshs% = nummeshs% - 1
         END IF
      END IF
      DEF SEG = &H0
      IF z$ = CHR$(13) AND (PEEK(&H417) AND 3) <> 0 THEN
         z$ = ""
         point2%(numpoints%) = mesh%(nummeshs%)
         nummeshs% = nummeshs% + 1
         numpoints% = numpoints% + 1
         mesh%(nummeshs%) = numpoints%
      END IF

         'SET POINT TO MOUSE POSITION
      px&(numpoints%) = mousx&
      py&(numpoints%) = mousy&
      IF lockmode% <> 0 THEN
         px&(numpoints%) = ((mousx& + 524288) AND &HFFF00000)
         py&(numpoints%) = ((mousy& + 524288) AND &HFFF00000)
      END IF
      point2%(numpoints%) = mesh%(nummeshs%)
    
         'DRAW SCREEN
      CLS
      FOR z% = 0 TO numpoints%
         zz% = point2%(z%)
         LINE (px&(z%) \ 65536, py&(z%) \ 65536)-(px&(zz%) \ 65536, py&(zz%) \ 65536), 4
         CIRCLE (px&(z%) \ 65536, py&(z%) \ 65536), 3, 4
      NEXT z%
      CIRCLE (mousx& \ 65536, mousy& \ 65536), 3, 7
      LINE (mousx& \ 65536 - 1, mousy& \ 65536 - 1)-(mousx& \ 65536 + 1, mousy& \ 65536 + 1), 0, BF

         'FLIP PAGES
      SCREEN SCRMODE, , pag%, 1 - pag%: pag% = 1 - pag%
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
                  
   LOOP WHILE z$ <> CHR$(13)
   numpoints% = numpoints% + 1
   nummeshs% = nummeshs% + 1
   mesh%(nummeshs%) = numpoints%
   IF mesh%(nummeshs%) <= mesh%(nummeshs% - 1) + 2 THEN
      nummeshs% = nummeshs% - 1
      numpoints% = numpoints% - 1
   END IF
END SUB

SUB getsplitline (x1&, y1&, x2&, y2&)
   pag% = 0

   danumpoints% = 0

   bstatus% = 3
   x& = XDIM \ 2: y& = YDIM \ 2
   DO
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      x& = x& + regs%(2) \ 2: y& = y& + regs%(3) \ 2
      regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
      obstatus% = bstatus%: bstatus% = regs%(0)
      IF x& < 4 THEN x& = 4
      IF y& < 4 THEN y& = 4
      IF x& >= XDIM - 4 THEN x& = XDIM - 4 - 1
      IF y& >= YDIM - 4 THEN y& = YDIM - 4 - 1
     
      CLS
     
      FOR z% = 1 TO numareas%
         CALL qfillpoly(nummeshs% - 1, z%, 14 - z%)
      NEXT z%
      FOR dap% = 0 TO nummeshs% - 1
         FOR z% = mesh%(dap%) TO mesh%(dap% + 1) - 1
            p% = p1%(z%): pp% = p2%(z%)

            IF dap% = nummeshs% - 1 THEN col% = 14 ELSE col% = 9
            LINE (px&(p%), py&(p%))-(px&(pp%), py&(pp%)), col%

            dax& = (px&(p%) + px&(pp%)) \ 2: vx& = (py&(p%) - py&(pp%))
            day& = (py&(p%) + py&(pp%)) \ 2: vy& = (px&(pp%) - px&(p%))
            dist& = SQR(vx& * vx& + vy& * vy&)
            IF dist& = 0 THEN dist& = 1
            LINE (dax&, day&)-(dax& + ((vx& * 6) \ dist&), day& + ((vy& * 6) \ dist&)), col% - 8
            IF a2%(z%) > 0 THEN LINE (dax&, day&)-(dax& - ((vx& * 6) \ dist&), day& - ((vy& * 6) \ dist&)), col% - 8
         NEXT z%
      NEXT dap%
      FOR z% = 0 TO numpoints% - 1
         CIRCLE (px&(z%), py&(z%)), 3, 15
      NEXT z%
     
      CIRCLE (x&, y&), 3, 15
     
      IF danumpoints% = 0 THEN
         x1& = x&: y1& = y&
         IF lockmode% THEN x1& = x1& OR 15 XOR 15: y1& = y1& OR 15 XOR 15
      END IF
      IF danumpoints% = 1 THEN
         x2& = x&: y2& = y&
         IF lockmode% THEN x2& = x2& OR 15 XOR 15: y2& = y2& OR 15 XOR 15
      END IF
     
      IF danumpoints% >= 0 THEN
         CIRCLE (x1&, y1&), 3, 4
         IF danumpoints% = 1 THEN LINE (x1&, y1&)-(x2&, y2&), 4
      END IF

      SCREEN SCRMODE, , pag%, 1 - pag%: pag% = 1 - pag%
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
   
      z$ = INKEY$
      IF z$ = "l" OR z$ = "L" THEN lockmode% = 1 - lockmode%
      IF (z$ = " " OR (bstatus% AND 1) > 0) AND danumpoints% < 1 THEN danumpoints% = danumpoints% + 1
      IF z$ = CHR$(8) AND danumpoints% > 0 THEN danumpoints% = danumpoints% - 1
   LOOP WHILE (z$ <> CHR$(13) AND (bstatus% AND 2) <= (obstatus% AND 2)) OR (danumpoints% = 0)
END SUB

FUNCTION mulscale& (eax&, ebx&, ecx&)
   'mulscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 f7 eb                             imul    ebx
   '66 0f ad d0                          shrd    eax,edx,cl

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(mulscale&): offset& = VARPTR(mulscale&)

   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &HF7: POKE p& + 28, &HEB
   POKE p& + 29, &H66: POKE p& + 30, &HF: POKE p& + 31, &HAD: POKE p& + 32, &HD0
   POKE p& + 33, &H26: POKE p& + 34, &HA3: POKE p& + 35, offset& AND 255: POKE p& + 36, (offset& \ 256) AND 255
   POKE p& + 37, &H66: POKE p& + 38, &HC1: POKE p& + 39, &HE8: POKE p& + 40, &H10
   POKE p& + 41, &H26: POKE p& + 42, &HA3: POKE p& + 43, (offset& + 2) AND 255: POKE p& + 44, ((offset& + 2) \ 256) AND 255
   POKE p& + 45, &H5D                                         'pop bp
   POKE p& + 46, &HCA: POKE p& + 47, &H2: POKE p& + 48, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

SUB qfillpoly (meshnum%, areanum%, col%)
   ymin& = YDIM: ymax& = 0
  
   pstart% = mesh%(meshnum%): pend% = mesh%(meshnum% + 1) - 1
   FOR z% = pstart% TO pend%
      IF a1%(z%) = areanum% OR a2%(z%) = areanum% THEN
         p% = p1%(z%): pp% = p2%(z%)
         IF py&(p%) < ymin& THEN ymin& = py&(p%)
         IF py&(p%) > ymax& THEN ymax& = py&(p%)
         IF py&(pp%) < ymin& THEN ymin& = py&(pp%)
         IF py&(pp%) > ymax& THEN ymax& = py&(pp%)
      END IF
   NEXT z%

   FOR y& = ymin& TO ymax&: lastx&(y&) = &H80000000: NEXT y&
  
   FOR z% = pstart% TO pend%
      IF a1%(z%) = areanum% OR a2%(z%) = areanum% THEN
         x1& = px&(p1%(z%)): y1& = py&(p1%(z%))
         x2& = px&(p2%(z%)): y2& = py&(p2%(z%))
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF y2& > y1& THEN
            xplc& = x1& * 256: xinc& = (x2& - x1&) * 256 / (y2& - y1&)
            FOR y& = y1& TO y2& - 1
               IF lastx&(y&) = &H80000000 THEN
                  lastx&(y&) = xplc& \ 256
               ELSE
                  LINE (xplc& \ 256, y&)-(lastx&(y&), y&), col%
               END IF
               xplc& = xplc& + xinc&
            NEXT y&
         END IF
      END IF
   NEXT z%
END SUB

FUNCTION scale& (eax&, ebx&, ecx&)
   'scale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 f7 eb                             imul    ebx
   '66 f7 f9                             idiv    ecx

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(scale&): offset& = VARPTR(scale&)

   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &HF7: POKE p& + 28, &HEB
   POKE p& + 29, &H66: POKE p& + 30, &HF7: POKE p& + 31, &HF9
   POKE p& + 32, &H26: POKE p& + 33, &HA3: POKE p& + 34, offset& AND 255: POKE p& + 35, (offset& \ 256) AND 255
   POKE p& + 36, &H66: POKE p& + 37, &HC1: POKE p& + 38, &HE8: POKE p& + 39, &H10
   POKE p& + 40, &H26: POKE p& + 41, &HA3: POKE p& + 42, (offset& + 2) AND 255: POKE p& + 43, ((offset& + 2) \ 256) AND 255
   POKE p& + 44, &H5D                                         'pop bp
   POKE p& + 45, &HCA: POKE p& + 46, &H2: POKE p& + 47, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

SUB splitmesh2 (meshnum%, x1&, y1&, x2&, y2&)
   pstart% = mesh%(meshnum%): pend% = mesh%(meshnum% + 1) - 1

   dx& = y2& - y1&: dy& = x1& - x2&
     
   FOR z% = pstart% TO pend%
      tval&(p1%(z%)) = &H80000000: tval&(p2%(z%)) = &H80000000
   NEXT z%

   numedges2% = MAXPOINTS - 1
   splitcnt1% = 0: splitcnt2% = 0
   FOR z% = pstart% TO pend%
      p% = p1%(z%): pp% = p2%(z%)
      a% = a1%(z%): aa% = a2%(z%)
      IF tval&(p%) = &H80000000 THEN tval&(p%) = (px&(p%) - x1&) * dx& + (py&(p%) - y1&) * dy&
      IF tval&(pp%) = &H80000000 THEN tval&(pp%) = (px&(pp%) - x1&) * dx& + (py&(pp%) - y1&) * dy&
      t1& = tval&(p%): t2& = tval&(pp%)
      IF t1& > 0 THEN
         IF t2& >= 0 THEN                  't1>0,t2>=0
            p1%(numedges%) = p%: p2%(numedges%) = pp%
            a1%(numedges%) = a%: a2%(numedges%) = aa%
            IF t2& = 0 THEN split1%(splitcnt1%) = pp%: splitag1%(splitcnt1%) = a% XOR aa%: splitcnt1% = splitcnt1% + 1
            numedges% = numedges% + 1
         ELSE                              't1>0,t2<0
            px&(numpoints%) = px&(p%) + scale&(px&(pp%) - px&(p%), t1&, t1& - t2&)
            py&(numpoints%) = py&(p%) + scale&(py&(pp%) - py&(p%), t1&, t1& - t2&)
            p1%(numedges%) = p%: p2%(numedges%) = numpoints%
            a1%(numedges%) = a%: a2%(numedges%) = aa%
            p1%(numedges2%) = numpoints%: p2%(numedges2%) = pp%
            a1%(numedges2%) = a%: a2%(numedges2%) = aa%
            split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = a% XOR aa%: splitcnt1% = splitcnt1% + 1
            split2%(splitcnt2%) = numpoints%: splitag2%(splitcnt2%) = a% XOR aa%: splitcnt2% = splitcnt2% + 1
            numedges% = numedges% + 1: numedges2% = numedges2% - 1
            numpoints% = numpoints% + 1
         END IF
      ELSEIF t1& <> 0 THEN
         IF t2& <= 0 THEN                  't1<0,t2<=0
            p1%(numedges2%) = p%: p2%(numedges2%) = pp%
            a1%(numedges2%) = a%: a2%(numedges2%) = aa%
            IF t2& = 0 THEN split2%(splitcnt2%) = pp%: splitag2%(splitcnt2%) = a% XOR aa%: splitcnt2% = splitcnt2% + 1
            numedges2% = numedges2% - 1
         ELSE                              't1<0,t2>0
            px&(numpoints%) = px&(p%) + scale&(px&(pp%) - px&(p%), t1&, t1& - t2&)
            py&(numpoints%) = py&(p%) + scale&(py&(pp%) - py&(p%), t1&, t1& - t2&)
            p1%(numedges%) = numpoints%: p2%(numedges%) = pp%
            a1%(numedges%) = a%: a2%(numedges%) = aa%
            p1%(numedges2%) = p%: p2%(numedges2%) = numpoints%
            a1%(numedges2%) = a%: a2%(numedges2%) = aa%
            split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = a% XOR aa%: splitcnt1% = splitcnt1% + 1
            split2%(splitcnt2%) = numpoints%: splitag2%(splitcnt2%) = a% XOR aa%: splitcnt2% = splitcnt2% + 1
            numedges% = numedges% + 1: numedges2% = numedges2% - 1
            numpoints% = numpoints% + 1
         END IF
      ELSE
         IF t2& > 0 THEN                   't1=0,t2>0
            p1%(numedges%) = p%: p2%(numedges%) = pp%
            a1%(numedges%) = a%: a2%(numedges%) = aa%
            split1%(splitcnt1%) = p%: splitag1%(splitcnt1%) = a% XOR aa%: splitcnt1% = splitcnt1% + 1
            numedges% = numedges% + 1
         ELSEIF t2& <> 0 THEN              't1=0,t2<0
            p1%(numedges2%) = p%: p2%(numedges2%) = pp%
            a1%(numedges2%) = a%: a2%(numedges2%) = aa%
            split2%(splitcnt2%) = p%: splitag2%(splitcnt2%) = a% XOR aa%: splitcnt2% = splitcnt2% + 1
            numedges2% = numedges2% - 1
         END IF
      END IF
   NEXT z%
  
   IF ABS(dx&) >= ABS(dy&) THEN
      FOR z% = 1 TO splitcnt1% - 1
         FOR zz% = 0 TO z% - 1
            IF px&(split1%(z%)) < px&(split1%(zz%)) THEN
               SWAP split1%(z%), split1%(zz%)
               SWAP splitag1%(z%), splitag1%(zz%)
            END IF
         NEXT zz%
      NEXT z%
      FOR z% = 1 TO splitcnt2% - 1
         FOR zz% = 0 TO z% - 1
            IF px&(split2%(z%)) < px&(split2%(zz%)) THEN
               SWAP split2%(z%), split2%(zz%)
               SWAP splitag2%(z%), splitag2%(zz%)
            END IF
         NEXT zz%
      NEXT z%
   ELSE
      FOR z% = 1 TO splitcnt1% - 1
         FOR zz% = 0 TO z% - 1
            IF py&(split1%(z%)) < py&(split1%(zz%)) THEN
               SWAP split1%(z%), split1%(zz%)
               SWAP splitag1%(z%), splitag1%(zz%)
            END IF
         NEXT zz%
      NEXT z%
      FOR z% = 1 TO splitcnt2% - 1
         FOR zz% = 0 TO z% - 1
            IF py&(split2%(z%)) < py&(split2%(zz%)) THEN
               SWAP split2%(z%), split2%(zz%)
               SWAP splitag2%(z%), splitag2%(zz%)
            END IF
         NEXT zz%
      NEXT z%
   END IF
  
   dx& = x2& - x1&: dy& = y2& - y1&
   IF splitcnt1% > 0 THEN
      s1% = split1%(0): s2% = split1%(splitcnt1% - 1)
      inc% = ABS((px&(s2%) - px&(s1%)) * dx& + (py&(s2%) - py&(s1%)) * dy& >= 0)
      s% = 0
      FOR z% = 0 TO splitcnt1% - 2
         s% = s% XOR splitag1%(z%)
         IF s% <> 0 THEN
            p1%(numedges%) = split1%(z% + inc%): p2%(numedges%) = split1%(z% + 1 - inc%)
            a1%(numedges%) = s%: a2%(numedges%) = 0
            numedges% = numedges% + 1
         END IF
      NEXT z%
   END IF
   IF splitcnt2% > 0 THEN
      s1% = split2%(0): s2% = split2%(splitcnt2% - 1)
      inc% = ABS((px&(s2%) - px&(s1%)) * dx& + (py&(s2%) - py&(s1%)) * dy& < 0)
      s% = 0
      FOR z% = 0 TO splitcnt2% - 2
         s% = s% XOR splitag2%(z%)
         IF s% <> 0 THEN
            p1%(numedges2%) = split2%(z% + inc%): p2%(numedges2%) = split2%(z% + 1 - inc%)
            a1%(numedges2%) = s%: a2%(numedges2%) = 0
            numedges2% = numedges2% - 1
         END IF
      NEXT z%
   END IF

   nummeshs% = nummeshs% + 1: mesh%(nummeshs%) = numedges%

   d% = (MAXPOINTS - 1) + numedges%
   FOR z% = MAXPOINTS - 1 TO numedges2% + 1 STEP -1
      p1%(numedges%) = p1%(z%): p2%(numedges%) = p2%(z%)
      a1%(numedges%) = a1%(z%): a2%(numedges%) = a2%(z%)
      numedges% = numedges% + 1
   NEXT z%
   nummeshs% = nummeshs% + 1: mesh%(nummeshs%) = numedges%
END SUB

