DECLARE FUNCTION addboxlinum% (z%)
DECLARE SUB drawline (thez%)
DECLARE FUNCTION front% (l1%, l2%)
DECLARE SUB scan (thelin%)
CONST maxlines% = 1024
DIM SHARED xa1&(maxlines%), ya1&(maxlines%), xa2&(maxlines%), ya2&(maxlines%)
DIM SHARED xr1&(maxlines%), yr1&(maxlines%), xr2&(maxlines%), yr2&(maxlines%)
DIM SHARED xb1&(maxlines%), yb1&(maxlines%), xb2&(maxlines%), yb2&(maxlines%)
DIM SHARED umost%(640), got%(maxlines%), theline%(maxlines%), sintable&(2048)
DIM SHARED cstat%(maxlines%)
COMMON SHARED col%, posx&, posy&, ang%, lintalplc%
FOR z& = 0 TO 511
   sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
NEXT z&
FOR z& = 512 TO 1023
   sintable&(z&) = sintable&(1023 - z&)
NEXT z&
FOR z& = 1024 TO 2047
   sintable&(z&) = -sintable&(z& - 1024)
NEXT z&
SCREEN 12
RANDOMIZE TIMER
GOSUB loadboards
DO
   col% = 1
   LINE (0, 0)-(639, 479), 0, BF
  
   FOR z% = 0 TO numlines% - 1
	 got%(z%) = 0
   NEXT z%
   FOR z% = 0 TO 639
	 umost%(z%) = 0
   NEXT z%
  
   lintalplc% = 0
   FOR z% = 0 TO numlines% - 1
	 IF cstat%(z%) = 3 THEN
	    IF addboxlinum%(z%) = 1 THEN
		  LINE ((xa1&(z%) - posx&) \ 2 + 320, (ya1&(z%) - posy&) \ 2 + 240)-((xa2&(z%) - posx&) \ 2 + 320, (ya2&(z%) - posy&) \ 2 + 240), 4
	    ELSE
		  LINE ((xa1&(z%) - posx&) \ 2 + 320, (ya1&(z%) - posy&) \ 2 + 240)-((xa2&(z%) - posx&) \ 2 + 320, (ya2&(z%) - posy&) \ 2 + 240), 8
	    END IF
	 END IF
   NEXT z%
  
   xa1&(maxlines%) = posx& + sintable&((ang% + 256) AND 2047) \ 32&
   ya1&(maxlines%) = posy& + sintable&((ang% + 1792) AND 2047) \ 32&
   xa2&(maxlines%) = posx& - sintable&((ang% + 1792) AND 2047) \ 32&
   ya2&(maxlines%) = posy& + sintable&((ang% + 256) AND 2047) \ 32&
   xb1&(lintalplc%) = 0
   xb2&(lintalplc%) = 319
   yb1&(lintalplc%) = 1
   yb2&(lintalplc%) = 1
   theline%(lintalplc%) = maxlines%
  
   LINE (320, 240)-((xa1&(maxlines%) - posx&) \ 2 + 320, (ya1&(maxlines%) - posy&) \ 2 + 240), 7
   LINE (320, 240)-((xa2&(maxlines%) - posx&) \ 2 + 320, (ya2&(maxlines%) - posy&) \ 2 + 240), 7
  
   CALL scan(lintalplc%)
  
   DO
	 z$ = INKEY$
   LOOP WHILE z$ = ""
   IF z$ = CHR$(0) + CHR$(72) THEN
	 posx& = posx& + sintable&((ang% + 512) AND 2047) \ 256
	 posy& = posy& + sintable&(ang% AND 2047) \ 256
   END IF
   IF z$ = CHR$(0) + CHR$(80) THEN
	 posx& = posx& - sintable&((ang% + 512) AND 2047) \ 256
	 posy& = posy& - sintable&(ang% AND 2047) \ 256
   END IF
   IF z$ = CHR$(0) + CHR$(75) THEN ang% = (ang% + 2016) AND 2047
   IF z$ = CHR$(0) + CHR$(77) THEN ang% = (ang% + 32) AND 2047
LOOP WHILE z$ <> CHR$(27)
END

loadboards:
   OPEN "boards2.dat" FOR BINARY AS #1
   z$ = "  ": GET #1, , z$: posx& = CVI(z$)
   z$ = "  ": GET #1, , z$: posy& = CVI(z$)
   z$ = "  ": GET #1, , z$: ang% = CVI(z$)
   z$ = "  ": GET #1, , z$: numlines% = CVI(z$)
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 xa1&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 ya1&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 xa2&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 ya2&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 cstat%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   CLOSE #1
RETURN

FUNCTION addboxlinum% (z%)
   got%(z%) = 1
   value% = 0
   xp1& = ((xa1&(z%) - posx&) * sintable&((ang% + 0) AND 2047) - (ya1&(z%) - posy&) * sintable&((ang% + 512) AND 2047)) \ 1024
   yp1& = ((xa1&(z%) - posx&) * sintable&((ang% + 512) AND 2047) + (ya1&(z%) - posy&) * sintable&((ang% + 0) AND 2047)) \ 1024
   xp2& = ((xa2&(z%) - posx&) * sintable&((ang% + 0) AND 2047) - (ya2&(z%) - posy&) * sintable&((ang% + 512) AND 2047)) \ 1024
   yp2& = ((xa2&(z%) - posx&) * sintable&((ang% + 512) AND 2047) + (ya2&(z%) - posy&) * sintable&((ang% + 0) AND 2047)) \ 1024
  
   good% = 7
   IF ((ABS(xp1&) <= yp1&) AND (yp1& > 0)) THEN good% = good% - 1
   IF ((ABS(xp2&) <= yp2&) AND (yp2& > 0)) THEN good% = good% - 2
   IF ((good% = 7) AND ((yp1& > 0) OR (yp2& > 0)) AND ((xp1& < 0) = (0 < xp2&))) THEN good% = 3
   yb1&(lintalplc%) = -1
   yb2&(lintalplc%) = -1
  
   IF (good% < 7) THEN
	 IF ((good% AND 3) > 0) THEN templong& = xp2& * yp1& - xp1& * yp2&
	 IF ((good% AND 1) = 0) THEN
	    IF (yp1& <> 0) THEN xb1&(lintalplc%) = 160& - ((xp1& * 160&) \ yp1&)
	    yb1&(lintalplc%) = yp1&
	 ELSE
	    j& = 0
	    IF (xp1& > 0) THEN j% = 1
	    IF (((xp1& < 0) = (0 < xp2&)) AND ((yp1& < 0) = (0 < yp2&))) THEN
		  IF (ABS(xp1& * yp2&) < ABS(xp2& * yp1&)) THEN j% = 1
	    END IF
	    IF j% = 0 THEN
		  xb1&(lintalplc%) = 319
		  templong1& = yp2& - yp1& + xp2& - xp1&
		  IF templong1& <> 0 THEN yb1&(lintalplc%) = templong& \ templong1&
	    ELSE
		  xb1&(lintalplc%) = 0
		  templong1& = yp1& - yp2& + xp2& - xp1&
		  IF (templong1& <> 0) THEN yb1&(lintalplc%) = templong& \ templong1&
	    END IF
	 END IF
	 IF ((good% AND 2) = 0) THEN
	    IF (yp2& <> 0) THEN xb2&(lintalplc%) = 160& - ((xp2& * 160&) \ yp2&)
	    yb2&(lintalplc%) = yp2&
	 ELSE
	    j& = 0
	    IF (xp2& > 0) THEN j% = 1
	    IF (((xp1& < 0) = (0 < xp2&)) AND ((yp1& < 0) = (0 < yp2&))) THEN
		  IF (ABS(xp2& * yp1&) < ABS(xp1& * yp2&)) THEN j% = 1
	    END IF
	    IF j% = 0 THEN
		  xb2&(lintalplc%) = 319
		  templong1& = yp2& - yp1& + xp2& - xp1&
		  IF templong1& <> 0 THEN yb2&(lintalplc%) = templong& \ templong1&
	    ELSE
		  xb2&(lintalplc%) = 0
		  templong1& = yp1& - yp2& + xp2& - xp1&
		  IF (templong1& <> 0) THEN yb2&(lintalplc%) = templong& \ templong1&
	    END IF
	 END IF
	 IF (yb1&(lintalplc%) > 0) AND (yb2&(lintalplc%) > 0) THEN
	    IF (xb1&(lintalplc%) > xb2&(lintalplc%)) THEN
		  SWAP xb1&(lintalplc%), xb2&(lintalplc%)
		  SWAP yb1&(lintalplc%), yb2&(lintalplc%)
	    END IF
	    xr1&(lintalplc%) = xp1&
	    yr1&(lintalplc%) = yp2&
	    xr2&(lintalplc%) = xp1&
	    yr2&(lintalplc%) = yp2&
	    theline%(lintalplc%) = z%
	    lintalplc% = lintalplc% + 1
	    value% = 1
	 END IF
   END IF
   addboxlinum% = value%
END FUNCTION

SUB drawline (thez%)
   'DO
   '   LINE ((xa1&(theline%(thez%)) - posx&) \ 2 + 320, (ya1&(theline%(thez%)) - posy&) \ 2 + 240)-((xa2&(theline%(thez%)) - posx&) \ 2 + 320, (ya2&(theline%(thez%)) - posy&) \ 2 + 240), 0
   '   LINE ((xa1&(theline%(thez%)) - posx&) \ 2 + 320, (ya1&(theline%(thez%)) - posy&) \ 2 + 240)-((xa2&(theline%(thez%)) - posx&) \ 2 + 320, (ya2&(theline%(thez%)) - posy&) \ 2 + 240), 15
   'LOOP WHILE INKEY$ = ""
   FOR t& = 0 TO 256&
	 x& = (((xa1&(theline%(thez%)) - posx&) * (256 - t&)) + (xa2&(theline%(thez%)) - posx&) * t&) \ 512&
	 y& = (((ya1&(theline%(thez%)) - posy&) * (256 - t&)) + (ya2&(theline%(thez%)) - posy&) * t&) \ 512&
	 LINE (320, 240)-(x& + 320, y& + 240), col%
   NEXT t&
   col% = col% + 1: IF col% = 15 THEN col% = 1
END SUB

FUNCTION front% (l1%, l2%)
 
   templong1& = (xa1&(l1%) - posx&) * (ya1&(l2%) - posy&) - (xa1&(l2%) - posx&) * (ya1&(l1%) - posy&)
   templong2& = (xa1&(l1%) - posx&) * (ya2&(l2%) - posy&) - (xa2&(l2%) - posx&) * (ya1&(l1%) - posy&)
   templong3& = (xa2&(l1%) - posx&) * (ya1&(l2%) - posy&) - (xa1&(l2%) - posx&) * (ya2&(l1%) - posy&)
   templong4& = (xa2&(l1%) - posx&) * (ya2&(l2%) - posy&) - (xa2&(l2%) - posx&) * (ya2&(l1%) - posy&)
   IF templong1& = 0 THEN
	 IF (templong2& <= 0) = (templong3& <= 0) AND (templong3& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSEIF templong2& = 0 THEN
	 IF (templong1& <= 0) = (templong3& <= 0) AND (templong3& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSEIF templong3& = 0 THEN
	 IF (templong1& <= 0) = (templong2& <= 0) AND (templong2& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSEIF templong4& = 0 THEN
	 IF (templong1& <= 0) = (templong2& <= 0) AND (templong2& <= 0) = (templong3& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSE
	 IF (templong1& <= 0) = (templong2& <= 0) AND (templong1& <= 0) = (templong3& <= 0) AND (templong1& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   END IF

   templong1& = (xa1&(l2%) - xa1&(l1%)) * (ya2&(l1%) - ya1&(l1%)) - (xa2&(l1%) - xa1&(l1%)) * (ya1&(l2%) - ya1&(l1%))    'p1(l2) vs. l1
   templong2& = (xa2&(l2%) - xa1&(l1%)) * (ya2&(l1%) - ya1&(l1%)) - (xa2&(l1%) - xa1&(l1%)) * (ya2&(l2%) - ya1&(l1%))    'p2(l2) vs. l1
   IF templong1& = 0 THEN templong1& = templong2&
   IF templong2& = 0 THEN templong2& = templong1&
   IF (templong1& < 0) = (templong2& < 0) THEN
	 templong0& = (posx& - xa1&(l1%)) * (ya2&(l1%) - ya1&(l1%)) - (xa2&(l1%) - xa1&(l1%)) * (posy& - ya1&(l1%))         'pos vs. l1
	 IF (templong1& < 0) = (templong0& < 0) THEN front% = l2% ELSE front% = l1%
	 EXIT FUNCTION
   END IF
 
   templong1& = (xa1&(l1%) - xa1&(l2%)) * (ya2&(l2%) - ya1&(l2%)) - (xa2&(l2%) - xa1&(l2%)) * (ya1&(l1%) - ya1&(l2%)) 'p1(l1) vs. l2
   templong2& = (xa2&(l1%) - xa1&(l2%)) * (ya2&(l2%) - ya1&(l2%)) - (xa2&(l2%) - xa1&(l2%)) * (ya2&(l1%) - ya1&(l2%)) 'p2(l1) vs. l2
   IF templong1& = 0 THEN templong1& = templong2&
   IF templong2& = 0 THEN templong2& = templong1&
   IF (templong1& < 0) = (templong2& < 0) THEN
	 templong0& = (posx& - xa1&(l2%)) * (ya2&(l2%) - ya1&(l2%)) - (xa2&(l2%) - xa1&(l2%)) * (posy& - ya1&(l2%))      'pos vs. l2
	 IF (templong1& < 0) = (templong0& < 0) THEN front% = l1% ELSE front% = l2%
	 EXIT FUNCTION
   END IF

   front% = -2: EXIT FUNCTION
  
END FUNCTION

SUB scan (thelin%)
  
   got%(thelin%) = 2
   'LINE (xa1&(theline%(thelin%))+320, ya1&(theline%(thelin%))+240)-(xa2&(theline%(thelin%))+320, ya2&(theline%(thelin%))+240), 5

   FOR i% = 0 TO lintalplc% - 1
	 IF got%(i%) <> 2 THEN
	    IF front%(theline%(i%), theline%(thelin%)) = theline%(i%) THEN
		  CALL scan(i%)
	    END IF
	 END IF
   NEXT i%
  
   drawline (thelin%)

END SUB

