SCREEN 13
DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
DIM pal%(768)
GOSUB loadpalettes

LINE (0, 0)-(319, 199), 255, BF
FOR z% = 0 TO 15
   FOR zz% = 0 TO 15
      LINE (z% * 12 + 1, zz% * 12 + 1)-(z% * 12 + 12, zz% * 12 + 12), z% * 16 + zz%, BF
   NEXT zz%
NEXT z%
x% = 0: y% = 0
DO
   LINE (x% * 12 + 1, y% * 12 + 1)-(x% * 12 + 12, y% * 12 + 12), 255, B
   DO
      z$ = INKEY$
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      mousx% = regs%(2) \ 2
      mousy% = regs%(3) \ 2
   LOOP WHILE z$ = "" AND mousx% = 0 AND mousy% = 0
   LINE (x% * 12 + 1, y% * 12 + 1)-(x% * 12 + 12, y% * 12 + 12), x% * 16 + y%, B
   x% = x% + mousx%
   y% = y% + mousy%
   IF x% < 0 THEN x% = 0
   IF x% > 15 THEN x% = 15
   IF y% < 0 THEN y% = 0
   IF y% > 15 THEN y% = 15
   IF z$ = CHR$(0) + CHR$(75) AND x% > 0 THEN x% = x% - 1
   IF z$ = CHR$(0) + CHR$(77) AND x% < 15 THEN x% = x% + 1
   IF z$ = CHR$(0) + CHR$(72) AND y% > 0 THEN y% = y% - 1
   IF z$ = CHR$(0) + CHR$(80) AND y% < 15 THEN y% = y% + 1
   z% = (x% * 16 + y%) * 3
   IF z$ = "1" AND pal%(z% + 0) < 63 THEN pal%(z% + 0) = pal%(z% + 0) + 1
   IF z$ = "2" AND pal%(z% + 1) < 63 THEN pal%(z% + 1) = pal%(z% + 1) + 1
   IF z$ = "3" AND pal%(z% + 2) < 63 THEN pal%(z% + 2) = pal%(z% + 2) + 1
   IF z$ = "4" AND pal%(z% + 0) > 0 THEN pal%(z% + 0) = pal%(z% + 0) - 1
   IF z$ = "5" AND pal%(z% + 1) > 0 THEN pal%(z% + 1) = pal%(z% + 1) - 1
   IF z$ = "6" AND pal%(z% + 2) > 0 THEN pal%(z% + 2) = pal%(z% + 2) - 1
   IF z$ = CHR$(9) THEN
      cbak1% = pal%(z% + 0)
      cbak2% = pal%(z% + 1)
      cbak3% = pal%(z% + 2)
   END IF
   IF z$ = " " THEN
      pal%(z% + 0) = cbak1%
      pal%(z% + 1) = cbak2%
      pal%(z% + 2) = cbak3%
   END IF
   IF z$ = "'" THEN oldp% = z%
   IF z$ = CHR$(13) THEN
      newp% = z%
      IF oldp% > newp% THEN SWAP oldp%, newp%
      FOR zz% = oldp% + 3 TO newp% - 3 STEP 3
         pal%(zz% + 0) = ((pal%(newp% + 0) * (zz% - oldp%)) + (pal%(oldp% + 0) * (newp% - zz%))) \ (newp% - oldp%)
         pal%(zz% + 1) = ((pal%(newp% + 1) * (zz% - oldp%)) + (pal%(oldp% + 1) * (newp% - zz%))) \ (newp% - oldp%)
         pal%(zz% + 2) = ((pal%(newp% + 2) * (zz% - oldp%)) + (pal%(oldp% + 2) * (newp% - zz%))) \ (newp% - oldp%)
         OUT &H3C8, zz% \ 3
         OUT &H3C9, pal%(zz% + 0)
         OUT &H3C9, pal%(zz% + 1)
         OUT &H3C9, pal%(zz% + 2)
      NEXT zz%
   END IF
   z% = (x% * 16 + y%) * 3
   COLOR 255
   LOCATE 1, 36: PRINT pal%(z% + 0)
   LOCATE 2, 36: PRINT pal%(z% + 1)
   LOCATE 3, 36: PRINT pal%(z% + 2)
   OUT &H3C8, z% \ 3
   OUT &H3C9, pal%(z% + 0)
   OUT &H3C9, pal%(z% + 1)
   OUT &H3C9, pal%(z% + 2)
LOOP WHILE z$ <> CHR$(27)
GOSUB savepalettes
END

loadpalettes:
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 0 TO 767
      pal%(z%) = ASC(MID$(pal$, z% + 1, 1))
      OUT &H3C9, pal%(z%)
   NEXT z%
   CLOSE #1
RETURN

savepalettes:
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = ""
   FOR z% = 0 TO 767
      pal$ = pal$ + CHR$(pal%(z%))
   NEXT z%
   PUT #1, , pal$
   CLOSE #1
RETURN

