DECLARE SUB vline (x%, y1&, y2&, siz&, walnume%, picplc%, shadeoffs%)
CONST maxwalls% = 4096
DIM SHARED buf%(4096), sintable&(2048)
DIM picsiz%(maxwalls%), picanm%(maxwalls%)
COMMON SHARED pageoffset&, posx&, posy&, ang&, horiz&
FOR z& = 0 TO 2047
   sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
NEXT z&
SCREEN 13
RANDOMIZE TIMER
GOSUB setupcolors
wallnum% = 0: GOSUB loadnewall
pageoffset& = 0
ang& = INT(2048 * RND)
posx& = INT(64 * RND)
posy& = INT(64 * RND)
posz& = INT(4096 * RND) + 6144

						   
cx& = 256: cy& = 1024: radius& = 512: side% = 1
ang1% = 0: ang2% = 0: picrotoffs% = 0

DO
   LINE (0, 0)-(319, 199), 0, BF
   o% = -1
   z% = ang1%
   ang2% = ang2% AND &HFFF8
   IF side% = 0 THEN oldx% = 319 ELSE oldx% = 0
   DO
	 theang% = (z% + 2048) AND 2047
	 x& = cx& + (radius& * sintable&((theang% + 2560) AND 2047)) \ 16384&
	 y& = cy& + (radius& * sintable&(theang%)) \ 16384&
	 oldx% = x%
	 x% = 160 + (x& * 160&) \ y&
	 IF z% = ang1% THEN oldx% = x%
	 y& = 16777216 \ y&
	 siz& = y& * 4096&
	 y1& = 100& * 65536 - siz& \ 16&
	 y2& = 100& * 65536 + siz& \ 16&
	 picplc% = (z% * 8 + picrotoffs%) AND 4095
	 IF side% = 0 THEN
	    WHILE x% < oldx%
		  oldx% = oldx% - 1
		  CALL vline(oldx%, y1&, y2&, siz&, wallnum%, picplc%, 0)
	    WEND
	 ELSE
	    WHILE x% > oldx%
		  oldx% = oldx% + 1
		  CALL vline(oldx%, y1&, y2&, siz&, wallnum%, picplc%, 0)
	    WEND
	 END IF
	 z% = (z% + 8) AND 2047
   LOOP WHILE z% <> ang2%
   DO
	 z$ = INKEY$
   LOOP WHILE z$ = ""
   IF z$ = " " THEN side% = 1 - side%
   IF z$ = CHR$(0) + CHR$(75) THEN cx& = cx& + 16
   IF z$ = CHR$(0) + CHR$(77) THEN cx& = cx& - 16
   IF z$ = CHR$(0) + CHR$(72) THEN cy& = cy& - 16
   IF z$ = CHR$(0) + CHR$(80) THEN cy& = cy& + 16
   IF z$ = "+" AND wallnum% < maxwalls% - 1 THEN wallnum% = wallnum% + 1: GOSUB loadnewall
   IF z$ = "-" AND wallnum% > 0 THEN wallnum% = wallnum% + 1: GOSUB loadnewall
   picrotoffs% = picrotoffs% + 64
LOOP WHILE z$ <> CHR$(27)
END

setupcolors:
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
	 OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   CLOSE #1
RETURN

loadnewall:
   OPEN "pics.dat" FOR BINARY AS #1
  
   SEEK #1, 1
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
	 picsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
	 picanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
  
   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
	 IF picsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((picsiz%(z%) AND 15) + (picsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
  
   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 4095
	 buf%(z%) = PEEK(offs&): offs& = offs& + 1
   NEXT z%
   asksave% = 0
   CLOSE #1
RETURN

SUB vline (x%, y1&, y2&, siz&, walnume%, picplc%, shadeoffs%)
   y1v% = y1& \ 65536
   y2v% = y2& \ 65536
   sizv% = siz& \ 65536
   thesiz% = y2v% - y1v%
   
   IF (y1v% > 199) OR (y2v% < 0) OR (thesiz% <= 0) OR (sizv% <= 0) OR (x% < 0) OR (x% >= 320) THEN EXIT SUB

   picplc% = picplc% AND &HFC0
   vinc& = (33554432 * 32) \ (siz& \ 2048)
   vplc& = ((((y1& AND 65535 XOR 65535) * (vinc& \ 256)) \ 256) AND 65535)
   IF (y1v% < 0) THEN
	 vplc& = vplc& - y1v% * vinc&
	 y1v% = 0
   END IF
   IF (y2v% > 199) THEN y2v% = 199
   thesiz% = y2v% - y1v%
   IF (thesiz% < 1) OR (thesiz% > 200) THEN EXIT SUB

   DEF SEG = &HA000
   p& = y1v% * 320& + x%
   FOR zx% = 0 TO thesiz%
	 vplc& = vplc& + vinc&
	 dat% = buf%(picplc% + ((vplc& \ 65536) AND 63))
	 POKE p&, dat%
	 p& = p& + 320
   NEXT zx%
END SUB

