' "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
' Ken Silverman's official web site: "http://www.advsys.net/ken"
' See the included license file "BUILDLIC.TXT" for license info.

DECLARE SUB hlin (start&, leng%, col%)
DECLARE SUB vlin (start&, startpag%, leng%, col%)
DECLARE SUB vline2 (x&, ydim&, segtemp&, offtemp&, stp%, shadeoffs%)
maxdim% = 128
maxwalls% = 4096
OPTION BASE 0
DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
DIM pal%(768), cl%(16, 3), palookup%(256), band%(16)
DIM buf%(maxdim%, maxdim%), buf2%(maxdim%, maxdim%), buf3%(maxdim%, maxdim%)
DIM buf4%(768), walsiz%(maxwalls%), walanm%(maxwalls%), walsiz2%(maxwalls%)
wallnum& = 0: anywallstatchg% = 0: updat$ = ""
DIM pow2&(16)
pow2&(0) = 1: pow2&(1) = 2: pow2&(2) = 4: pow2&(3) = 8
pow2&(4) = 16: pow2&(5) = 32: pow2&(6) = 64: pow2&(7) = 128
pow2&(8) = 256: pow2&(9) = 512: pow2&(10) = 1024: pow2&(11) = 2048
pow2&(12) = 4096: pow2&(13) = 8192: pow2&(14) = 16384: pow2&(15) = 32768

OPEN "pics.dat" FOR BINARY AS #1
SEEK #1, 1
buf$ = STRING$(maxwalls%, 0)
GET #1, , buf$
FOR z% = 0 TO maxwalls% - 1
   walsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
NEXT z%
buf$ = STRING$(maxwalls%, 0)
GET #1, , buf$
FOR z% = 0 TO maxwalls% - 1
   walanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
NEXT z%
SCREEN 13
LOCATE 25, 1: PRINT "Loading data...";
GOSUB setupcolors
LOCATE 25, 1: PRINT "               ";
palval% = 0
trailstatus% = 0
z$ = ""
DO UNTIL z$ = CHR$(27)
   IF z$ <> CHR$(27) THEN GOSUB editwalls
LOOP
IF anywallstatchg% = 1 THEN
   buf$ = ""
   FOR z% = 0 TO maxwalls% - 1
      buf$ = buf$ + CHR$(walsiz%(z%))
   NEXT z%
   SEEK #1, 1
   PUT #1, , buf$
   buf$ = ""
   FOR z% = 0 TO maxwalls% - 1
      buf$ = buf$ + CHR$(walanm%(z%))
   NEXT z%
   PUT #1, , buf$
END IF
CLOSE #1
END

editwalls:
   GOSUB loadnewall
   DEF SEG = &HA000
   c% = 31: d% = 31
   mousx% = 0: mousy% = 0
   col% = 0
   asksave% = 0
   GOSUB printcol
   DO
      DO
         WAIT &H3DA, 8
         WAIT &H3DA, 8, 255
         LINE (c% * scale%, d% * scale%)-(c% * scale% + scale% - 1, d% * scale% + scale% - 1), (buf%(c%, d%) + 147) MOD 252, BF
         WAIT &H3DA, 8
         WAIT &H3DA, 8, 255
         LINE (c% * scale%, d% * scale%)-(c% * scale% + scale% - 1, d% * scale% + scale% - 1), buf%(c%, d%), BF
         GOSUB mouse
         z$ = UCASE$(INKEY$)
         OUT &H3C8, 255
         WAIT &H3DA, 8
         OUT &H3C9, palval%: OUT &H3C9, palval%: OUT &H3C9, palval%
         palval% = (palval% + 1) AND 63
      LOOP WHILE z$ = "" AND mousx% = 0 AND mousy% = 0
      DEF SEG = 0: keystate% = PEEK(&H417)
      IF trailstatus% = 0 THEN LINE (c% * scale%, d% * scale%)-(c% * scale% + scale% - 1, d% * scale% + scale% - 1), buf%(c%, d%), BF
      IF trailstatus% = 1 THEN LINE (c% * scale%, d% * scale%)-(c% * scale% + scale% - 1, d% * scale% + scale% - 1), col%, BF: buf%(c%, d%) = col%: asksave% = 1
      IF z$ = CHR$(0) + CHR$(82) THEN        'Insert
         IF walsiz%(wallnum&) = 0 THEN
            anywallstatchg% = 1
            asksave% = 1
            LOCATE 2, 26: PRINT "New Size?";
            DO
               z$ = UCASE$(INKEY$)
            LOOP WHILE z$ = ""
            LOCATE 2, 26: PRINT "         ";
            IF z$ = "Y" THEN
               DO
                  LOCATE 2, 26: PRINT "Xdim:";
                  INPUT xdim&
                  LOCATE 2, 26: PRINT "         ";
               LOOP WHILE xdim& <> 4 AND xdim& <> 8 AND xdim& <> 16 AND xdim& <> 32 AND xdim& <> 64 AND xdim& <> 128
               DO
                  LOCATE 2, 26: PRINT "Ydim:";
                  INPUT ydim&
                  LOCATE 2, 26: PRINT "         ";
               LOOP WHILE ydim& <> 4 AND ydim& <> 8 AND ydim& <> 16 AND ydim& <> 32 AND ydim& <> 64 AND ydim& <> 128
               totsiz& = 0
               FOR z% = 0 TO maxwalls% - 1
                  IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
               NEXT z%
               sourplc& = totsiz&
               destplc& = totsiz& + xdim& * ydim&
               FOR z% = maxwalls% - 1 TO wallnum& STEP -1
                  memsiz& = 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
                  IF memsiz& > 1 THEN
                     buf$ = STRING$(memsiz&, 0)
                     sourplc& = sourplc& - memsiz&
                     destplc& = destplc& - memsiz&
                     SEEK #1, sourplc& + maxwalls% * 2 + 1: GET #1, , buf$
                     SEEK #1, destplc& + maxwalls% * 2 + 1: PUT #1, , buf$
                  END IF
               NEXT z%
               walsiz%(wallnum&) = LOG(xdim&) / LOG(2)
               walsiz%(wallnum&) = walsiz%(wallnum&) + 16 * (LOG(ydim&) / LOG(2))
               walanm%(wallnum&) = 0
               c% = xdim& - 1
               d% = ydim& - 1
               GOSUB loadnewall
            END IF
         END IF
      END IF
      IF z$ = CHR$(0) + CHR$(83) THEN      'Delete
         IF walsiz%(wallnum&) <> 0 THEN
            anywallstatchg% = 1
            asksave% = 1
            LOCATE 2, 26: PRINT "Supersuck size?";
            DO
               z$ = UCASE$(INKEY$)
            LOOP WHILE z$ = ""
            LOCATE 2, 26: PRINT "               ";
            IF z$ = "Y" THEN
               totsiz& = 0
               FOR z% = 0 TO wallnum& - 1
                  IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
               NEXT z%
               sourplc& = totsiz&
               destplc& = totsiz&
               sourplc& = sourplc& + 2 ^ ((walsiz%(wallnum&) AND 15) + (walsiz%(wallnum&) \ 16))
               FOR z% = wallnum& + 1 TO maxwalls% - 1
                  memsiz& = 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
                  IF memsiz& > 1 THEN
                     buf$ = STRING$(memsiz&, 0)
                     SEEK #1, sourplc& + maxwalls% * 2 + 1: GET #1, , buf$
                     SEEK #1, destplc& + maxwalls% * 2 + 1: PUT #1, , buf$
                     sourplc& = sourplc& + memsiz&
                     destplc& = destplc& + memsiz&
                  END IF
               NEXT z%
               walsiz%(wallnum&) = 0
               walanm%(wallnum&) = 0
               GOSUB loadnewall
            END IF
         END IF
      END IF
      IF z$ = CHR$(0) + CHR$(132) THEN
         anywallstatchg% = 1
         IF (walanm%(wallnum&) AND 63) > 0 THEN
            walanm%(wallnum&) = (walanm%(wallnum&) + 255) AND 255
         ELSE
            walanm%(wallnum&) = (walanm%(wallnum&) + 64) AND 255
         END IF
         LOCATE 22, 29
         SELECT CASE (walanm%(wallnum&) AND 192)
            CASE 0: PRINT "NoAnm:";
            CASE 64: PRINT "Oscil:";
            CASE 128: PRINT "AnmFD:";
            CASE 192: PRINT "AnmBK:";
         END SELECT
         PRINT (walanm%(wallnum&) AND 63); " ";
      END IF
      IF z$ = CHR$(0) + CHR$(118 - 32) THEN
         anywallstatchg% = 1
         IF (walanm%(wallnum&) AND 63) < 63 THEN
            walanm%(wallnum&) = (walanm%(wallnum&) + 1) AND 255
         ELSE
            walanm%(wallnum&) = (walanm%(wallnum&) + 64) AND 255
         END IF
         LOCATE 22, 29
         SELECT CASE (walanm%(wallnum&) AND 192)
            CASE 0: PRINT "NoAnm:";
            CASE 64: PRINT "Oscil:";
            CASE 128: PRINT "AnmFD:";
            CASE 192: PRINT "AnmBK:";
         END SELECT
         PRINT (walanm%(wallnum&) AND 63); " ";
      END IF
      IF z$ = "O" THEN
         asksave% = 1
         LOCATE 2, 26: PRINT "Optimize?";
         DO
            zx$ = UCASE$(INKEY$)
         LOOP WHILE zx$ <> "Y" AND zx$ <> "N"
         LOCATE 2, 26: PRINT "         ";
         IF zx$ = "Y" THEN
            OPEN "PICSTEMP.JNK" FOR BINARY AS #2
            buf$ = ""
            FOR z% = 0 TO maxwalls% - 1
               buf$ = buf$ + CHR$(walsiz%(z%))
            NEXT z%
            PUT #2, , buf$
            buf$ = ""
            FOR z% = 0 TO maxwalls% - 1
               buf$ = buf$ + CHR$(walanm%(z%))
            NEXT z%
            PUT #2, , buf$
            SEEK #1, maxwalls% * 2 + 1
            FOR z% = 0 TO maxwalls% - 1
               IF walsiz%(z%) > 0 THEN
                  buf$ = STRING$(2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16)), 0)
                  GET #1, , buf$
                  PUT #2, , buf$
               END IF
            NEXT z%
            CLOSE #2
            CLOSE #1
            SHELL "copy PICSTEMP.JNK PICS.DAT > nul"
            SHELL "del PICSTEMP.JNK > nul"
            OPEN "pics.dat" FOR BINARY AS #1
         END IF
      END IF
      IF z$ = "R" THEN
         asksave% = 1
         LOCATE 2, 26: PRINT "Rotate way?";
         DO
            z$ = UCASE$(INKEY$)
         LOOP WHILE z$ = ""
         LOCATE 2, 26: PRINT "           ";
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf3%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         IF z$ = CHR$(0) + CHR$(72) THEN
            FOR z% = 0 TO xdim& - 1
               FOR zz% = 0 TO ydim& - 1
                  buf%(z%, zz%) = buf3%(z%, (zz% + ydim& - 1) MOD ydim&)
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               NEXT zz%
            NEXT z%
         END IF
         IF z$ = CHR$(0) + CHR$(80) THEN
            FOR z% = 0 TO xdim& - 1
               FOR zz% = 0 TO ydim& - 1
                  buf%(z%, zz%) = buf3%(z%, (zz% + 1) MOD ydim&)
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               NEXT zz%
            NEXT z%
         END IF
         IF z$ = CHR$(0) + CHR$(75) THEN
            FOR z% = 0 TO xdim& - 1
               FOR zz% = 0 TO ydim& - 1
                  buf%(z%, zz%) = buf3%((z% + xdim& - 1) MOD xdim&, zz%)
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               NEXT zz%
            NEXT z%
         END IF
         IF z$ = CHR$(0) + CHR$(77) THEN
            FOR z% = 0 TO xdim& - 1
               FOR zz% = 0 TO ydim& - 1
                  buf%(z%, zz%) = buf3%((z% + xdim& + 1) MOD xdim&, zz%)
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               NEXT zz%
            NEXT z%
         END IF
      END IF
      IF z$ = "K" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf3%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            offs% = INT(3 * RND) - 1
            FOR zz% = 0 TO ydim& - 1
               buf%(z%, zz%) = buf3%(z%, (zz% + offs% + xdim&) MOD ydim&)
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "\" THEN c% = xdim& \ 2: d% = ydim& \ 2
      IF z$ = "|" THEN LOCATE 18, 30: PRINT c%; d%; "  ";
      IF (keystate% AND 7) = 0 THEN
         IF z$ = CHR$(0) + CHR$(72) AND d% > 0 THEN d% = d% - 1
         IF z$ = CHR$(0) + CHR$(80) AND d% < ydim& - 1 THEN d% = d% + 1
         IF z$ = CHR$(0) + CHR$(75) AND c% > 0 THEN c% = c% - 1
         IF z$ = CHR$(0) + CHR$(77) AND c% < xdim& - 1 THEN c% = c% + 1
      END IF
      IF (keystate% AND 3) > 0 THEN
         GOSUB clearcol
         IF z$ = CHR$(0) + CHR$(72) AND col% > 0 THEN col% = col% - 1
         IF z$ = CHR$(0) + CHR$(80) AND col% < 255 THEN col% = col% + 1
         IF z$ = CHR$(0) + CHR$(75) AND col% > 15 THEN col% = col% - 16
         IF z$ = CHR$(0) + CHR$(77) AND col% < 240 THEN col% = col% + 16
         GOSUB printcol
      END IF
      IF z$ = "1" THEN x1% = c%: y1% = d%
      IF z$ = "2" THEN
         x2% = c%: y2% = d%
         IF x1% > x2% THEN SWAP x1%, x2%
         IF y1% > y2% THEN SWAP y1%, y2%
         FOR z% = x1% TO x2%
            FOR zz% = y1% TO y2%
               buf3%(z% - x1%, zz% - y1%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         x2% = x2% - x1%
         y2% = y2% - y1%
         x1% = 0
         y1% = 0
      END IF
      IF z$ = "4" THEN
         FOR z% = 0 TO x2% \ 2
            FOR zz% = 0 TO y2%
               SWAP buf3%(z%, zz%), buf3%(x2% - z%, zz%)
            NEXT zz%
         NEXT z%
         SOUND 262, .1
      END IF
      IF z$ = "5" THEN
         FOR z% = 0 TO x2%
            FOR zz% = 0 TO y2% \ 2
               SWAP buf3%(z%, zz%), buf3%(z%, y2% - zz%)
            NEXT zz%
         NEXT z%
         SOUND 262, .1
      END IF
      IF z$ = "6" THEN
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               IF z% > zz% THEN SWAP buf3%(z%, zz%), buf3%(zz%, z%)
            NEXT zz%
         NEXT z%
         SWAP x2%, y2%
         SOUND 262, .1
      END IF
      IF z$ = "7" THEN
         asksave% = 1
         col1% = buf%(c%, d%)
         col2% = col%
         newcol% = (col1% + col2%) \ 2
         IF (newcol% = col1% OR newcol% = col2% OR ((col1% \ 32) <> (col2% \ 32))) THEN
            SOUND 37, 2
         ELSE
            FOR z% = 0 TO xdim& - 1
               FOR zz% = 0 TO ydim& - 1
                  IF buf%(z%, zz%) = col1% THEN
                     IF buf%((z% + xdim& - 1) MOD xdim&, zz%) = col2% THEN
                        buf%((z% + xdim& - 1) MOD xdim&, zz%) = newcol%
                        LINE (((z% + xdim& - 1) MOD xdim&) * scale%, zz% * scale%)-((((z% + xdim& - 1) MOD xdim&)) * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(((z% + xdim& - 1) MOD xdim&), zz%), BF
                     END IF
                  END IF
                  IF buf%(z%, zz%) = col1% THEN
                     IF buf%((z% + 1) MOD xdim&, zz%) = col2% THEN
                        buf%((z% + 1) MOD xdim&, zz%) = newcol%
                        LINE (((z% + 1) MOD xdim&) * scale%, zz% * scale%)-((((z% + 1) MOD xdim&)) * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(((z% + 1) MOD xdim&), zz%), BF
                     END IF
                  END IF
                  IF buf%(z%, zz%) = col1% THEN
                     IF buf%(z%, (zz% + ydim& - 1) MOD ydim&) = col2% THEN
                        buf%(z%, (zz% + ydim& - 1) MOD ydim&) = newcol%
                        LINE (z% * scale%, ((zz% + ydim& - 1) MOD ydim&) * scale%)-(z% * scale% + scale% - 1, ((zz% + ydim& - 1) MOD ydim&) * scale% + scale% - 1), buf%(z%, (zz% + ydim& - 1) MOD ydim&), BF
                     END IF
                  END IF
                  IF buf%(z%, zz%) = col1% THEN
                     IF buf%(z%, (zz% + 1) MOD ydim&) = col2% THEN
                        buf%(z%, (zz% + 1) MOD ydim&) = newcol%
                        LINE (z% * scale%, ((zz% + 1) MOD ydim&) * scale%)-(z% * scale% + scale% - 1, ((zz% + 1) MOD ydim&) * scale% + scale% - 1), buf%(z%, (zz% + 1) MOD ydim&), BF
                     END IF
                  END IF
               NEXT zz%
            NEXT z%
            SOUND 262, .1
         END IF
      END IF
      IF z$ = "g" OR z$ = "G" THEN
         FOR z% = 0 TO xdim& STEP 2
            FOR zz% = 0 TO ydim&
               IF (buf%(z%, zz%) AND 31) > 0 THEN
                  buf%(z%, zz%) = buf%(z%, zz%) - 1
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               END IF
               IF (buf%(zz%, z%) AND 31) > 0 THEN
                  buf%(zz%, z%) = buf%(zz%, z%) - 1
                  LINE (zz% * scale%, z% * scale%)-(zz% * scale% + scale% - 1, z% * scale% + scale% - 1), buf%(zz%, z%), BF
               END IF
            NEXT zz%
         NEXT z%
         asksave% = 1
      END IF
      IF z$ = "," OR z$ = "<" THEN
         zstep% = SGN(c% - x1%)
         zzstep% = SGN(d% - y1%)
         IF zstep% = 0 THEN zstep% = 1
         IF zzstep% = 0 THEN zzstep% = 1
         FOR z% = x1% TO c% STEP zstep%
            FOR zz% = y1% TO d% STEP zzstep%
               IF z$ = "," THEN buf%(z%, zz%) = buf%(z%, zz%) - 1
               IF z$ = "<" THEN buf%(z%, zz%) = (buf%(z%, zz%) + 240) AND 255
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
         asksave% = 1
      END IF
      IF z$ = "." OR z$ = ">" THEN
         zstep% = SGN(c% - x1%)
         zzstep% = SGN(d% - y1%)
         IF zstep% = 0 THEN zstep% = 1
         IF zzstep% = 0 THEN zzstep% = 1
         FOR z% = x1% TO c% STEP zstep%
            FOR zz% = y1% TO d% STEP zzstep%
               IF z$ = "." THEN buf%(z%, zz%) = buf%(z%, zz%) + 1
               IF z$ = ">" THEN buf%(z%, zz%) = (buf%(z%, zz%) + 16) AND 255
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
         asksave% = 1
      END IF
      IF z$ = "/" THEN
         FOR z% = x1% TO x2%
            FOR zz% = y1% TO y2%
               IF z% < xdim& \ 2 AND zz% < ydim& \ 2 THEN
                  band% = buf3%(z% * 2 + 0, zz% * 2 + 0) \ 32
                  dat% = 0: numdat% = 0
                  IF buf3%(z% * 2, zz% * 2) \ 32 = band% THEN dat% = dat% + buf3%(z% * 2, zz% * 2): numdat% = numdat% + 1
                  IF buf3%(z% * 2, zz% * 2 + 1) \ 32 = band% THEN dat% = dat% + buf3%(z% * 2, zz% * 2 + 1): numdat% = numdat% + 1
                  IF buf3%(z% * 2 + 1, zz% * 2) \ 32 = band% THEN dat% = dat% + buf3%(z% * 2 + 1, zz% * 2): numdat% = numdat% + 1
                  IF buf3%(z% * 2 + 1, zz% * 2 + 1) \ 32 = band% THEN dat% = dat% + buf3%(z% * 2 + 1, zz% * 2 + 1): numdat% = numdat% + 1
                  buf3%(z%, zz%) = dat% \ numdat%
               END IF
            NEXT zz%
         NEXT z%
         x2% = x2% \ 2: y2% = y2% \ 2
      END IF
      IF z$ = "*" THEN
         x2% = x2% * 2 + 1: y2% = y2% * 2 + 1
         FOR z% = x2% TO x1% STEP -1
            FOR zz% = y2% TO y1% STEP -1
               IF z% < xdim& AND zz% < ydim& THEN buf3%(z%, zz%) = buf3%(z% \ 2, zz% \ 2)
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "3" THEN
         asksave% = 1
         FOR z% = 0 TO x2%
            FOR zz% = 0 TO y2%
               IF z% + c% >= 0 AND z% + c% < xdim& AND zz% + d% >= 0 AND zz% + d% < ydim& THEN
                  IF buf3%(z%, zz%) <> 255 THEN buf%(z% + c%, zz% + d%) = buf3%(z%, zz%)
               END IF
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "T" OR z$ = "t" THEN trailstatus% = 1 - trailstatus%: GOSUB printcol
      IF z$ = "`" THEN
         LOCATE 2, 26: INPUT "Wall?"; wall%
         IF wall% >= 0 AND wall% < maxwalls% THEN
            IF asksave% = 1 THEN GOSUB testsavewallchanges
            wallnum& = wall%
            GOSUB loadnewall
         ELSE
            SOUND 60, 1
         END IF
         LOCATE 2, 26: PRINT "            ";
      END IF
      IF z$ = CHR$(0) + CHR$(73) AND wallnum& > 0 THEN
         IF asksave% = 1 THEN GOSUB testsavewallchanges
         wallnum& = wallnum& - 1
         GOSUB loadnewall
      END IF
      IF z$ = CHR$(0) + CHR$(81) AND wallnum& < maxwalls% - 1 THEN
         IF asksave% = 1 THEN GOSUB testsavewallchanges
         wallnum& = wallnum& + 1
         GOSUB loadnewall
      END IF
      IF (mousx% <> 0 OR mousy% <> 0) AND bstatus% > 0 THEN
         newc% = c% + mousx%
         newd% = d% + mousy%
         IF newc% < 0 THEN newc% = 0
         IF newc% > xdim& - 1 THEN newc% = xdim& - 1
         IF newd% < 0 THEN newd% = 0
         IF newd% > ydim& - 1 THEN newd% = ydim& - 1
         FOR zx% = 0 TO 32
            z% = (c% * zx% + newc% * (32 - zx%)) \ 32
            zz% = (d% * zx% + newd% * (32 - zx%)) \ 32
            buf%(z%, zz%) = col%
            LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
         NEXT zx%
         asksave% = 1
      END IF
      c% = c% + mousx%: mousx% = 0
      d% = d% + mousy%: mousy% = 0
      IF c% < 0 THEN c% = 0
      IF c% > xdim& - 1 THEN c% = xdim& - 1
      IF d% < 0 THEN d% = 0
      IF d% > ydim& - 1 THEN d% = ydim& - 1
      IF z$ = CHR$(8) THEN GOSUB clearcol: col% = 255: GOSUB printcol
      IF z$ = " " THEN buf%(c%, d%) = col%: asksave% = 1
      IF z$ = "A" THEN GOSUB addwall
      IF z$ = "U" THEN GOSUB updatewall
      IF z$ = CHR$(0) + CHR$(18) THEN                  'Ctrl-E
         OPEN updat$ + ".bmp" FOR BINARY AS #3
         buf$ = STRING$(3, 0)
         GET #3, , buf$
         IF MID$(buf$, 3, 1) = "6" THEN
            snot% = 1
            filoffs& = ASC(MID$(buf$, 3, 1)) + 1024 + 1
            buf$ = STRING$(ASC(MID$(buf$, 3, 1)) - 3, 0): GET #3, , buf$
            buf$ = ""
            OUT &H3C7, 0
            FOR z% = 0 TO 255
               c3% = INP(&H3C9) * 4
               c2% = INP(&H3C9) * 4
               c1% = INP(&H3C9) * 4
               buf$ = buf$ + CHR$(c1%) + CHR$(c2%) + CHR$(c3%) + CHR$(0)
            NEXT z%
            PUT #3, , buf$
         ELSE
            snot% = 0
            filoffs& = 26 + 768 + 1
            buf$ = STRING$(23, 0): GET #3, , buf$
            buf$ = ""
            OUT &H3C7, 0
            FOR z% = 0 TO 255
               c1% = INP(&H3C9) * 4
               c2% = INP(&H3C9) * 4
               c3% = INP(&H3C9) * 4
               buf$ = buf$ + CHR$(c1%) + CHR$(c2%) + CHR$(c3%)
            NEXT z%
            PUT #3, , buf$
         END IF
         FOR zz& = updateplcy% TO updateplcy% + ydim& - 1
            SEEK #3, (199& - zz&) * 320& + updateplcx% + filoffs&
            z$ = ""
            FOR z& = updateplcx% TO updateplcx% + xdim& - 1
               z$ = z$ + CHR$(buf%(z& - updateplcx%, zz& - updateplcy%))
            NEXT z&
            PUT #3, , z$
         NEXT zz&
         CLOSE #3
         SOUND 262, 1
      END IF
      IF z$ = "V" THEN GOSUB showallwalls
      IF z$ = "M" THEN
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf3%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "P" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf%(z%, zz%) = buf3%(z%, zz%)
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "C" THEN
         asksave% = 1
         chanfromcol% = buf%(c%, d%)
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               IF buf%(z%, zz%) = chanfromcol% THEN
                  buf%(z%, zz%) = col%
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), col%, BF
               END IF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "J" THEN
         asksave% = 1
         col1% = buf%(c%, d%)
         col2% = col%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               IF buf%(z%, zz%) = col1% THEN
                  IF INT(10 * RND) = 0 THEN buf%(z%, zz%) = col2%
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               END IF
            NEXT zz%
         NEXT z%
         SOUND 262, .1
      END IF
      IF z$ = "F" THEN
         asksave% = 1
         LINE (xdim& * scale%, 0)-(xdim& * scale%, ydim& * scale%), col%
         LINE (0, ydim& * scale%)-(xdim& * scale%, ydim& * scale%), col%
         PAINT (c% * scale%, d% * scale%), col%, col%
         LINE (xdim& * scale%, 0)-(xdim& * scale%, ydim& * scale%), 0
         LINE (0, ydim& * scale%)-(xdim& * scale%, ydim& * scale%), 0
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf%(z%, zz%) = POINT(z% * scale%, zz% * scale%)
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = ";" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               FOR zx% = 1 TO 1
                  x% = INT(3 * RND)
                  y% = INT(3 * RND)
                  IF ABS(x% + y%) > 1 THEN
                     x% = INT(3 * RND)
                     y% = INT(3 * RND)
                  END IF
                  dat% = buf2%((x% + z% + xdim& - 1) MOD xdim&, (y% + zz% + ydim& - 1) MOD ydim&)
                  IF (dat% AND &HE0) <> band% THEN
                     IF (buf%(z%, zz%) AND 31) < (dat% AND 31) - 1 THEN buf%(z%, zz%) = buf%(z%, zz%) + 1
                     IF (buf%(z%, zz%) AND 31) > (dat% AND 31) + 1 THEN buf%(z%, zz%) = buf%(z%, zz%) - 1
                  END IF
               NEXT zx%
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "]" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               snot% = 0
               totzx% = 0
               FOR zx% = 1 TO 16
                  x% = INT(3 * RND)
                  y% = INT(3 * RND)
                  IF ABS(x% + y%) > 1 THEN
                     x% = INT(3 * RND)
                     y% = INT(3 * RND)
                  END IF
                  avg% = buf2%((x% + z% + xdim& - 1) MOD xdim&, (y% + zz% + ydim& - 1) MOD ydim&)
                  IF (avg% AND &HE0) = band% THEN
                     snot% = snot% + avg%
                     totzx% = totzx% + 1
                  END IF
               NEXT zx%
               IF totzx% > 0 THEN buf%(z%, zz%) = snot% \ totzx%
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "[" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               snot% = 0
               totzx% = 0
               FOR zx% = 1 TO 6
                  x% = INT(3 * RND)
                  y% = INT(3 * RND)
                  IF ABS(x% + y%) > 1 THEN
                     x% = INT(3 * RND)
                     y% = INT(3 * RND)
                  END IF
                  avg% = buf2%((x% + z% + xdim& - 1) MOD xdim&, (y% + zz% + ydim& - 1) MOD ydim&)
                  IF (avg% AND &HE0) = band% THEN
                     snot% = snot% + (avg% AND 31) * (avg% AND 31)
                     totzx% = totzx% + 1
                  END IF
               NEXT zx%
               IF totzx% > 0 THEN
                  snot% = SQR(snot% \ totzx%)
                  buf%(z%, zz%) = (buf%(z%, zz%) AND &HE0) + (snot% AND 31)
                  LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
               END IF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "}" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               colband% = buf%(z%, zz%) AND 31
               FOR zx% = 1 TO 2
                  x% = INT(3 * RND) - 1
                  y% = INT(3 * RND) - 1
                  IF ABS(x% + y%) > 1 THEN
                     x% = INT(3 * RND)
                     y% = INT(3 * RND)
                  END IF
                  datzx% = buf2%((x% + z% + 256) MOD xdim&, (y% + zz% + 256) MOD ydim&)
                  IF (datzx% AND &HE0) <> band% THEN
                     IF x% + y% > 0 AND colband% > 0 THEN colband% = colband% - 1
                     IF x% + y% < 0 AND colband% < 15 THEN colband% = colband% + 1
                  END IF
               NEXT zx%
               buf%(z%, zz%) = (buf%(z%, zz%) AND &HE0) OR (colband% AND 31)
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "=" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               colband% = buf%(z%, zz%) AND 31
               FOR zx% = 0 TO 3
                  IF zx% = 0 THEN x% = -1: y% = 0
                  IF zx% = 1 THEN x% = 1: y% = 0
                  IF zx% = 2 THEN x% = 0: y% = -1
                  IF zx% = 3 THEN x% = 0: y% = 1
                  datzx% = buf2%((x% + z% + 256) MOD xdim&, (y% + zz% + 256) MOD ydim&)
                  IF (datzx% AND &HE0) <> band% THEN
                     IF x% + y% > 0 AND colband% > 0 THEN colband% = colband% - 1
                     IF x% + y% < 0 AND colband% < 15 THEN colband% = colband% + 1
                  END IF
               NEXT zx%
               buf%(z%, zz%) = (buf%(z%, zz%) AND &HE0) OR (colband% AND 31)
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "?" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               colband% = buf%(z%, zz%) AND 31
               FOR zx% = 1 TO 2
                  x% = INT(3 * RND) - 1
                  y% = INT(3 * RND) - 1
                  IF ABS(x% + y%) > 1 THEN
                     x% = INT(3 * RND)
                     y% = INT(3 * RND)
                  END IF
                  datzx% = buf2%((x% + z% + 256) MOD xdim&, (y% + zz% + 256) MOD ydim&)
                  IF (datzx% AND &HE0) <> band% AND (datzx% AND &HE0) = (col% AND &HE0) THEN
                     IF x% + y% > 0 AND colband% > 0 THEN colband% = colband% - 1
                     IF x% + y% < 0 AND colband% < 15 THEN colband% = colband% + 1
                  END IF
               NEXT zx%
               buf%(z%, zz%) = (buf%(z%, zz%) AND &HE0) OR (colband% AND 31)
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "{" THEN
         asksave% = 1
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               buf2%(z%, zz%) = buf%(z%, zz%)
            NEXT zz%
         NEXT z%
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               band% = buf2%(z%, zz%) AND &HE0
               FOR zx% = 1 TO 2
                  x% = INT(5 * RND) - 1
                  y% = INT(5 * RND) - 1
                  IF ABS(x% + y%) > 3 THEN
                     x% = INT(5 * RND)
                     y% = INT(5 * RND)
                  END IF
                  IF ABS(x% + y%) > 1 THEN
                     x% = INT(5 * RND)
                     y% = INT(5 * RND)
                  END IF
                  datzx% = buf2%((x% + z% + 256) MOD xdim&, (y% + zz% + 256) MOD ydim&)
                  IF (datzx% AND &HE0) = band% THEN
                     IF (datzx% AND 31) < (buf2%(z%, zz%) AND 31) AND (buf%(z%, zz%) AND 31) > 0 THEN buf%(z%, zz%) = buf%(z%, zz%) - 1
                     IF (datzx% AND 31) > (buf2%(z%, zz%) AND 31) AND (buf%(z%, zz%) AND 31) < 15 THEN buf%(z%, zz%) = buf%(z%, zz%) + 1
                  END IF
               NEXT zx%
               LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = CHR$(9) THEN GOSUB clearcol: col% = buf%(c%, d%): GOSUB printcol
      IF z$ = "+" THEN
          GOSUB clearcol: col% = buf%(c%, d%)
          IF (col% AND 31) < 31 THEN col% = col% + 1 ELSE SOUND 37, 2
          GOSUB printcol
          buf%(c%, d%) = col%
          LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
          asksave% = 1
      END IF
      IF z$ = "-" THEN
          GOSUB clearcol: col% = buf%(c%, d%)
          IF (col% AND 31) > 0 THEN col% = col% - 1 ELSE SOUND 37, 2
          GOSUB printcol
          buf%(c%, d%) = col%
          LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
          asksave% = 1
      END IF
   LOOP WHILE z$ <> CHR$(27) AND z$ <> CHR$(13)
   IF asksave% = 1 THEN GOSUB testsavewallchanges
RETURN

mouse:
   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   mousx% = mousx% + regs%(2) \ 2: mousy% = mousy% + regs%(3) \ 2
   regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
   bstatus% = regs%(0)
RETURN

clearcol:
   LOCATE 20, 30: PRINT "TRAIL ";
   IF trailstatus% = 0 THEN PRINT "OFF";  ELSE PRINT "ON ";
   x% = 203 + (col% \ 16) * 3
   y% = 75 + (col% AND 15) * 3
   PSET (x% + 1, y% + 1), col%
RETURN

printcol:
   LOCATE 1, 26: PRINT col%; "    ";
   LOCATE 20, 30: PRINT "TRAIL ";
   IF trailstatus% = 0 THEN PRINT "OFF";  ELSE PRINT "ON ";
   x% = 203 + (col% \ 16) * 3
   y% = 75 + (col% AND 15) * 3
   PSET (x% + 1, y% + 1), (col% AND &HE0) + (15 - (col% AND &HF))
RETURN

setupcolors:
   OPEN "palette.dat" FOR BINARY AS #3
   pal$ = STRING$(768, 0)
   GET #3, , pal$
   OUT &H3C8, 0
   FOR z% = 0 TO 767
      pal%(z%) = ASC(MID$(pal$, z% + 1, 1))
      OUT &H3C9, pal%(z%)
   NEXT z%
   CLOSE #3
   FOR z% = 0 TO 15
      FOR zz% = 0 TO 15
         LINE (z% * 3 + 203, zz% * 3 + 75)-(z% * 3 + 205, zz% * 3 + 77), z% * 16 + zz%, BF
      NEXT zz%
   NEXT z%
RETURN
  
testsavewallchanges:
   IF walsiz%(wallnum&) = 0 THEN RETURN
   anywallstatchg% = 1
   LOCATE 25, 1: PRINT "Save changes?";
   zx$ = INPUT$(1)
   IF zx$ = "y" OR zx$ = "Y" THEN
      buf$ = ""
      xdim& = 2 ^ (walsiz%(wallnum&) AND 15)
      ydim& = 2 ^ (walsiz%(wallnum&) \ 16)
      buf$ = STRING$(xdim& * ydim&, 0)
      DEF SEG = VARSEG(buf$)
      offs& = SADD(buf$)
      FOR z% = 0 TO xdim& - 1
         FOR zz% = 0 TO ydim& - 1
            POKE offs&, buf%(z%, zz%)
            offs& = offs& + 1
         NEXT zz%
      NEXT z%
      totsiz& = 0
      FOR z% = 0 TO wallnum& - 1
         IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
      NEXT z%
      SEEK #1, totsiz& + maxwalls% * 2 + 1
      PUT #1, , buf$
   END IF
   LOCATE 25, 1: PRINT "             ";
   asksave% = 0
RETURN

loadnewall:
   LOCATE 22, 29
   SELECT CASE (walanm%(wallnum&) AND 192)
      CASE 0: PRINT "NoAnm:";
      CASE 64: PRINT "Oscil:";
      CASE 128: PRINT "AnmFD:";
      CASE 192: PRINT "AnmBK:";
   END SELECT
   PRINT (walanm%(wallnum&) AND 63); " ";
   LOCATE 23, 30: PRINT 2 ^ (walsiz%(wallnum&) AND 15); "*"; 2 ^ (walsiz%(wallnum&) \ 16); "  ";
   LOCATE 24, 30: PRINT "Sprite"; wallnum&;
   scale% = 3
   IF walsiz%(wallnum&) = 0 THEN scale% = 0
   LINE (0, 0)-(191, 191), 0, BF
   IF walsiz%(wallnum&) = 0 THEN RETURN
   totsiz& = 0
   FOR z% = 0 TO wallnum& - 1
      IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
   xdim& = 2 ^ (walsiz%(wallnum&) AND 15)
   ydim& = 2 ^ (walsiz%(wallnum&) \ 16)
   IF xdim& > 64 OR ydim& > 64 THEN scale% = 1
   buf$ = STRING$(xdim& * ydim&, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO xdim& - 1
      FOR zz% = 0 TO ydim& - 1
         buf%(z%, zz%) = PEEK(offs&): offs& = offs& + 1
         LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
      NEXT zz%
   NEXT z%
   asksave% = 0
   IF c% >= xdim& THEN c% = xdim& - 1
   IF d% >= ydim& THEN d% = ydim& - 1
RETURN

loadnewall2:
   IF walsiz%(wallnumber&) = 0 THEN RETURN
   FOR z% = 0 TO wallnumber& - 1
      IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
   xdim& = 2 ^ (walsiz%(wallnumber&) AND 15)
   ydim& = 2 ^ (walsiz%(wallnumber&) \ 16)
   buf$ = STRING$(xdim& * ydim&, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO xdim& - 1
      FOR zz% = 0 TO ydim& - 1
         buf2%(z%, zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
RETURN

showallwalls:
   picsbuf$ = STRING$(16384, 0)
   IF asksave% = 1 THEN GOSUB testsavewallchanges
   regs%(0) = &H38: CALL int86old(&H10, regs%(), regs%())
   DEF SEG = &HA000
   GOSUB setupcolors
   tempwall& = wallnum&
  
   place& = (tempwall& \ 192) * 768
   OUT &H3D4, &H33: OUT &H3D5, place& \ 256
   OUT &H3D4, &HC: OUT &H3D5, place& AND 255
   FOR z% = (place& \ 4) TO (place& \ 4) + 191
      walnume& = z%
      GOSUB showall
   NEXT z%
  
   DO
      startp& = (tempwall& AND 15) * 64&
      startpag% = ((tempwall& \ 16) AND 15)
      OUT &H3CD, startpag%
      CALL hlin(startp&, 63, 31)
      CALL hlin(startp& + 1024, 63, 31)
      CALL hlin(startp& + 65536 - 1024, 63, 31)
      CALL hlin(startp& + 65536 - 2048, 63, 31)
      CALL vlin(startp&, startpag%, 63, 31)
      CALL vlin(startp& + 1, startpag%, 63, 31)
      CALL vlin(startp& + 62, startpag%, 63, 31)
      CALL vlin(startp& + 63, startpag%, 63, 31)
     
      DO
         z$ = INKEY$
         regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
         mousx% = regs%(2) \ 2
         mousy% = regs%(3) \ 2
         regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
         obstatus% = bstatus%: bstatus% = regs%(0)
            
         OUT &H3C8, 255
         WAIT &H3DA, 8
         OUT &H3C9, palval%: OUT &H3C9, palval%: OUT &H3C9, palval%
         palval% = (palval% + 1) MOD 63
      LOOP WHILE z$ = "" AND mousx% = 0 AND mousy% = 0 AND obstatus% = bstatus%
               
      startp& = (tempwall& AND 15) * 64&
      startpag% = ((tempwall& \ 16) AND 15)
      OUT &H3CD, startpag%
      CALL hlin(startp&, 63, 0)
      CALL hlin(startp& + 1024, 63, 0)
      CALL hlin(startp& + 65536 - 1024, 63, 0)
      CALL hlin(startp& + 65536 - 2048, 63, 0)
      CALL vlin(startp&, startpag%, 63, 0)
      CALL vlin(startp& + 1, startpag%, 63, 0)
      CALL vlin(startp& + 62, startpag%, 63, 0)
      CALL vlin(startp& + 63, startpag%, 63, 0)
              
      walnume& = tempwall&: GOSUB showall
     
      IF (z$ = CHR$(0) + CHR$(75) OR mousx% < 0) AND (tempwall& AND 15) > 0 THEN tempwall& = tempwall& - 1
      IF (z$ = CHR$(0) + CHR$(77) OR mousx% > 0) AND (tempwall& AND 15) < 15 THEN tempwall& = tempwall& + 1
      IF (z$ = CHR$(0) + CHR$(72) OR mousy% < 0) AND tempwall& >= 16 THEN
         tempwall& = tempwall& - 16
         IF tempwall& < (place& \ 4) THEN
            place& = place& - 64
            OUT &H3D4, &H33: OUT &H3D5, place& \ 256
            OUT &H3D4, &HC: OUT &H3D5, place& AND 255
          
            OUT &H3CD, (((place& \ 4) \ 16) AND 15)
            startp& = 0
            FOR zx& = 0 TO 63
               CALL hlin(startp&, 1024, 0)
               startp& = startp& + 1024&
            NEXT zx&
           
            FOR zxjunk% = 0 TO 15
               walnume& = zxjunk% + (place& \ 4)
               GOSUB showall
            NEXT zxjunk%
         END IF
      END IF
      IF (z$ = CHR$(0) + CHR$(80) OR mousy% > 0) AND tempwall& < maxwalls% - 16 THEN
         tempwall& = tempwall& + 16
         IF tempwall& > (place& \ 4) + 192 THEN
            place& = place& + 64
            OUT &H3D4, &H33: OUT &H3D5, place& \ 256
            OUT &H3D4, &HC: OUT &H3D5, place& AND 255
           
            OUT &H3CD, (((176 + place& \ 4) \ 16) AND 15)
            startp& = 0
            FOR zx& = 0 TO 63
               CALL hlin(startp&, 1024, 0)
               startp& = startp& + 1024&
            NEXT zx&
           
            FOR zxjunk% = 176 TO 191
               walnume& = zxjunk% + (place& \ 4)
               GOSUB showall
            NEXT zxjunk%
         END IF
      END IF
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27) AND (bstatus% AND 1) >= (obstatus% AND 1)
   IF z$ = CHR$(13) THEN wallnum& = tempwall&
   z$ = ""
   picsbuf$ = ""
   regs%(0) = &H13: CALL int86old(&H10, regs%(), regs%())
   DEF SEG = &HA000
   GOSUB setupcolors
   GOSUB loadnewall
   GOSUB printcol
RETURN

showall:
   IF walsiz%(walnume&) = 0 THEN RETURN
   totsiz& = 0
   FOR z% = 0 TO walnume& - 1
      IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
   xdim& = 2 ^ (walsiz%(walnume&) AND 15)
   ydim& = 2 ^ (walsiz%(walnume&) \ 16)
   GET #1, , picsbuf$
  
   startp& = (walnume& AND 15) * 64&
   OUT &H3CD, ((walnume& \ 16) AND 15)
   xdim& = pow2&(walsiz%(walnume&) AND 15)
   ydim& = pow2&(walsiz%(walnume&) \ 16)
   IF xdim& <= 64 AND ydim& <= 64 THEN
      stp% = 1: stpadd& = ydim& * 2&
   ELSE
      stp% = 2: stpadd& = ydim& * 4&: xdim& = xdim& \ 2
   END IF
   tempseg& = VARSEG(picsbuf$)
   offs& = SADD(picsbuf$)
   FOR zx& = startp& TO startp& + xdim& - 1 STEP 2
      CALL vline2(zx&, ydim&, tempseg&, offs&, stp%, shadeoffs%)
      offs& = offs& + stpadd&
   NEXT zx&
RETURN

addwall:
   LOCATE 25, 1: PRINT "What wall file"; : INPUT zx$
   OPEN zx$ FOR BINARY AS #3
   SEEK #3, 1
   buf$ = STRING$(maxwalls%, 0)
   GET #3, , buf$
   FOR z% = 0 TO maxwalls% - 1
      walsiz2%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
   LOCATE 25, 1: PRINT STRING$(40, 32);
   LOCATE 25, 1: PRINT "What wall number"; : INPUT zx&
   IF zx& > 0 THEN
      totsiz& = 0
      FOR z% = 0 TO zx& - 1
         IF walsiz2%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz2%(z%) AND 15) + (walsiz2%(z%) \ 16))
      NEXT z%
      SEEK #3, totsiz& + maxwalls% * 2 + 1
   END IF
   buf$ = STRING$(4096, 0)
   GET #3, , buf$
   CLOSE #3
   CLS
   GOSUB setupcolors
   GOSUB printcol
   xd& = 2 ^ (walsiz2%(zx&) AND 15)
   yd& = 2 ^ (walsiz2%(zx&) \ 16)
   FOR z% = 0 TO xd& - 1
      FOR zz% = 0 TO yd& - 1
         buf%(z%, zz%) = ASC(MID$(buf$, zz% + yd& * z% + 1, 1))
         LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
      NEXT zz%
   NEXT z%
   asksave% = 1
RETURN

updatewall:
   LOCATE 25, 1: PRINT "Filename: "; updat$;
   INPUT z$
   IF z$ <> "" THEN updat$ = z$
   IF INSTR(UCASE$(updat$), ".BMP") > 0 THEN
      OPEN updat$ FOR BINARY AS #3
      buf$ = STRING$(3, 0)
      GET #3, , buf$
      IF MID$(buf$, 3, 1) = "6" THEN
         snot% = 1
         buf$ = STRING$(ASC(MID$(buf$, 3, 1)) - 3, 0): GET #3, , buf$
         buf$ = STRING$(1024, 0): GET #3, , buf$
         FOR z% = 0 TO 255
            buf4%(z% * 3 + 0) = ASC(MID$(buf$, z% * 4 + 3, 1)) \ 4
            buf4%(z% * 3 + 1) = ASC(MID$(buf$, z% * 4 + 2, 1)) \ 4
            buf4%(z% * 3 + 2) = ASC(MID$(buf$, z% * 4 + 1, 1)) \ 4
         NEXT z%
         OUT &H3C8, 0
         FOR z% = 0 TO 767
            OUT &H3C9, buf4%(z%)
         NEXT z%
        
         totintens1% = 0
         totintens2% = 0
         FOR z% = 0 TO 767
            totintens1% = totintens1% + pal%(z%)
            totintens2% = totintens2% + buf4%(z%)
         NEXT z%
         brichang% = (totintens1% - totintens2%) \ 768
         FOR z% = 0 TO 767 STEP 3
            c1% = buf4%(z%) + brichang%
            c2% = buf4%(z% + 1) + brichang%
            c3% = buf4%(z% + 2) + brichang%
            bestcol% = 0
            dadist% = 1024
            FOR zz% = 0 TO 767 STEP 3
               zx% = (c1% - pal%(zz%)) * (c1% - pal%(zz%)) + (c2% - pal%(zz% + 1)) * (c2% - pal%(zz% + 1)) + (c3% - pal%(zz% + 2)) * (c3% - pal%(zz% + 2))
               IF zx% < dadist% THEN dadist% = zx%: bestcol% = zz% \ 3
            NEXT zz%
            palookup%(z% \ 3) = bestcol%
         NEXT z%
      ELSE
         snot% = 0
         buf$ = STRING$(23, 0): GET #3, , buf$
         buf$ = STRING$(768, 0): GET #3, , buf$
         OUT &H3C8, 0
         FOR z% = 0 TO 255
            c1% = ASC(MID$(buf$, z% * 3 + 1, 1)) \ 4
            c2% = ASC(MID$(buf$, z% * 3 + 2, 1)) \ 4
            c3% = ASC(MID$(buf$, z% * 3 + 3, 1)) \ 4
            OUT &H3C9, c3%
            OUT &H3C9, c2%
            OUT &H3C9, c1%
         NEXT z%
         FOR z% = 0 TO 255
            palookup%(z%) = z%
         NEXT z%
      END IF
      FOR zz& = 199 TO 0 STEP -1
         buf$ = STRING$(320, 0)
         GET #3, , buf$
         DEF SEG = VARSEG(buf$)
         offs& = SADD(buf$)
         FOR z% = 0 TO 319
            buf4%(z%) = PEEK(offs& + z%)
         NEXT z%
         DEF SEG = &HA000
         p& = zz& * 320
         FOR z& = 0 TO 319
            POKE p& + z&, buf4%(z&)
         NEXT z&
      NEXT zz&
      CLOSE #3
   ELSE
      GOSUB readpcx
      totintens1% = 0
      totintens2% = 0
      FOR z% = 0 TO 767
         totintens1% = totintens1% + pal%(z%)
         totintens2% = totintens2% + buf4%(z%)
      NEXT z%
      brichang% = (totintens1% - totintens2%) \ 768
      FOR z% = 0 TO 767 STEP 3
         c1% = buf4%(z%) + brichang%
         c2% = buf4%(z% + 1) + brichang%
         c3% = buf4%(z% + 2) + brichang%
         bestcol% = 0
         dadist% = 1024
         FOR zz% = 0 TO 767 STEP 3
            zx% = (c1% - pal%(zz%)) * (c1% - pal%(zz%)) + (c2% - pal%(zz% + 1)) * (c2% - pal%(zz% + 1)) + (c3% - pal%(zz% + 2)) * (c3% - pal%(zz% + 2))
            IF zx% < dadist% THEN dadist% = zx%: bestcol% = zz% \ 3
         NEXT zz%
         palookup%(z% \ 3) = bestcol%
      NEXT z%
   END IF
   xorval% = 255
   FOR z% = 0 TO xdim& - 1
      PSET (x% + z%, y%), POINT(x% + z%, y%) XOR xorval%
      PSET (x% + z%, y% + ydim& - 1), POINT(x% + z%, y% + ydim& - 1) XOR xorval%
   NEXT z%
   FOR z% = 0 TO ydim& - 1
      PSET (x%, y% + z%), POINT(x%, y% + z%) XOR xorval%
      PSET (x% + xdim& - 1, y% + z%), POINT(x% + xdim& - 1, y% + z%) XOR xorval%
   NEXT z%
   DO
      z$ = INKEY$
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      IF regs%(2) <> 0 AND regs%(3) <> 0 OR LEN(z$) = 2 THEN
         FOR z% = 0 TO xdim& - 1
            PSET (x% + z%, y%), POINT(x% + z%, y%) XOR xorval%
            PSET (x% + z%, y% + ydim& - 1), POINT(x% + z%, y% + ydim& - 1) XOR xorval%
         NEXT z%
         FOR z% = 0 TO ydim& - 1
            PSET (x%, y% + z%), POINT(x%, y% + z%) XOR xorval%
            PSET (x% + xdim& - 1, y% + z%), POINT(x% + xdim& - 1, y% + z%) XOR xorval%
         NEXT z%
         xorval% = 255
         x% = x% + regs%(2) \ 2
         y% = y% + regs%(3) \ 2
         IF z$ = CHR$(0) + CHR$(75) THEN x% = x% - 1
         IF z$ = CHR$(0) + CHR$(77) THEN x% = x% + 1
         IF z$ = CHR$(0) + CHR$(72) THEN y% = y% - 1
         IF z$ = CHR$(0) + CHR$(80) THEN y% = y% + 1
         IF x% < 0 THEN x% = 0
         IF y% < 0 THEN y% = 0
         IF x% > 320 - xdim& THEN x% = 320 - xdim&
         IF y% > 200 - ydim& THEN y% = 200 - ydim&
         FOR z% = 0 TO xdim& - 1
            PSET (x% + z%, y%), POINT(x% + z%, y%) XOR xorval%
            PSET (x% + z%, y% + ydim& - 1), POINT(x% + z%, y% + ydim& - 1) XOR xorval%
         NEXT z%
         FOR z% = 0 TO ydim& - 1
            PSET (x%, y% + z%), POINT(x%, y% + z%) XOR xorval%
            PSET (x% + xdim& - 1, y% + z%), POINT(x% + xdim& - 1, y% + z%) XOR xorval%
         NEXT z%
      END IF
      IF z$ = "P" OR z$ = "p" THEN
         pal$ = ""
         OUT &H3C7, 0
         FOR z% = 0 TO 767
            dat% = INP(&H3C9)
            pal$ = pal$ + CHR$(dat%)
            pal%(z%) = dat%
         NEXT z%
         OPEN "palette.dat" FOR BINARY AS #3
         SEEK #3, 1
         PUT #3, , pal$
         CLOSE #3
         FOR z% = 0 TO 255
            palookup%(z%) = z%
         NEXT z%
         SOUND 523, 1
      END IF
      regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27) AND regs%(0) = 0
   z$ = ""
   FOR z% = 0 TO xdim& - 1
      PSET (x% + z%, y%), POINT(x% + z%, y%) XOR xorval%
      PSET (x% + z%, y% + ydim& - 1), POINT(x% + z%, y% + ydim& - 1) XOR xorval%
   NEXT z%
   FOR z% = 0 TO ydim& - 1
      PSET (x%, y% + z%), POINT(x%, y% + z%) XOR xorval%
      PSET (x% + xdim& - 1, y% + z%), POINT(x% + xdim& - 1, y% + z%) XOR xorval%
   NEXT z%
   updateplcx% = x%
   updateplcy% = y%
   FOR z% = 0 TO xdim& - 1
      FOR zz% = 0 TO ydim& - 1
         buf%(z%, zz%) = palookup%(POINT(x% + z%, y% + zz%))
      NEXT zz%
   NEXT z%
   CLS
   GOSUB setupcolors
   GOSUB printcol
   FOR z% = 0 TO xdim& - 1
      FOR zz% = 0 TO ydim& - 1
         LINE (z% * scale%, zz% * scale%)-(z% * scale% + scale% - 1, zz% * scale% + scale% - 1), buf%(z%, zz%), BF
      NEXT zz%
   NEXT z%
   asksave% = 1
RETURN

readpcx:
   DIM hasmprog%(15)
   DEF SEG = VARSEG(hasmprog%(0)): asmp& = VARPTR(hasmprog%(0))
   POKE asmp& + 0, &H55
   POKE asmp& + 1, &H8B: POKE asmp& + 2, &HEC
   POKE asmp& + 3, &HB8: POKE asmp& + 4, &H0: POKE asmp& + 5, &HA0
   POKE asmp& + 6, &H8E: POKE asmp& + 7, &HC0
   POKE asmp& + 8, &HB9 ' '
   POKE asmp& + 11, &HBF ' '
   POKE asmp& + 14, &HB8 ' '
   POKE asmp& + 17, &HD1: POKE asmp& + 18, &HE9
   POKE asmp& + 19, &HF3: POKE asmp& + 20, &HAB
   POKE asmp& + 21, &HD1: POKE asmp& + 22, &HD1
   POKE asmp& + 23, &H83: POKE asmp& + 24, &HE1: POKE asmp& + 25, &H1
   POKE asmp& + 26, &HF3: POKE asmp& + 27, &HAA
   POKE asmp& + 28, &H5D
   POKE asmp& + 29, &HCA: POKE asmp& + 30, &H2: POKE asmp& + 31, &H0
 
   OPEN updat$ FOR BINARY AS #3
   header$ = STRING$(128, 0): GET #3, , header$
   SCREEN 13: DEF SEG = &HA000
   IF LEFT$(header$, 2) <> CHR$(&HA) + CHR$(5) THEN
      PRINT "Not 256 color PCX file"
      RETURN
   END IF
   p& = 0
   dbuf$ = STRING$(16384, 0): GET #3, , dbuf$: datcnt% = 1
   WHILE p& < 64000
      dat% = ASC(MID$(dbuf$, datcnt%, 1)): datcnt% = datcnt% + 1: IF datcnt% = 16385 THEN GET #3, , dbuf$: datcnt% = 1
      IF datcnt% = 16385 THEN GET #3, , dbuf$: datcnt% = 1
      IF (dat% AND &HC0) = &HC0 THEN
         leng% = (dat% AND &H3F)
         dat% = ASC(MID$(dbuf$, datcnt%, 1)): datcnt% = datcnt% + 1: IF datcnt% = 16385 THEN GET #3, , dbuf$: datcnt% = 1
         DEF SEG = VARSEG(hasmprog%(0))
         POKE asmp& + 9, leng% AND 255: POKE asmp& + 10, leng% \ 256
         POKE asmp& + 12, p& AND 255: POKE asmp& + 13, p& \ 256
         POKE asmp& + 15, dat%: POKE asmp& + 16, dat%
         CALL ABSOLUTE(0, asmp&)
         p& = p& + leng%
      ELSE
         DEF SEG = &HA000
         POKE p&, dat%: p& = p& + 1
      END IF
   WEND
   dat% = ASC(MID$(dbuf$, datcnt%, 1)): datcnt% = datcnt% + 1: IF datcnt% = 16385 THEN GET #3, , dbuf$: datcnt% = 1
   IF dat% = &HC THEN
      OUT &H3C8, 0
      FOR z% = 0 TO 767
         dat% = ASC(MID$(dbuf$, datcnt%, 1)): datcnt% = datcnt% + 1: IF datcnt% = 16385 THEN GET #3, , dbuf$: datcnt% = 1
         buf4%(z%) = dat% \ 4
         OUT &H3C9, buf4%(z%)
      NEXT z%
   END IF
   CLOSE #3
   ERASE hasmprog%
RETURN

SUB hlin (start&, leng%, col%)
   DIM asmprog%(15)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B
   POKE p& + 2, &HEC
   POKE p& + 3, &HB8
   POKE p& + 4, &H0
   POKE p& + 5, &HA0
   POKE p& + 6, &H8E
   POKE p& + 7, &HC0
   POKE p& + 8, &HB9
   POKE p& + 9, leng% AND 255
   POKE p& + 10, leng% \ 256
   POKE p& + 11, &HBF
   POKE p& + 12, start& AND 255
   POKE p& + 13, start& \ 256
   POKE p& + 14, &HB8
   POKE p& + 15, col%
   POKE p& + 16, col%
   POKE p& + 17, &HD1
   POKE p& + 18, &HE9
   POKE p& + 19, &HF3
   POKE p& + 20, &HAB
   POKE p& + 21, &HD1
   POKE p& + 22, &HD1
   POKE p& + 23, &H83
   POKE p& + 24, &HE1
   POKE p& + 25, &H1
   POKE p& + 26, &HF3
   POKE p& + 27, &HAA
   POKE p& + 28, &H5D
   POKE p& + 29, &HCA
   POKE p& + 30, &H2
   POKE p& + 31, &H0
'DATA &H55              : 'PUSH BP
'DATA &H8B, &HEC        : 'MOV BP,SP
'DATA &HB8, &H00, &HA0  : 'MOV AX, &HA000
'DATA &H8E, &HC0        : 'MOV ES, AX
'DATA &HB9, &H?,  &H?   : 'MOV CX, LEN
'DATA &HBF, &H?,  &H?   : 'MOV DI, START
'DATA &HB8, &H?,  &H?   : 'MOV AX, COL
'DATA &HD1, &HE9        : 'SHR CX, 1
'DATA &HF3, &HAB        : 'REP STOSW
'DATA &HD1, &HD1        : 'RCL CX, 1
'DATA &H83, &HE1, &H01  : 'AND CX, 1
'DATA &HF3, &HAA        : 'REP STOSB
'DATA &H5D              : 'POP BP
'DATA &HCA, &H02, &H00  : 'RET 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
END SUB

SUB vlin (start&, startpag%, leng%, col%)
   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B
   POKE p& + 2, &HEC
   POKE p& + 3, &HB8
   POKE p& + 4, &H0
   POKE p& + 5, &HA0
   POKE p& + 6, &H8E
   POKE p& + 7, &HC0
   POKE p& + 8, &HBA
   POKE p& + 9, &HCD
   POKE p& + 10, &H3
   POKE p& + 11, &HB4
   POKE p& + 12, col%
   POKE p& + 13, &HB0
   POKE p& + 14, startpag%
   POKE p& + 15, &HEE
   POKE p& + 16, &HBF
   POKE p& + 17, start& AND 255
   POKE p& + 18, start& \ 256
   POKE p& + 19, &HB9
   POKE p& + 20, leng% AND 255
   POKE p& + 21, leng% \ 256
   POKE p& + 22, &H26
   POKE p& + 23, &H88
   POKE p& + 24, &H25
   POKE p& + 25, &H81
   POKE p& + 26, &HC7
   POKE p& + 27, &H0
   POKE p& + 28, &H4
   POKE p& + 29, &H72
   POKE p& + 30, &H7
   POKE p& + 31, &H83
   POKE p& + 32, &HE9
   POKE p& + 33, &H1
   POKE p& + 34, &H73
   POKE p& + 35, &HF2
   POKE p& + 36, &H72
   POKE p& + 37, &H8
   POKE p& + 38, &HFE
   POKE p& + 39, &HC0
   POKE p& + 40, &HEE
   POKE p& + 41, &H83
   POKE p& + 42, &HE9
   POKE p& + 43, &H1
   POKE p& + 44, &H73
   POKE p& + 45, &HE8
   POKE p& + 46, &H5D
   POKE p& + 47, &HCA
   POKE p& + 48, &H2
   POKE p& + 49, &H0
   CALL ABSOLUTE(0, p&)
   DEF SEG
  
'     55             push bp
'     8b ec          mov bp, sp
'     b8 00 a0       mov ax, 0xa000
'     8e c0          mov es, ax
'     ba cd 03       mov dx, 0x3cd
'     b4 ?           mov ah, 0x88        (col)
'     b0 ?           mov al, 0x88        (startpag)
'     ee             out dx, al
'     bf ?  ?        mov di, 0x8888      (start)
'     b9 ?  ?        mov cx, 0x8888      (leng)
'lab: 26 88 25       mov byte ptr es:[di], ah
'     81 c7 00 04    add di, 1024
'     72 07          jc skp
'     83 e9 01       sub cx, 1
'     73 f2          jnc lab
'     72 08          jc stp
'skp: fe c0          inc al
'     ee             out dx, al
'     83 e9 01       sub cx, 1
'     73 e8          jnc lab
'stp: 5d             pop bp
'     ca 02 00       ret 2

END SUB

SUB vline2 (x&, ydim&, segtemp&, offtemp&, stp%, shadeoffs%)
   DIM asmprog%(31)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B: POKE p& + 2, &HEC
   POKE p& + 3, &HB8: POKE p& + 4, &H0: POKE p& + 5, &HA0
   POKE p& + 6, &H8E: POKE p& + 7, &HC0
   POKE p& + 8, &HBF: POKE p& + 9, x& AND 255: POKE p& + 10, x& \ 256
   POKE p& + 11, &HB9: POKE p& + 12, (ydim& \ stp%) AND 255: POKE p& + 13, (ydim& \ stp%) \ 256
   POKE p& + 14, &HBB: POKE p& + 15, ydim AND 255: POKE p& + 16, ydim& \ 256
   POKE p& + 17, &HB8: POKE p& + 18, segtemp& AND 255: POKE p& + 19, segtemp& \ 256
   POKE p& + 20, &HBE: POKE p& + 21, offtemp& AND 255: POKE p& + 22, offtemp& \ 256
   POKE p& + 23, &H33: POKE p& + 24, &HD2
   POKE p& + 25, &H1E
   POKE p& + 26, &H8E: POKE p& + 27, &HD8
   POKE p& + 28, &H3E: POKE p& + 29, &H8A: POKE p& + 30, &H4
   POKE p& + 31, &H3E: POKE p& + 32, &H8A: POKE p& + 33, &H20
   POKE p& + 34, &H4: POKE p& + 35, shadeoffs%
   POKE p& + 36, &H80: POKE p& + 37, &HC4: POKE p& + 38, shadeoffs%
   POKE p& + 39, &H26: POKE p& + 40, &H89: POKE p& + 41, &H5
   POKE p& + 42, &H81: POKE p& + 43, &HC7: POKE p& + 44, &H0: POKE p& + 45, &H4
   POKE p& + 46, &H81: POKE p& + 47, &HC2: POKE p& + 48, 0: POKE p& + 49, 0
   POKE p& + 50, &H81: POKE p& + 51, &HD6: POKE p& + 52, stp%: POKE p& + 53, 0
   POKE p& + 54, &HE2: POKE p& + 55, &HE4
   POKE p& + 56, &H1F
   POKE p& + 57, &H5D
   POKE p& + 58, &HCA: POKE p& + 59, &H2: POKE p& + 60, &H0
   CALL ABSOLUTE(0, p&)
   DEF SEG

'      55             push bp
'      8b ec          mov bp, sp
'      b8 00 a0       mov ax, 0xa000
'      8e c0          mov es, ax
'      bf ?  ?        mov di, 0x8888   ;x position
'      b9 ?  ?        mov cx, 0x8888   ;leng
'      bb ?  ?        mov bx, 0x8888   ;ydim
'      b8 ?  ?        mov ax, 0x8888   ;seg tempbuf
'      be ?  ?        mov si, 0x8888   ;offset tempbuf
'      33 d2          xor dx, dx
'      1e             push ds
'      8e d8          mov ds, ax
' beg: 3e 8a 04       mov al, byte ptr ds:[si]
'      3e 8a 20       mov ah, byte ptr ds:[bx][si]
'      04 88          add al, 0x88
'      80 c4 88       add ah, 0x88
'      26 89 05       mov word ptr es:[di], ax
'      81 c7 00 04    add di, 1024
'      81 c2 ? ?      add dx, 0x8888   ;incr value
'      81 d6 ? 0      adc si, 0x88     ;step
'      e2 e4          loop beg
'      1f             pop ds
'      5d             pop bp
'      ca 02 00       ret 2

END SUB

