DECLARE SUB fill (x%, y%, col%)
DECLARE FUNCTION getpixel% (x%, y%)
DECLARE SUB drawpixel (x%, y%, col%)
DECLARE SUB fillscreen (startpag%, col%)
DIM SHARED pow2%(4), xfill%(256), yfill%(256)
SCREEN 13
DIM regs%(7), pal%(768), buf3%(64, 64)
pow2%(0) = 1: pow2%(1) = 2: pow2%(2) = 4: pow2%(3) = 8
regs%(0) = &H0: CALL int86old(&H33, regs%(), regs%())
OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) AND 247          'TRUST ME #1
OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) AND 191         'TRUST ME #2
OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) OR 64           'TRUST ME #3
OUT &H3CE, &H5: OUT &H3CF, 64                          'TRUST ME #4

OPEN "palette.dat" FOR BINARY AS #1
pal$ = STRING$(768, 0): GET #1, , pal$
OUT &H3C8, 0
FOR z% = 1 TO 768
   OUT &H3C9, ASC(MID$(pal$, z%, 1))
NEXT z%
CALL fillscreen(0, 32)
CALL fillscreen(1, 32)
GOSUB setupcolors
FOR z% = 0 TO 193
   CALL drawpixel(z%, 0, 30)
   CALL drawpixel(z%, 193, 30)
   CALL drawpixel(0, z%, 30)
   CALL drawpixel(193, z%, 30)
NEXT z%
DEF SEG = &HA000
col% = 32: CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, (col% AND &H1C0) + ((col% + 32) AND 63))
x% = 96: y% = 96: xdim& = 192: ydim& = 192
oldcol% = getpixel%(x% + 1, y% + 1)
CALL drawpixel(x% + 1, y% + 1, (oldcol% AND &H1C0) + ((oldcol% + 32) AND 63))
trail% = 0
DO
   DO
      regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
      bstatus% = regs%(0)
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      z$ = UCASE$(INKEY$)
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
      OUT &H3D4, &HC: OUT &H3D5, pag%: pag% = pag% XOR 64
   LOOP WHILE regs%(2) = 0 AND regs%(3) = 0 AND z$ = "" AND bstatus% = 0
   CALL drawpixel(x% + 1, y% + 1, oldcol%)
   IF (regs%(2) OR regs%(3)) <> 0 THEN
      IF bstatus% > 0 THEN
         x = x%: y = y%
         FOR zx = 0 TO 16
            x = x + (regs%(2) / 16)
            y = y + (regs%(3) / 16)
            x% = x: y% = y
            IF x% < 0 THEN x% = 0
            IF x% > 191 THEN x% = 191
            IF y% < 0 THEN y% = 0
            IF y% > 191 THEN y% = 191
            CALL drawpixel(x% + 1, y% + 1, col%)
         NEXT zx
       ELSE
          x% = x% + regs%(2)
          y% = y% + regs%(3)
       END IF
   END IF
   DEF SEG = 0
   IF (PEEK(&H417) AND 3) = 0 THEN
      IF z$ = CHR$(0) + CHR$(75) THEN x% = x% - 1
      IF z$ = CHR$(0) + CHR$(77) THEN x% = x% + 1
      IF z$ = CHR$(0) + CHR$(72) THEN y% = y% - 1
      IF z$ = CHR$(0) + CHR$(80) THEN y% = y% + 1
   ELSE
      CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, col%)
      IF z$ = CHR$(0) + CHR$(75) THEN col% = (col% + 448) AND 511
      IF z$ = CHR$(0) + CHR$(77) THEN col% = (col% + 64) AND 511
      IF z$ = CHR$(0) + CHR$(72) THEN col% = (col% + 511) AND 511: IF (col% AND 63) = 63 THEN col% = (col% + 511) AND 511
      IF z$ = CHR$(0) + CHR$(80) THEN col% = (col% + 1) AND 511: IF (col% AND 63) = 63 THEN col% = (col% + 1) AND 511
      CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, (col% AND &H1C0) + ((col% + 32) AND 63))
   END IF
   IF x% < 0 THEN x% = 0
   IF x% > 191 THEN x% = 191
   IF y% < 0 THEN y% = 0
   IF y% > 191 THEN y% = 191
   oldcol% = getpixel%(x% + 1, y% + 1)
   CALL drawpixel(x% + 1, y% + 1, (oldcol% AND &H1C0) + ((oldcol% + 32) AND 63))
   IF z$ = "+" OR z$ = "-" THEN
      CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, col%)
      IF z$ = "+" THEN col% = (col% + 1) AND 511: IF (col% AND 63) = 63 THEN col% = (col% + 1) AND 511
      IF z$ = "-" THEN col% = (col% + 511) AND 511: IF (col% AND 63) = 63 THEN col% = (col% + 511) AND 511
      CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, (col% AND &H1C0) + ((col% + 32) AND 63))
   END IF
   IF z$ = "T" THEN trail% = trail% XOR 1
   IF z$ = " " OR trail% > 0 THEN oldcol% = col%
   IF z$ = CHR$(9) THEN
      CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, col%)
      col% = oldcol%: x1% = x%: y1% = y%
      CALL drawpixel(201 + (col% \ 64) * 3, 3 + (col% AND 63) * 3, (col% AND &H1C0) + ((col% + 32) AND 63))
   END IF
   IF z$ = "F" THEN
      FOR z% = 0 TO 193
         CALL drawpixel(z%, 0, col%)
         CALL drawpixel(z%, 193, col%)
         CALL drawpixel(0, z%, col%)
         CALL drawpixel(193, z%, col%)
      NEXT z%
      CALL fill(x% + 1, y% + 1, col%)
      oldcol% = col%
      FOR z% = 0 TO 193
         CALL drawpixel(z%, 0, 30)
         CALL drawpixel(z%, 193, 30)
         CALL drawpixel(0, z%, 30)
         CALL drawpixel(193, z%, 30)
      NEXT z%
   END IF
   IF z$ = "1" THEN
      x1% = x%
      y1% = y%
   END IF
   IF z$ = "2" THEN
      x2% = x%: y2% = y%
      IF x1% > x2% THEN SWAP x1%, x2%
      IF y1% > y2% THEN SWAP y1%, y2%
      FOR z% = x1% TO x2%
         FOR zz% = y1% TO y2%
            buf3%(z% - x1%, zz% - y1%) = getpixel%(z% + 1, zz% + 1)
         NEXT zz%
      NEXT z%
      x2% = x2% - x1%
      y2% = y2% - y1%
      x1% = 0
      y1% = 0
   END IF
   IF z$ = "4" THEN
      FOR z% = 0 TO x2% \ 2
         FOR zz% = 0 TO y2%
            SWAP buf3%(z%, zz%), buf3%(x2% - z%, zz%)
         NEXT zz%
      NEXT z%
      SOUND 262, .1
   END IF
   IF z$ = "5" THEN
      FOR z% = 0 TO x2%
         FOR zz% = 0 TO y2% \ 2
            SWAP buf3%(z%, zz%), buf3%(z%, y2% - zz%)
         NEXT zz%
      NEXT z%
      SOUND 262, .1
   END IF
   IF z$ = "6" THEN
      FOR z% = 0 TO xdim& - 1
         FOR zz% = 0 TO ydim& - 1
            IF z% > zz% THEN SWAP buf3%(z%, zz%), buf3%(zz%, z%)
         NEXT zz%
      NEXT z%
      SWAP x2%, y2%
      SOUND 262, .1
   END IF
   IF z$ = "3" THEN
      asksave% = 1
      FOR z% = 0 TO x2%
         FOR zz% = 0 TO y2%
            IF z% + x% >= 0 AND z% + x% < xdim& AND zz% + y% >= 0 AND zz% + y% < ydim& THEN
               IF buf3%(z%, zz%) <> 255 THEN CALL drawpixel(z% + x% + 1, zz% + y% + 1, buf3%(z%, zz%))
            END IF
         NEXT zz%
      NEXT z%
   END IF
   IF z$ = "7" THEN
      asksave% = 1
      col1% = oldcol%
      col2% = col%
      newcol% = (col1% + col2%) \ 2
      IF (newcol% = col1% OR newcol% = col2% OR ((col1% \ 64) <> (col2% \ 64))) THEN
         SOUND 37, 2
      ELSE
         FOR z% = 0 TO xdim& - 1
            FOR zz% = 0 TO ydim& - 1
               IF getpixel%(z% + 1, zz% + 1) = col1% THEN
                  IF getpixel%(((z% + xdim& - 1) MOD xdim&) + 1, zz% + 1) = col2% THEN
                     CALL drawpixel(((z% + xdim& - 1) MOD xdim&) + 1, zz% + 1, newcol%)
                  END IF
               END IF
               IF getpixel%(z% + 1, zz% + 1) = col1% THEN
                  IF getpixel%(((z% + 1) MOD xdim&) + 1, zz% + 1) = col2% THEN
                     CALL drawpixel(((z% + 1) MOD xdim&) + 1, zz% + 1, newcol%)
                  END IF
               END IF
               IF getpixel%(z% + 1, zz% + 1) = col1% THEN
                  IF getpixel%(z% + 1, ((zz% + ydim& - 1) MOD ydim&) + 1) = col2% THEN
                     CALL drawpixel(z% + 1, ((zz% + ydim& - 1) MOD ydim&) + 1, newcol%)
                  END IF
               END IF
               IF getpixel%(z% + 1, zz% + 1) = col1% THEN
                  IF getpixel%(z% + 1, ((zz% + 1) MOD ydim&) + 1) = col2% THEN
                     CALL drawpixel(z% + 1, ((zz% + 1) MOD ydim&) + 1, newcol%)
                  END IF
               END IF
            NEXT zz%
         NEXT z%
         SOUND 262, .1
      END IF
   END IF
   IF z$ = "C" THEN
      asksave% = 1
      chanfromcol% = oldcol%
      FOR z% = 0 TO xdim& - 1
         FOR zz% = 0 TO ydim& - 1
            IF getpixel%(z% + 1, zz% + 1) = chanfromcol% THEN
               CALL drawpixel(z% + 1, zz% + 1, col%)
            END IF
         NEXT zz%
      NEXT z%
   END IF
   IF z$ = "J" THEN
      asksave% = 1
      col1% = oldcol%
      col2% = col%
      FOR z% = 0 TO xdim& - 1
         FOR zz% = 0 TO ydim& - 1
            IF getpixel%(z% + 1, zz% + 1) = col1% THEN
               IF INT(10 * RND) = 0 THEN CALL drawpixel(z% + 1, zz% + 1, col2%)
            END IF
         NEXT zz%
      NEXT z%
      SOUND 262, .1
   END IF
   IF z$ = "=" THEN
      asksave% = 1
      FOR z% = 0 TO xdim& - 1
         FOR zz% = 0 TO ydim& - 1
            buf3%(z%, zz%) = getpixel%(z% + 1, zz% + 1)
         NEXT zz%
      NEXT z%
      FOR z% = 0 TO xdim& - 1
         FOR zz% = 0 TO ydim& - 1
            band% = buf3%(z%, zz%) AND &HE0
            colband% = oldcol%
            FOR zx% = 0 TO 3
               IF zx% = 0 THEN x% = -1: y% = 0
               IF zx% = 1 THEN x% = 1: y% = 0
               IF zx% = 2 THEN x% = 0: y% = -1
               IF zx% = 3 THEN x% = 0: y% = 1
               datzx% = buf3%((x% + z% + 256) MOD xdim&, (y% + zz% + 256) MOD ydim&)
               IF (datzx% AND &HE0) <> band% THEN
                  IF x% + y% > 0 AND colband% > 0 THEN colband% = colband% - 1
                  IF x% + y% < 0 AND colband% < 15 THEN colband% = colband% + 1
               END IF
            NEXT zx%
            CALL drawpixel(z% + 1, zz% + 1, (getpixel%(z% + 1, zz% + 1) AND &HE0) OR (colband% AND 31))
         NEXT zz%
      NEXT z%
   END IF
   IF z$ = "<" OR z$ = ">" OR z$ = "," OR z$ = "." THEN
      x2% = x%
      y2% = y%
      IF x1% > x2% THEN SWAP x1%, x2%
      IF y1% > y2% THEN SWAP y1%, y2%
      IF z$ = "<" THEN
         FOR z% = x1% TO x2%
            FOR zz% = y1% TO y2%
               CALL drawpixel(z% + 1, zz% + 1, (getpixel%(z% + 1, zz% + 1) + 448) AND 511)
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = ">" THEN
         FOR z% = x1% TO x2%
            FOR zz% = y1% TO y2%
               CALL drawpixel(z% + 1, zz% + 1, (getpixel%(z% + 1, zz% + 1) + 64) AND 511)
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "," THEN
         FOR z% = x1% TO x2%
            FOR zz% = y1% TO y2%
               CALL drawpixel(z% + 1, zz% + 1, (getpixel%(z% + 1, zz% + 1) + 511) AND 511)
            NEXT zz%
         NEXT z%
      END IF
      IF z$ = "." THEN
         FOR z% = x1% TO x2%
            FOR zz% = y1% TO y2%
               CALL drawpixel(z% + 1, zz% + 1, (getpixel%(z% + 1, zz% + 1) + 1) AND 511)
            NEXT zz%
          NEXT z%
      END IF
   END IF
LOOP WHILE z$ <> CHR$(27)
END

setupcolors:
   OPEN "palette.dat" FOR BINARY AS #3
   pal$ = STRING$(768, 0)
   GET #3, , pal$
   OUT &H3C8, 0
   FOR z% = 0 TO 767
      pal%(z%) = ASC(MID$(pal$, z% + 1, 1))
      OUT &H3C9, pal%(z%)
   NEXT z%
   CLOSE #3
   FOR z% = 0 TO 7
      CALL drawpixel(z% * 3 + 200, 1, 30)
      CALL drawpixel(z% * 3 + 201, 1, 30)
      CALL drawpixel(z% * 3 + 202, 1, 30)
      CALL drawpixel(z% * 3 + 200, 191, 30)
      CALL drawpixel(z% * 3 + 201, 191, 30)
      CALL drawpixel(z% * 3 + 202, 191, 30)
      FOR zz% = 0 TO 62
         CALL drawpixel(z% * 3 + 200, zz% * 3 + 2, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 201, zz% * 3 + 2, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 202, zz% * 3 + 2, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 200, zz% * 3 + 3, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 201, zz% * 3 + 3, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 202, zz% * 3 + 3, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 200, zz% * 3 + 4, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 201, zz% * 3 + 4, z% * 64 + zz%)
         CALL drawpixel(z% * 3 + 202, zz% * 3 + 4, z% * 64 + zz%)
      NEXT zz%
   NEXT z%
   FOR z% = 1 TO 191
      CALL drawpixel(199, z%, 30)
      CALL drawpixel(224, z%, 30)
   NEXT z%
RETURN

SUB drawpixel (x%, y%, col%)
   DEF SEG = &HA000
   OUT &H3C4, 2: OUT &H3C5, pow2%(x% AND 3)
   p% = y% * 80 + x% \ 4
   col1% = col% \ 2
   col2% = (col% + 1) \ 2
   IF ((x% + y%) AND 1) = 0 THEN
      POKE p%, col1%: POKE p% + 16384, col2%
   ELSE
      POKE p%, col2%: POKE p% + 16384, col1%
   END IF
END SUB

SUB fill (x%, y%, col%)
   c% = 1: xfill%(c%) = x%: yfill%(c%) = y%
   bound% = col%
   WHILE c% > 0
      IF c% > maxc% THEN maxc% = c%
      z% = xfill%(c%)
      zz% = yfill%(c%)
      c% = c% - 1
      WHILE getpixel%(z%, zz%) <> bound%
         z% = z% - 1
      WEND
      z% = z% + 1
      leftz% = z%
      tlast% = 0
      blast% = 0
      WHILE getpixel%(z%, zz%) <> bound%
         tstat% = getpixel%(z%, zz% - 1)
         IF tstat% <> bound% AND tstat% <> col% THEN
            IF tlast% = 0 THEN
               c% = c% + 1: xfill%(c%) = z%: yfill%(c%) = zz% - 1
               tlast% = 1
            END IF
         ELSE
            tlast% = 0
         END IF
         bstat% = getpixel%(z%, zz% + 1)
         IF bstat% <> bound% AND bstat% <> col% THEN
            IF blast% = 0 THEN
               c% = c% + 1: xfill%(c%) = z%: yfill%(c%) = zz% + 1
               blast% = 1
            END IF
         ELSE
            blast% = 0
         END IF
         z% = z% + 1
      WEND
      z% = z% - 1
      FOR zx% = leftz% TO z%
         CALL drawpixel(zx%, zz%, col%)
      NEXT zx%
   WEND
END SUB

SUB fillscreen (startpag%, col%)
   OUT &H3C4, 2: OUT &H3C5, 15
   diplc& = (startpag% AND 3) * 16384&
   DIM asmprog%(12)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B: POKE p& + 2, &HEC
   POKE p& + 3, &HB8: POKE p& + 4, &H0: POKE p& + 5, &HA0
   POKE p& + 6, &H8E: POKE p& + 7, &HC0
   POKE p& + 8, &HB9: POKE p& + 9, &H0: POKE p& + 10, &H20
   POKE p& + 11, &HBF: POKE p& + 12, diplc& AND 255: POKE p& + 13, diplc& \ 256
   POKE p& + 14, &HB8: POKE p& + 15, col%: POKE p& + 16, col%
   POKE p& + 17, &HF3: POKE p& + 18, &HAB
   POKE p& + 19, &H5D
   POKE p& + 20, &HCA: POKE p& + 21, &H2: POKE p& + 22, &H0
   CALL ABSOLUTE(0, p&)

' 55        : 'push bp
' 8B EC     : 'mov bp, sp
' B8 00 A0  : 'mov ax, &ha000
' 8E C0     : 'mov es, ax
' B9 00 20  : 'mov cx, 8192
' 33 ?  ?   : 'mov di, 0x8888
' B8 ?  ?   : 'mov ax, 0x8888
' F3 AB     : 'rep stosw
' 5D        : 'pop bp
' CA 02 00  : 'ret 2

END SUB

FUNCTION getpixel% (x%, y%)
   DEF SEG = &HA000
   OUT &H3CE, 4: OUT &H3CF, x% AND 3
   p% = y% * 80 + x% \ 4
   getpixel% = PEEK(p%) + PEEK(p% + 16384)
END FUNCTION

