DECLARE SUB hline (xl%, xr%, yp%, zd%, walnume%, shadeoffs%)
DIM SHARED buf%(64, 64), sintable&(2048)
COMMON SHARED pageoffset&, posx&, posy&, ang&, horiz&
maxwalls% = 4096
DIM picsiz%(maxwalls%), picanm%(maxwalls%)
DIM hlinx%(200, 16), hlinz%(200, 16), hlinum%(200)
FOR z& = 0 TO 511
   sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
NEXT z&
FOR z& = 512 TO 1023
   sintable&(z&) = sintable&(1023 - z&)
NEXT z&
FOR z& = 1024 TO 2047
   sintable&(z&) = -sintable&(z& - 1024)
NEXT z&
SCREEN 13
RANDOMIZE TIMER
GOSUB setupcolors
wallnum% = 20: GOSUB loadnewall
OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) AND (255 - 8)    'CHAIN 4 OFF
OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) OR 64           'WORD MODE
OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) AND (255 - 64)  '2-WORD MODE
pageoffset& = 0
ang& = INT(2048 * RND)
posx& = INT(64 * RND)
posy& = INT(64 * RND)
horiz& = INT(40 * RND) + 80
posz& = INT(4096 * RND) + 6144

FOR z% = 0 TO 199
   hlinx%(z%, 0) = 0: hlinz%(z%, 0) = posz&
   hlinx%(z%, 1) = 319: hlinz%(z%, 1) = posz&
   hlinum%(z%) = 2
NEXT z%
FOR z% = 0 TO 199
   CALL hline(hlinx%(z%, 0), hlinx%(z%, 1), z%, hlinz%(z%, 0), 0, 0)
NEXT z%
END

setupcolors:
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   CLOSE #1
RETURN

loadnewall:
   OPEN "pics.dat" FOR BINARY AS #1
 
   SEEK #1, 1
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
      picsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
      picanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
 
   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      IF picsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((picsiz%(z%) AND 15) + (picsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
 
   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 63
      FOR zz% = 0 TO 63
         buf%(z%, zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
RETURN

SUB hline (xl%, xr%, yp%, zd%, walnume%, shadeoffs%)
   IF xl% <> xr% THEN
      IF xl% > xr% THEN
         SWAP xl%, xr%
         SWAP xc1&, xc2&
         SWAP yc1&, yc2&
      END IF
      siz& = xr% - xl%
      hd& = ABS(horiz& - yp%)
      IF siz& > 0 AND hd& > 0 THEN
         templong1& = (zd% * (sintable&((2048 + ang&) AND 2047))) \ (64& * hd&)
         templong2& = (zd% * (sintable&((2560 + ang&) AND 2047))) \ (64& * hd&)
         xj1& = -templong1& - templong2&
         yj1& = templong1& - templong2&
         xj2& = templong1& - templong2&
         yj2& = templong1& + templong2&
         xc1& = (xj2& * xl% + xj1& * (320& - xl%)) \ 40&
         yc1& = (yj2& * xl% + yj1& * (320& - xl%)) \ 40&
         xc2& = (xj2& * xr% + xj1& * (320& - xr%)) \ 40&
         yc2& = (yj2& * xr% + yj1& * (320& - xr%)) \ 40&
         p& = yp% * 80& + (xl% \ 4&) + pageoffset&
         DEF SEG = &HA000
         xc& = ((xc2& - xc1&) * 16&) \ siz&
         yc& = ((yc2& - yc1&) * 16&) \ siz&
         x& = ((xc1& - (posx& * 16&)) AND &HFFFFF) * 16&
         y& = ((yc1& + (posy& * 16&)) AND &HFFFFF) * 16&
         xsnot& = 2 ^ (xl% AND 3)
         OUT &H3C4, 2
         FOR zx& = 1 TO siz&
            OUT &H3C5, xsnot&: xsnot& = (xsnot& + xsnot&) AND 15
            POKE p&, buf%((x& \ 65536) AND 63, (y& \ 65536) AND 63)
            x& = x& + xc&: y& = y& + yc&
            xl% = xl% + 1: IF (xl% AND 3) = 0 THEN p& = p& + 1: xsnot& = 1
         NEXT zx&
      END IF
   END IF
END SUB

