DECLARE SUB testwithsines ()
DECLARE SUB testwithrandom ()
DECLARE SUB hline (x1%, x2%, y%, col%)
DECLARE SUB singlehscan ()
DECLARE SUB doublehscan ()

CONST XDIM = 320
CONST YDIM = 200

DIM SHARED topwall%(XDIM), botwall%(XDIM), lastx%(YDIM)
SCREEN 13
'call singlehscan
LOCATE 1, 1: PRINT "1 - sines, 2 - random"
DO
   z$ = INPUT$(1)
LOOP WHILE z$ <> "1" AND z$ <> "2" AND z$ <> CHR$(27)
DO
   IF z$ = "1" THEN CALL testwithsines
   IF z$ = "2" THEN CALL testwithrandom
   z% = 0: zdir% = 1
   DO
      z% = z% + zdir%: IF z% = 0 OR z% = 63 THEN zdir% = -zdir%
      OUT &H3C8, 9
      OUT &H3C9, z% \ 2: OUT &H3C9, z%: OUT &H3C9, z%
      OUT &H3C8, 14
      OUT &H3C9, (63 - z%) \ 2: OUT &H3C9, 63 - z%: OUT &H3C9, (63 - z%) \ 2
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
      z$ = INKEY$
   LOOP WHILE z$ <> "1" AND z$ <> "2" AND z$ <> CHR$(27)
LOOP WHILE z$ <> CHR$(27)
END

SUB doublehscan
   LINE (0, 0)-(XDIM - 1, YDIM - 1), 15, BF
   FOR x% = 0 TO XDIM - 1
      IF topwall%(x%) >= 0 THEN LINE (x%, 0)-(x%, topwall%(x%)), 6
      IF botwall%(x%) < YDIM THEN LINE (x%, botwall%(x%))-(x%, YDIM - 1), 6
   NEXT x%
   DO: LOOP WHILE INKEY$ = ""
   y1% = topwall%(0): y2% = topwall%(0)
   IF y1% < -1 THEN y1% = -1
   IF y1% > YDIM - 1 THEN y1% = YDIM - 1
   IF y2% < 0 THEN y2% = 0
   IF y2% > YDIM THEN y2% = YDIM
   FOR x% = 0 TO XDIM - 1
      twall% = topwall%(x%)
      bwall% = botwall%(x%)
      IF twall% < bwall% - 1 THEN
        
         IF twall% < -1 THEN twall% = -1
         IF twall% > YDIM - 1 THEN twall% = YDIM - 1
         IF bwall% < 0 THEN bwall% = 0
         IF bwall% > YDIM THEN bwall% = YDIM
        
         IF twall% >= y2% THEN
            WHILE y1% < y2% - 1
               y1% = y1% + 1
               CALL hline(lastx%(y1%), x% - 1, y1%, 1)
               SOUND 392, .03
            WEND
            y1% = twall%
         ELSE
            WHILE y1% < twall%
               y1% = y1% + 1
               CALL hline(lastx%(y1%), x% - 1, y1%, 1)
               SOUND 392, .03
            WEND
            WHILE y1% > twall%
               lastx%(y1%) = x%
               PSET (x%, y1%), 7
               SOUND 196, .03
               y1% = y1% - 1
            WEND
         END IF

         WHILE y2% > bwall%
            y2% = y2% - 1
            CALL hline(lastx%(y2%), x% - 1, y2%, 1)
            SOUND 392, .03
         WEND
         WHILE y2% < bwall%
            lastx%(y2%) = x%
            PSET (x%, y2%), 7
            SOUND 196, .03
            y2% = y2% + 1
         WEND
      ELSE
         WHILE y1% < y2% - 1
            y1% = y1% + 1
            CALL hline(lastx%(y1%), x% - 1, y1%, 1)
            SOUND 392, .03
         WEND
         y1% = topwall%(x% + 1)
         y2% = y1%
        
         IF y1% < -1 THEN y1% = -1
         IF y1% > YDIM - 1 THEN y1% = YDIM - 1
         IF y2% < 0 THEN y2% = 0
         IF y2% > YDIM THEN y2% = YDIM
      END IF
   NEXT x%
   WHILE y1% < y2% - 1
      y1% = y1% + 1
      CALL hline(lastx%(y1%), XDIM - 1, y1%, 1)
      SOUND 523, .03
   WEND
END SUB

SUB hline (x1%, x2%, y%, col%)
   FOR z% = x1% TO x2%
      IF POINT(z%, y%) = 15 OR POINT(z%, y%) = 7 THEN
         PSET (z%, y%), col%
      ELSE
         PSET (z%, y%), POINT(z%, y%) + 8
      END IF
   NEXT z%
END SUB

SUB singlehscan
   LINE (0, 0)-(XDIM - 1, YDIM - 1), 0, BF
   FOR x% = 0 TO XDIM - 1
      IF topwall%(x%) <= botwall%(x%) THEN LINE (x%, topwall%(x%))-(x%, botwall%(x%)), 12 + (x% AND 1)
   NEXT x%
   DO: LOOP WHILE INKEY$ = ""
   y% = 0
   FOR x% = 0 TO XDIM - 1
      twall% = topwall%(x%)
      IF twall% < 0 THEN twall% = 0
      IF twall% > YDIM THEN twall% = YDIM
      WHILE y% < twall%
         lastx%(y%) = x%
         y% = y% + 1
      WEND
      WHILE y% > twall%
         y% = y% - 1
         LINE (lastx%(y%), y%)-(x% - 1, y%), 10 + (y% AND 1)
      WEND
   NEXT x%
   WHILE y% > 0
      y% = y% - 1
      LINE (lastx%(y%), y%)-(x%, y%), 10 + (y% AND 1)
   WEND
   
   y% = YDIM - 1
   FOR x% = 0 TO XDIM - 1
      bwall% = botwall%(x%)
      IF bwall% < -1 THEN bwall% = -1
      IF bwall% > YDIM THEN bwall% = YDIM
      WHILE y% > bwall%
         lastx%(y%) = x%
         y% = y% - 1
      WEND
      WHILE y% < bwall%
         y% = y% + 1
         LINE (lastx%(y%), y%)-(x% - 1, y%), 10 + (y% AND 1)
      WEND
   NEXT x%
   WHILE y% < YDIM - 1
      y% = y% + 1
      LINE (lastx%(y%), y%)-(XDIM - 1, y%), 10 + (y% AND 1)
   WEND
  
   DO: LOOP WHILE INKEY$ = ""
END SUB

SUB testwithrandom
   FOR x% = 0 TO XDIM - 1
      topwall%(x%) = INT(300 * RND) - 50
      botwall%(x%) = INT(300 * RND) - 50
   NEXT x%

   CALL doublehscan
END SUB

SUB testwithsines
   v1 = 2 * RND: v2 = 10 * RND + 2: v3 = 30 * RND + 5
   v4 = 50 * RND + 10: v5 = 30 * RND + 5: v6 = 100 * RND + 20
   v7 = 20 * RND + 5: v8 = 30 * RND + 5: v9 = 2 * RND
   v10 = 15 * RND + 2: v11 = 30 * RND + 10: v12 = 100 * RND + 80
  
   FOR x% = 0 TO XDIM - 1
      topwall%(x%) = INT(COS((x% + v1) / v2)) * v3 + SIN(x% / v4) * v5 + v6
      botwall%(x%) = SIN(x% / v7) * v8 + COS((x% + v9) / v10) * v11 + v12
   NEXT x%

   CALL doublehscan
END SUB

