#define MOVEFIFOSIZ 256

extern char syncstate;
static char syncvalplc, othersyncvalplc;
static char syncvalend, othersyncvalend;
static long syncvalcnt, othersyncvalcnt;
static char syncval[MOVEFIFOSIZ], othersyncval[MOVEFIFOSIZ];

in prepareboard:
	//movefifoplc = 0; movefifoend = 0;
	syncvalplc = 0; othersyncvalplc = 0;
	syncvalend = 0; othersyncvalend = 0;
	syncvalcnt = 0L; othersyncvalcnt = 0L;

in drawscreen (just before nextpage):
	if ((myconnectindex != connecthead) && (option[4] != 0)) //Slave
	{
		ch = 0;
		while (syncvalplc != syncvalend)
		{
			if (othersyncvalcnt > syncvalcnt)
				ch |= (syncval[syncvalplc]^othersyncval[syncvalplc]);
			syncvalplc = ((syncvalplc+1)&(MOVEFIFOSIZ-1));
			syncvalcnt++;
		}
		while (othersyncvalplc != othersyncvalend)
		{
			if (syncvalcnt > othersyncvalcnt)
				ch |= (syncval[othersyncvalplc]^othersyncval[othersyncvalplc]);
			othersyncvalplc = ((othersyncvalplc+1)&(MOVEFIFOSIZ-1));
			othersyncvalcnt++;
		}
		if (ch != 0) printext256(68L,84L,31,0,"OUT OF SYNC!",0);
	}
	if (syncstate != 0) printext256(68L,92L,31,0,"Missed Network packet!",0);
	//nextpage();

beginning of domovethings:
	syncval[syncvalend] = getsyncbyte();
	syncvalend = ((syncvalend+1)&(MOVEFIFOSIZ-1));

in faketimerhandler:
	just before master sends packet to slave, after setting up tempbuf:
		while (syncvalplc != syncvalend)
		{
			tempbuf[j++] = syncval[syncvalplc];
			syncvalplc = ((syncvalplc+1)&(MOVEFIFOSIZ-1));
		}
	After slave receives packet from master, after reading tempbuf:
		while (j != tempbufleng)
		{
			othersyncval[othersyncvalend] = tempbuf[j++];
			othersyncvalend = ((othersyncvalend+1)&(MOVEFIFOSIZ-1));
		}
		//movethings();        //Move all players and sprites

getsyncbyte()
{
	long i, j;
	char ch;
	struct spritetype *spr;

	ch = (char)(randomseed&255);
	for(i=connecthead;i>=0;i=connectpoint2[i])
		ch ^= (posx[i]&posy[i])^(posz[i]|ang[i])^(horiz[i]^health[i]);

	for(i=7;i>=0;i--)
		for(j=headspritestat[i];j>=0;j=nextspritestat[j])
		{
			spr = &sprite[j];
			ch ^= (spr->x|spr->y)^(spr->z&spr->ang);
		}
	return(ch);
}
