// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#define maxscandist 32
#define numtimecounts 9
#define maxlines 2048
#define maxwalls 1024
#define maxsprites 64

#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

EXTERN struct walldata
{
	short unsigned int xa1, ya1, xa2, ya2;
	short unsigned int picnum, picnum1, picnum2;
	char shade, shade1, shade2, z1, z2, got, cstat, zosc, repeat;
};
EXTERN short int lintal[maxlines*4];     /*May need *5,*6... if dense board*/
EXTERN struct walldata lin[maxlines];

#ifdef MAIN
EXTERN char timenames[numtimecounts][20] =
{
	"Main loop          ",
	"Addbox             ",
	"Sorting            ",
	"Sprites            ",
	"Wall calculations  ",
	"Vline calculations ",
	"Vline drawing      ",
	"Hline calculations ",
	"Hline drawing      ",
};
#else
	EXTERN char timenames[numtimecounts][20];
#endif
EXTERN short int numlines, capturecount;
EXTERN long centeroffset, scrsize;
EXTERN long posx, posy, posz, vel, svel, hvel, angvel, newposz;
EXTERN long xb1[64], yb1[64], xb2[64], yb2[64];
EXTERN short int theline[64], ceilingstat, uxsave[242], dxsave[242];
EXTERN unsigned char swapped[64], picsiz[maxwalls], picanm[maxwalls];
EXTERN long xs[maxsprites], ys[maxsprites], sizs[maxsprites];
EXTERN short int sline[maxsprites], sord[maxsprites], snum;
EXTERN char sumost[maxsprites][320], sdmost[maxsprites][320];
EXTERN short int vidmode, xdim, ydim, halfwidth, eigthwidth, halfheight, clockspeed;
EXTERN short int xtotaldim, ytotaldim, closestline, lintalplc, numhits, page;
EXTERN short int sintable[2048];
EXTERN long tantable[1024], numframes, waloff[maxwalls];
EXTERN unsigned short int lintaladdr[4097], lintalcnt, ang;
EXTERN unsigned char tempbuf[maxlines*2], palette[768];
EXTERN short int umost[321], dmost[321];
EXTERN unsigned char uzmost[321], dzmost[321];
EXTERN long uplace[321], dplace[321], linum[321];
EXTERN volatile unsigned char readch, oldreadch, keystatus[256], extended;
EXTERN volatile long totalclock, timetakercount[numtimecounts], takernum;
EXTERN void (__interrupt __far *oldhand)();
EXTERN void (__interrupt __far *oldkeyhandler)();
EXTERN void __interrupt __far ksmhandler(void);
EXTERN void __interrupt __far keyhandler(void);
EXTERN char *pic;
EXTERN short int mousx, mousy, moustat;
EXTERN unsigned long vplc1, vplc2, vinc1, vinc2, pplc;
