DECLARE SUB loadtables ()
DECLARE SUB vdraw (x&, xbmp%, dist&)
DIM SHARED pic%(4096), sintable&(2048), radarang%(320)

SCREEN 13
CALL loadtables
FOR z% = 0 TO 63
   FOR zz% = 0 TO 63
      pic%(z% * 64 + zz%) = z% * zz%
   NEXT zz%
NEXT z%

FOR x& = 0 TO 319
   vinc& = 4& * sintable&((radarang%(x&) + 512) AND 2047)
   CALL vdraw(x&, (radarang%(x&) \ 2 + ang%) AND 63, vinc&)
NEXT x&

SUB loadtables
   FOR z% = 0 TO 2047
      sintable&(z%) = SIN((z% * 3.141592653589793#) / 1024) * 16384
   NEXT z%
   FOR z% = 0 TO 319
      radarang%(z%) = (ATN((z% - 160) / 160) * 1024 / 3.141592)
   NEXT z%
END SUB

SUB vdraw (x&, xbmp%, vinc&)
   vpos& = -100 * vinc&
   voff% = xbmp% * 64
   DEF SEG = &HA000: p& = x&
   FOR y& = 0 TO 199
      POKE p&, pic%(voff% + ((vpos& \ 65536) AND 63))
      p& = p& + 320
      vpos& = vpos& + vinc&
   NEXT y&
END SUB

