DECLARE SUB deletesprite (spritenum%)
DECLARE FUNCTION insertsprite% (sectnum%)
DECLARE SUB showlinks ()
CONST MAXSECTORS = 16, MAXSPRITES = 256

COMMON SHARED numsprites%
DIM SHARED firstsprite%(MAXSECTORS)
DIM SHARED spritepoint2%(MAXSPRITES)
DIM SHARED spritesectnum%(MAXSPRITES)
DIM SHARED spritedat%(MAXSPRITES)

CLS
RANDOMIZE TIMER
numsprites% = 0
FOR z% = 0 TO MAXSECTORS - 1
   firstsprite%(z%) = -1
NEXT z%

FOR z% = 0 TO MAXSPRITES - 1
   spritenum% = insertsprite%(INT(MAXSECTORS * RND))
   spritedat%(spritenum%) = INT(10 * RND)
   CALL showlinks
   FOR zx = 0 TO 1000: NEXT zx
NEXT z%

FOR z% = 0 TO MAXSPRITES - 1
  
   zz% = INT(numsprites% * RND)
   LOCATE 25, 1: PRINT "delete "; zz%; "       ";
   FOR zx = 0 TO 1000: NEXT zx
   CALL deletesprite(zz%)
   CALL showlinks
NEXT z%

SUB deletesprite (spritenum%)
  
   i% = firstsprite%(spritesectnum%(spritenum%))    'delete sprite
  
   'whatever points to spritenum should now point to spritepoint2(spritenum)
   IF (i% = spritenum%) THEN
      firstsprite%(spritesectnum%(spritenum%)) = spritepoint2%(spritenum%)
   ELSE
      WHILE spritepoint2%(i%) <> spritenum%
         i% = spritepoint2%(i%)
      WEND
      spritepoint2%(i%) = spritepoint2%(spritenum%)
   END IF
  
   numsprites% = numsprites% - 1
   IF (spritenum% <> numsprites%) THEN    'sprite%(spritenum%) = sprite%(numsprites%)
     
      spritedat%(spritenum%) = spritedat%(numsprites%)
      spritesectnum%(spritenum%) = spritesectnum%(numsprites%)
      spritepoint2%(spritenum%) = spritepoint2%(numsprites%)
   
      'whatever points to numsprites should now point to spritenum
      i% = firstsprite%(spritesectnum%(numsprites%))
      IF (i% = numsprites%) THEN
         firstsprite%(spritesectnum%(numsprites%)) = spritenum%
      ELSE
         WHILE spritepoint2%(i%) <> numsprites%
            i% = spritepoint2%(i%)
         WEND
         spritepoint2%(i%) = spritenum%
      END IF
   END IF
END SUB

FUNCTION insertsprite% (sectnum%)
   spritesectnum%(numsprites%) = sectnum%
   spritepoint2%(numsprites%) = firstsprite%(sectnum%)
   firstsprite%(sectnum%) = numsprites%
   numsprites% = numsprites% + 1
   insertsprite% = numsprites% - 1
END FUNCTION

SUB showlinks
   CLS
   FOR z% = 0 TO MAXSECTORS - 1
      zz% = 0
      j% = firstsprite%(z%)
      WHILE j% <> -1
         IF j% = numsprites% - 1 THEN COLOR 0, 7 ELSE COLOR 7, 0
         LOCATE zz% + 1, z% * 4 + 1: PRINT j%
         j% = spritepoint2%(j%)
         zz% = zz% + 1
      WEND
   NEXT z%
   COLOR 7, 0
END SUB

