#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#define numwalls 16

static long sintable[2048], tantable[1024];
unsigned char tempbuf[4096];
unsigned int pic, walseg[numwalls], pageoffset, lastpageoffset;

main()
{
	char ch;
	int i, j, ang, mousx, mousy, posz;
	long posx, posy, templong, templong1, templong2, xp1, yp1, xp2, yp2;

	if ((pic = convallocate(4096>>4)) == -1)
	{
		printf("Allocation failed!");
		exit(-1);
	}
	for(i=0;i<numwalls;i++)
		walseg[i] = pic;
	loadtables();
	for(i=0;i<4096;i++)
		tempbuf[i] = (((i&63)+(i>>6))<<1)&255;
	_asm \
	{
		cld
		mov cx, 2048
		mov es, pic
		xor di, di
		mov si, offset tempbuf
		mov ax, seg tempbuf
		push ds
		mov ds, ax
		rep movsw
		pop ds
	}
	_asm \
	{
		mov ax, 0
		int 0x33

		mov ax, 0x13
		int 0x10
	}
	outp(0x3c8,0);
	for(i=0;i<256;i++)
	{
		outp(0x3c9,(255-i)>>2);
		outp(0x3c9,i>>4);
		outp(0x3c9,i>>2);
	}
	outp(0x3d4,0x17); outp(0x3d5, inp(0x3d5)|64);   //WORD MODE
	outp(0x3d4,0x14); outp(0x3d5, inp(0x3d5)&191);   //2-WORD MODE
	outp(0x3c4,0x4); outp(0x3c5, inp(0x3c5)&247);   //CHAIN 4 OFF
	posx = 0;
	posy = 0;
	posz = 32;
	j = 0;
	ang = 0;
	ch = 0;
	pageoffset = 2880;
	lastpageoffset = 2880;
	while (ch != 27)
	{
		_asm \
		{
			mov ax, 11
			int 0x33
			sar cx, 1
			sar dx, 1
			mov mousx, cx
			mov mousy, dx
		}
		ang += mousx;
		posx -= ((sintable[(2560+ang)&2047]*mousy)>>12);
		posy -= ((sintable[(2048+ang)&2047]*mousy)>>12);
		if (kbhit() != 0)
		{
			ch = getch();
			if (((ch == 'a') || (ch == 'A')) && (posz > 4)) posz--;
			if (((ch == 'z') || (ch == 'Z')) && (posz < 60)) posz++;
		}
		for(i=1;i<=100;i++)
		{
			templong = (256L*((long)posz))/((long)i);
			templong1 = templong*sintable[(2048+ang)&2047];
			templong2 = templong*sintable[(2560+ang)&2047];
			yp2 = ((templong1+templong2)>>11);
			yp1 = ((templong1-templong2)>>11);
			hline(0,319,100-i,2,-yp2-posx,yp1+posy,yp1-posx,yp2+posy);
		}
		outp(97,inp(97)|2);
		for(i=1;i<=100;i++)
		{
			templong = (256L*(63-(long)posz))/((long)i);
			templong1 = templong*sintable[(2048+ang)&2047];
			templong2 = templong*sintable[(2560+ang)&2047];
			yp2 = ((templong1+templong2)>>11);
			yp1 = ((templong1-templong2)>>11);
			hline(0,319,99+i,1,-yp2-posx,yp1+posy,yp1-posx,yp2+posy);
		}
		lastpageoffset = pageoffset;
		_asm \
		{
			mov bx, lastpageoffset
			mov al, 0xc
			mov ah, bh
			mov cl, 0xd
			mov ch, bl
			mov dx, 0x3d4
			out dx, al
			inc dx
			mov al, ah
			out dx, al
			mov ax, cx
			dec dx
			out dx, al
			inc dx
			mov al, ah
			out dx, al
		}
		if (lastpageoffset < 21312) pageoffset = 21312;
		if (lastpageoffset == 21312) pageoffset = 39744;
		if (lastpageoffset > 21312) pageoffset = 2880;
		outp(97,inp(97)&252);
	}
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	convdeallocate(pic);
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc allocated
		mov segnum, -1
allocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc deallocated
		mov segnum, -1
deallocated:
	}
	return(segnum);
}

loadtables()
{
	int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&tempbuf[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
	_asm \
	{
		mov cx, 2048
		xor bx, bx
		xor si, si
convsintable:
		mov ax, word ptr tempbuf[bx]
		cwd
		mov word ptr sintable[si+0], ax
		mov word ptr sintable[si+2], dx
		add bx, 2
		add si, 4
		loop convsintable
	}
}

hline(xl, xr, yp, walnume, xc1, yc1, xc2, yc2)
unsigned xl, xr, yp;
int walnume;
long xc1, yc1, xc2, yc2;
{
	int i, siz, picplc, tempint;
	unsigned p, x, y, xc, yc;
	long templong;

	if (xl == xr)
		return(-1);
	if (xl > xr)
	{
		tempint = xl, xl = xr, xr = tempint;
		templong = xc1, xc1 = xc2, xc2 = templong;
		templong = yc1, yc1 = yc2, yc2 = templong;
	}
	siz = xr-xl+1;
	if (siz <= 0)
		return(-1);
	p = yp*80+(xl>>2)+pageoffset;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
	}
	xc = ((xc2-xc1)<<8)/siz;
	yc = ((yc2-yc1)<<8)/siz;
	x = ((((unsigned)xc1)&0x3ff)<<6);
	y = ((((unsigned)yc1)&0x3ff)<<6);
	_asm \
	{
		cld

		mov dx, 0x3c4
		mov al, 0x2
		out dx, al
		inc dx
		mov al, 0x3
		out dx, al

		mov cx, siz
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov bx, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1a+2], ax
		mov ax, yc
		mov word ptr cs:[mach2a+2], ax
		mov si, walnume
		shl si, 1
		push ds
		mov ds, word ptr walseg[si]
begindrawa:
mach1a:add bx, 0x1234
mach2a:add dx, 0x1234
		mov ah, bh
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov si, ax
		movsb
		sub ch, 2
		jnz begindrawa
		pop ds

		mov dx, 0x3c5
		mov al, 0xc
		out dx, al

		mov cx, siz
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov bx, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1b+2], ax
		sar ax, 1
		add bx, ax
		mov ax, yc
		mov word ptr cs:[mach2b+2], ax
		sar ax, 1
		add dx, ax
		mov si, walnume
		shl si, 1
		push ds
		mov ds, word ptr walseg[si]
begindrawb:
mach1b:add bx, 0x1234
mach2b:add dx, 0x1234
		mov ah, bh
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov si, ax
		movsb
		sub ch, 2
		jnz begindrawb
		pop ds
	}
}
