DECLARE SUB hchain (xl&, xr&, yp&, sectnum%)
DECLARE SUB chainit ()
DECLARE SUB unchainit ()
DECLARE SUB hline (xl&, xr&, yp&, sectnum%)
DECLARE SUB loadnewall (bufplc&, wallnum%)
DECLARE SUB setupscreen ()
DECLARE SUB loadtables ()

CONST numpalookups = 32, xdim = 320, ydim = 200, MAXTILES = 4096

DIM SHARED buf%(20480), palookup%(numpalookups, 256), sintable&(2048)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)

CALL loadtables
CALL setupscreen
CALL loadnewall(0&, 2)
CALL loadnewall(4096&, 5)

DO
   CALL unchainit
   FOR y& = 0 TO 199
      LINE (0, y&)-(319, y&), 0
      CALL hline(40 * COS(y& / 15) + 50, 250 + 50 * SIN(y& / 35), y&, 0)
   NEXT y&
  
   CALL chainit
   FOR y& = 0 TO 199
      DEF SEG = &HA000
      OUT &H3C4, 2: OUT &H3C5, 15
      p& = y& * 80&
      FOR zx% = 0 TO 79
         POKE p&, 0: p& = p& + 1
      NEXT zx%
      CALL hchain(40 * COS(y& / 15) + 50, 250 + 50 * SIN(y& / 35), y&, 0)
   NEXT y&
LOOP

DO: LOOP WHILE INKEY$ = ""

SUB chainit
   OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) AND 247          'TRUST ME #1
   OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) AND 191         'TRUST ME #2
   OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) OR 64           'TRUST ME #3
   OUT &H3CE, &H5: OUT &H3CF, 64                          'TRUST ME #4
END SUB

SUB hchain (xl&, xr&, yp&, sectnum%)
   IF ((yp& = ydim \ 2) OR tilesizx%(walnume%) = 0 OR tilesizy%(walnume%) = 0) THEN EXIT SUB
   IF xl& > xr& THEN SWAP xl&, xr&

   IF yp& < (ydim \ 2) THEN
      zd& = 8192&  '(sector(sectnum%).z1 - posz&) * 256&
      bufplc& = 0& 'sector(sectnum%).picnum1
   ELSE
      zd& = 8192& ' (posz& - sector(sectnum%).z2) * 256&
      bufplc& = 4096& 'sector(sectnum%).picnum2
   END IF

   hd& = (zd& * 16384&) \ (xdim * ABS(ydim \ 2 - yp&))
   IF ABS(hd&) > 131072 THEN EXIT SUB
   xc& = (hd& * sintable&((2048 + ang%) AND 2047)) \ 1024&
   yc& = (hd& * sintable&((2560 + ang%) AND 2047)) \ 1024&
   x& = xc& * xl& - (xc& + yc&) * (xdim \ 2) + (posx& * 16384&)
   y& = yc& * xl& + (xc& - yc&) * (xdim \ 2) - (posy& * 16384&)
   IF yp& > (ydim \ 2) THEN
      y& = y& XOR &HFFFFFFFF
      yc& = yc& XOR &HFFFFFFFF
   END IF

   shade% = ABS(hd&) \ 4096&
   IF shade% < 0 THEN shade% = 0
   IF shade% >= numpalookups THEN shade% = numpalookups - 1
  
   p& = yp& * 80& + (xl& \ 4&): DEF SEG = &HA000
   siz& = xr& - xl&

   asm1& = xc&
   asm2& = yc&
   asm3& = siz&
   ah% = ((xr& + 1) AND 3): al% = (xl& AND 3) 'eax&
   ebx& = y&
   ch% = shade% 'ecx&
   edx& = bufplc&
   esi& = x&
   edi& = p&
  
   'dd startx&
   'dd starty&
   'dd startp&
   'dd xc4&
   'dd yc4&
   'db plane%
   'db startplane%
   ebp& = edx&
   cl% = al%
   al% = 2 ^ cl%
   plane% = al%
   startplane% = al%
   IF asm3& >= 4 THEN GOTO hchainskip1
   cl% = ah%
   al% = 2 ^ ah%
   startplane% = al%
hchainskip1:
   cl% = ch%
   startx& = esi&
   starty& = ebx&
   startp& = edi&
   eax& = asm1&
   eax& = eax& * 4&
   xc4& = eax&
   eax& = asm2&
   eax& = eax& * 4&
   yc4& = eax&
   edx& = &H3C4
   al% = 2
   OUT edx&, al%
hchain1:
   edx& = &H3C5
   al% = plane%
   OUT edx&, al%
   esi& = startx&
   ebx& = starty&
   edi& = startp&
   ax% = asm3& AND 65535
   ax% = ax% \ 4
   ch% = ax% AND 255
   IF ch% < 3 THEN GOTO hchainskip2
hchainstart1:
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   albak% = palookup%(cl%, buf%(ebp& + edx&))
   esi& = esi& + xc4&
   ebx& = ebx& + yc4&
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   ahbak% = palookup%(cl%, buf%(ebp& + edx&))
   esi& = esi& + xc4&
   ebx& = ebx& + yc4&
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   al% = palookup%(cl%, buf%(ebp& + edx&))
   esi& = esi& + xc4&
   ebx& = ebx& + yc4&
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   ah% = palookup%(cl%, buf%(ebp& + edx&))
   esi& = esi& + xc4&
   ebx& = ebx& + yc4&
   POKE edi& + 0, albak%: POKE edi& + 1, ahbak%: POKE edi& + 2, al%: POKE edi& + 3, ah%: edi& = edi& + 4
   ch% = ch% - 4
   IF ch% >= 3 THEN GOTO hchainstart1
hchainskip2:
   IF ch% < 1 THEN GOTO hchainskip3
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   al% = palookup%(cl%, buf%(ebp& + edx&))
   esi& = esi& + xc4&
   ebx& = ebx& + yc4&
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   ah% = palookup%(cl%, buf%(ebp& + edx&))
   esi& = esi& + xc4&
   ebx& = ebx& + yc4&
   POKE edi& + 0, al%: POKE edi& + 1, ah%: edi& = edi& + 2
hchainskip3:
   IF (ch% AND 1) <> 0 THEN GOTO hchainskip4
   edx& = ((esi& \ 262144) AND 63) * 64& + ((ebx& \ 262144) AND 63)
   al% = palookup%(cl%, buf%(ebp& + edx&))
   POKE edi&, al%
hchainskip4:
   eax& = asm1&
   startx& = startx& + eax&
   eax& = asm2&
   starty& = starty& + eax&
   asm3& = asm3& - 1
   plane% = plane% * 2: IF plane% = 16 THEN plane% = 1
   IF plane% <> 1 THEN GOTO hchainskip5
   startp& = startp& + 1
hchainskip5:
   al% = plane%
   IF al% <> startplane% THEN GOTO hchain1

END SUB

SUB hline (xl&, xr&, yp&, sectnum%)
   IF ((yp& = ydim \ 2) OR tilesizx%(walnume%) = 0 OR tilesizy%(walnume%) = 0) THEN EXIT SUB
   IF xl& > xr& THEN SWAP xl&, xr&
   siz& = xr& - xl& + 1
 
   IF yp& < (ydim \ 2) THEN
      zd& = 8192&  '(sector(sectnum%).z1 - posz&) * 256&
      bufplc& = 0& 'sector(sectnum%).picnum1
   ELSE
      zd& = 8192& ' (posz& - sector(sectnum%).z2) * 256&
      bufplc& = 4096& 'sector(sectnum%).picnum2
   END IF

   hd& = (zd& * 16384&) \ (xdim * ABS(ydim \ 2 - yp&))
   IF ABS(hd&) > 131072 THEN EXIT SUB
   xc& = (hd& * sintable&((2048 + ang%) AND 2047)) \ 1024&
   yc& = (hd& * sintable&((2560 + ang%) AND 2047)) \ 1024&
   x& = xc& * xl& - (xc& + yc&) * (xdim \ 2) + (posx& * 16384&)
   y& = yc& * xl& + (xc& - yc&) * (xdim \ 2) - (posy& * 16384&)
   IF yp& > (ydim \ 2) THEN
      y& = y& XOR &HFFFFFFFF
      yc& = yc& XOR &HFFFFFFFF
   END IF

   shade% = ABS(hd&) \ 4096&
   IF shade% < 0 THEN shade% = 0
   IF shade% >= numpalookups THEN shade% = numpalookups - 1
   
   pscr& = yp& * 320& + xl&: DEF SEG = &HA000
 
   FOR zx& = 1 TO siz&
      POKE pscr&, palookup%(shade%, buf%(((x& \ 262144) AND 63) * 64& + ((y& \ 262144) AND 63) + bufplc&))
      pscr& = pscr& + 1
      x& = x& + xc&
      y& = y& + yc&
   NEXT zx&
END SUB

SUB loadnewall (bufplc&, wallnum%)
   OPEN "tiles.art" FOR BINARY AS #1

   SEEK #1, 1
   GET #1, , version&
   GET #1, , numtiles&
   FOR z% = 0 TO numtiles& - 1
      GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO numtiles& - 1
      GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO numtiles& - 1
      GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      totsiz& = totsiz& + tilesizx%(z%) * tilesizy%(z%)
   NEXT z%
   SEEK #1, totsiz& + 8 + numtiles& * 8 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 63
      FOR zz% = 0 TO 63
         buf%(bufplc& + z% * 64 + zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB setupscreen
   SCREEN 13
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   pal$ = STRING$(256, 0)
   FOR z% = 0 TO numpalookups
      GET #1, , pal$
      FOR zz% = 0 TO 255
         palookup%(z%, zz%) = ASC(MID$(pal$, zz% + 1, 1))
      NEXT zz%
   NEXT z%
   CLOSE #1

END SUB

SUB unchainit
   OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) OR 8             'TRUST ME #1
   OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) OR 64           'TRUST ME #2
   OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) AND (255 - 64)  'TRUST ME #3
   OUT &H3CE, &H5: OUT &H3CF, 64                          'TRUST ME #4
   OUT &H3C4, 2: OUT &H3C5, 15
END SUB

