DECLARE SUB addboxlinum (z%)
DECLARE SUB drawline (thez%)
DECLARE FUNCTION front% (l1%, l2%)
DECLARE SUB scan (thelin%)
CONST maxlines% = 1536
DIM SHARED xa1&(maxlines%), ya1&(maxlines%), xa2&(maxlines%), ya2&(maxlines%)
DIM SHARED xr1&(maxlines%), yr1&(maxlines%), xr2&(maxlines%), yr2&(maxlines%)
DIM SHARED xb1&(maxlines%), yb1&(maxlines%), xb2&(maxlines%), yb2&(maxlines%)
DIM SHARED got%(maxlines%), theline%(maxlines%), swapped%(maxlines%)
DIM SHARED cstat%(maxlines%), z1%(maxlines%), z2%(maxlines%)
DIM SHARED picnum%(maxlines%), picnum1%(maxlines%), picnum2%(maxlines%)
DIM SHARED sintable&(2048), umost%(320), dmost%(320)
DIM SHARED sort1%(maxlines%), sort2%(maxlines%)
COMMON SHARED col%, posx&, posy&, posz&, ang%, lintalplc%, numhits%
FOR z& = 0 TO 511
   sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
NEXT z&
FOR z& = 512 TO 1023
   sintable&(z&) = sintable&(1023 - z&)
NEXT z&
FOR z& = 1024 TO 2047
   sintable&(z&) = -sintable&(z& - 1024)
NEXT z&
pag% = 0: SCREEN 7, , pag%, 1 - pag%
posz& = 160
RANDOMIZE TIMER
GOSUB loadboards
DO
   col% = 1
   LINE (0, 0)-(319, 199), 0, BF
  
   FOR z% = 0 TO numlines% - 1
	 got%(z%) = 0
   NEXT z%
   FOR z% = 0 TO 319
	 umost%(z%) = -1
	 dmost%(z%) = 200
   NEXT z%
  
   lintalplc% = 0
   FOR z% = 0 TO numlines% - 1
	 CALL addboxlinum(z%)
   NEXT z%
  
   xa1&(maxlines%) = posx& + sintable&((ang% + 256) AND 2047)
   ya1&(maxlines%) = posy& + sintable&((ang% + 1792) AND 2047)
   xa2&(maxlines%) = posx& - sintable&((ang% + 1792) AND 2047)
   ya2&(maxlines%) = posy& + sintable&((ang% + 256) AND 2047)
   xb1&(lintalplc%) = 0
   xb2&(lintalplc%) = 319
   yb1&(lintalplc%) = 1
   yb2&(lintalplc%) = 1
   theline%(lintalplc%) = maxlines%
 
   numhits% = 320
   CALL scan(lintalplc%)
  
   pag% = 1 - pag%: SCREEN 7, , pag%, 1 - pag%
   DO
	 z$ = INKEY$
   LOOP WHILE z$ = ""
   IF z$ = CHR$(0) + CHR$(72) THEN
	 posx& = posx& + sintable&((ang% + 512) AND 2047) \ 1024
	 posy& = posy& + sintable&(ang% AND 2047) \ 1024
   END IF
   IF z$ = CHR$(0) + CHR$(80) THEN
	 posx& = posx& - sintable&((ang% + 512) AND 2047) \ 1024
	 posy& = posy& - sintable&(ang% AND 2047) \ 1024
   END IF
   IF z$ = CHR$(0) + CHR$(75) THEN ang% = (ang% + 1984) AND 2047
   IF z$ = CHR$(0) + CHR$(77) THEN ang% = (ang% + 64) AND 2047
   IF z$ = "A" OR z$ = "a" THEN posz& = posz& - 4
   IF z$ = "Z" OR z$ = "z" THEN posz& = posz& + 4
LOOP WHILE z$ <> CHR$(27)
END

loadboards:
   IF COMMAND$ <> "" THEN
	 fil$ = COMMAND$
	 IF INSTR(fil$, ".") = 0 THEN fil$ = fil$ + ".dat"
   ELSE
	 fil$ = "boards2.dat"
   END IF
   OPEN fil$ FOR BINARY AS #1
   z$ = "  ": GET #1, , z$: posx& = CVI(z$)
   z$ = "  ": GET #1, , z$: posy& = CVI(z$)
   z$ = "  ": GET #1, , z$: ang% = CVI(z$)
   z$ = "  ": GET #1, , z$: numlines% = CVI(z$)
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 xa1&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 ya1&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 xa2&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 ya2&(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 picnum%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 picnum1%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 picnum2%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 z1%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 z2%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
	 cstat%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   CLOSE #1
RETURN

SUB addboxlinum (z%)
   xp1& = ((xa1&(z%) - posx&) * sintable&((ang% + 0) AND 2047) - (ya1&(z%) - posy&) * sintable&((ang% + 512) AND 2047)) \ 16384
   yp1& = ((xa1&(z%) - posx&) * sintable&((ang% + 512) AND 2047) + (ya1&(z%) - posy&) * sintable&((ang% + 0) AND 2047)) \ 16384
   xp2& = ((xa2&(z%) - posx&) * sintable&((ang% + 0) AND 2047) - (ya2&(z%) - posy&) * sintable&((ang% + 512) AND 2047)) \ 16384
   yp2& = ((xa2&(z%) - posx&) * sintable&((ang% + 512) AND 2047) + (ya2&(z%) - posy&) * sintable&((ang% + 0) AND 2047)) \ 16384
  
   good% = 7
   IF ((ABS(xp1&) <= yp1&) AND (yp1& > 0)) THEN good% = good% - 1
   IF ((ABS(xp2&) <= yp2&) AND (yp2& > 0)) THEN good% = good% - 2
   IF ((good% = 7) AND ((yp1& > 0) OR (yp2& > 0)) AND ((xp1& < 0) = (0 < xp2&))) THEN good% = 3
   yb1&(lintalplc%) = -1
   yb2&(lintalplc%) = -1
  
   IF (good% < 7) THEN
	 IF ((good% AND 3) > 0) THEN templong& = xp2& * yp1& - xp1& * yp2&
	 IF ((good% AND 1) = 0) THEN
	    IF (yp1& <> 0) THEN xb1&(lintalplc%) = 160& - ((xp1& * 160&) \ yp1&)
	    yb1&(lintalplc%) = yp1&
	 ELSE
	    j% = 0
	    IF (xp1& > 0) THEN j% = 1
	    IF (((xp1& < 0) = (0 < xp2&)) AND ((yp1& < 0) = (0 < yp2&))) THEN
		  IF (ABS(xp1& * yp2&) < ABS(xp2& * yp1&)) THEN j% = 1
	    END IF
	    IF j% = 0 THEN
		  xb1&(lintalplc%) = 319
		  templong1& = yp2& - yp1& + xp2& - xp1&
		  IF templong1& <> 0 THEN yb1&(lintalplc%) = templong& \ templong1&
	    ELSE
		  xb1&(lintalplc%) = 0
		  templong1& = yp1& - yp2& + xp2& - xp1&
		  IF templong1& <> 0 THEN yb1&(lintalplc%) = templong& \ templong1&
	    END IF
	 END IF
	 IF ((good% AND 2) = 0) THEN
	    IF (yp2& <> 0) THEN xb2&(lintalplc%) = 160& - ((xp2& * 160&) \ yp2&)
	    yb2&(lintalplc%) = yp2&
	 ELSE
	    j% = 0
	    IF (xp2& > 0) THEN j% = 1
	    IF (((xp1& < 0) = (0 < xp2&)) AND ((yp1& < 0) = (0 < yp2&))) THEN
		  IF (ABS(xp2& * yp1&) < ABS(xp1& * yp2&)) THEN j% = 0
	    END IF
	    IF j% = 0 THEN
		  xb2&(lintalplc%) = 319
		  templong1& = yp2& - yp1& + xp2& - xp1&
		  IF templong1& <> 0 THEN yb2&(lintalplc%) = templong& \ templong1&
	    ELSE
		  xb2&(lintalplc%) = 0
		  templong1& = yp1& - yp2& + xp2& - xp1&
		  IF templong1& <> 0 THEN yb2&(lintalplc%) = templong& \ templong1&
	    END IF
	 END IF
	 IF (yb1&(lintalplc%) > 0) AND (yb2&(lintalplc%) > 0) THEN
	    swapped%(lintalplc%) = 0
	    IF (xb1&(lintalplc%) > xb2&(lintalplc%)) THEN
		  SWAP xb1&(lintalplc%), xb2&(lintalplc%)
		  SWAP yb1&(lintalplc%), yb2&(lintalplc%)
		  swapped%(lintalplc%) = 1
	    END IF
	    IF cstat%(z%) <> 3 OR swapped%(lintalplc%) = 0 THEN
		  xr1&(lintalplc%) = xp1&
		  yr1&(lintalplc%) = yp2&
		  xr2&(lintalplc%) = xp1&
		  yr2&(lintalplc%) = yp2&
		  yb1&(lintalplc%) = 65536 \ yb1&(lintalplc%)
		  yb2&(lintalplc%) = 65536 \ yb2&(lintalplc%)
		  theline%(lintalplc%) = z%
		  lintalplc% = lintalplc% + 1
	    END IF
	 END IF
   END IF
END SUB

SUB drawline (thez%)
   col% = (picnum%(theline%(thez%)) MOD 7) + 9
   FOR x& = xb1&(thez%) TO xb2&(thez%)
	 IF umost%(x&) < dmost%(x&) THEN
	    IF xb2&(thez%) > xb1&(thez%) THEN
		  h& = (yb1&(thez%) * (xb2&(thez%) - x&) + yb2&(thez%) * (x& - xb1&(thez%))) \ (xb2&(thez%) - xb1&(thez%))
	    ELSE
		  h& = yb1&(thez%)
	    END IF
	    y1& = 100 + (h& * (z1%(theline%(thez%)) - posz&)) \ 1024
	    y2& = 100 + (h& * (z2%(theline%(thez%)) - posz&)) \ 1024
	    IF y1& < umost%(x&) THEN y1& = umost%(x&)
	    IF y1& > dmost%(x&) THEN y1& = dmost%(x&)
	    IF y2& < umost%(x&) THEN y2& = umost%(x&)
	    IF y2& > dmost%(x&) THEN y2& = dmost%(x&)
	   
	    IF cstat%(theline%(thez%)) = 3 THEN
		  IF y1& - 2 >= umost%(x&) THEN LINE (x&, umost%(x&) + 1)-(x&, y1& - 1), (picnum1%(theline%(thez%)) MOD 7) + 1
		  IF y2& + 2 <= dmost%(x&) THEN LINE (x&, dmost%(x&) - 1)-(x&, y2& + 1), (picnum2%(theline%(thez%)) MOD 7) + 1
	    END IF
	    IF cstat%(theline%(thez%)) = 6 THEN
		  IF swapped%(thez%) = 0 THEN
			IF y2& + 2 <= dmost%(x&) THEN LINE (x&, dmost%(x&) - 1)-(x&, y2& + 1), (picnum2%(theline%(thez%)) MOD 7) + 1
		  ELSE
			IF y1& + 2 <= dmost%(x&) THEN LINE (x&, dmost%(x&) - 1)-(x&, y1& + 1), (picnum1%(theline%(thez%)) MOD 7) + 1
		  END IF
	    END IF
	    IF cstat%(theline%(thez%)) = 9 THEN
		  IF swapped%(thez%) = 0 THEN
			IF y1& - 2 >= umost%(x&) THEN LINE (x&, umost%(x&) + 1)-(x&, y1& - 1), (picnum1%(theline%(thez%)) MOD 7) + 1
		  ELSE
			IF y2& - 2 >= umost%(x&) THEN LINE (x&, umost%(x&) + 1)-(x&, y2& - 1), (picnum2%(theline%(thez%)) MOD 7) + 1
		  END IF
	    END IF
	   
	    IF swapped%(thez%) = 0 THEN
		  IF x& = xb1&(thez%) OR x& = xb2&(thez%) THEN
			LINE (x&, y1&)-(x&, y2&), col% - 8
		  ELSE
			LINE (x&, y1&)-(x&, y2&), col%
			PSET (x&, y1&), col% - 8
			PSET (x&, y2&), col% - 8
		  END IF
	    END IF
	   
	    IF cstat%(theline%(thez%)) = 3 THEN
		  umost%(x&) = 100
		  dmost%(x&) = 100
	    END IF
	    IF cstat%(theline%(thez%)) = 6 THEN
		  IF swapped%(thez%) = 1 THEN PSET (x&, y1&), col% - 8
		  dmost%(x&) = y1&
	    END IF
	    IF cstat%(theline%(thez%)) = 9 THEN
		  IF swapped%(thez%) = 1 THEN PSET (x&, y2&), col% - 8
		  umost%(x&) = y2&
	    END IF

	    IF umost%(x&) >= dmost%(x&) THEN numhits% = numhits% - 1
	END IF
   NEXT x&

   'lintalplc% = lintalplc% - 1
   'xb1&(thez%) = xb1&(lintalplc%)
   'yb1&(thez%) = yb1&(lintalplc%)
   'xb2&(thez%) = xb2&(lintalplc%)
   'yb2&(thez%) = yb2&(lintalplc%)
   'theline%(thez%) = theline%(lintalplc%)
   'swapped%(thez%) = swapped%(lintalplc%)

END SUB

FUNCTION front% (l1%, l2%)
  
   templong1& = (xa1&(l1%) - posx&) * (ya1&(l2%) - posy&) - (xa1&(l2%) - posx&) * (ya1&(l1%) - posy&)
   templong2& = (xa1&(l1%) - posx&) * (ya2&(l2%) - posy&) - (xa2&(l2%) - posx&) * (ya1&(l1%) - posy&)
   templong3& = (xa2&(l1%) - posx&) * (ya1&(l2%) - posy&) - (xa1&(l2%) - posx&) * (ya2&(l1%) - posy&)
   templong4& = (xa2&(l1%) - posx&) * (ya2&(l2%) - posy&) - (xa2&(l2%) - posx&) * (ya2&(l1%) - posy&)
   IF templong1& = 0 THEN
	 IF (templong2& <= 0) = (templong3& <= 0) AND (templong3& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSEIF templong2& = 0 THEN
	 IF (templong1& <= 0) = (templong3& <= 0) AND (templong3& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSEIF templong3& = 0 THEN
	 IF (templong1& <= 0) = (templong2& <= 0) AND (templong2& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSEIF templong4& = 0 THEN
	 IF (templong1& <= 0) = (templong2& <= 0) AND (templong2& <= 0) = (templong3& <= 0) THEN front% = -1: EXIT FUNCTION
   ELSE
	 IF (templong1& <= 0) = (templong2& <= 0) AND (templong1& <= 0) = (templong3& <= 0) AND (templong1& <= 0) = (templong4& <= 0) THEN front% = -1: EXIT FUNCTION
   END IF

   templong1& = (xa1&(l2%) - xa1&(l1%)) * (ya2&(l1%) - ya1&(l1%)) - (xa2&(l1%) - xa1&(l1%)) * (ya1&(l2%) - ya1&(l1%))    'p1(l2) vs. l1
   templong2& = (xa2&(l2%) - xa1&(l1%)) * (ya2&(l1%) - ya1&(l1%)) - (xa2&(l1%) - xa1&(l1%)) * (ya2&(l2%) - ya1&(l1%))    'p2(l2) vs. l1
   IF templong1& = 0 THEN templong1& = templong2&
   IF templong2& = 0 THEN templong2& = templong1&
   IF (templong1& < 0) = (templong2& < 0) THEN
	 templong0& = (posx& - xa1&(l1%)) * (ya2&(l1%) - ya1&(l1%)) - (xa2&(l1%) - xa1&(l1%)) * (posy& - ya1&(l1%))         'pos vs. l1
	 IF (templong1& < 0) = (templong0& < 0) THEN front% = l2% ELSE front% = l1%
	 EXIT FUNCTION
   END IF
 
   templong1& = (xa1&(l1%) - xa1&(l2%)) * (ya2&(l2%) - ya1&(l2%)) - (xa2&(l2%) - xa1&(l2%)) * (ya1&(l1%) - ya1&(l2%)) 'p1(l1) vs. l2
   templong2& = (xa2&(l1%) - xa1&(l2%)) * (ya2&(l2%) - ya1&(l2%)) - (xa2&(l2%) - xa1&(l2%)) * (ya2&(l1%) - ya1&(l2%)) 'p2(l1) vs. l2
   IF templong1& = 0 THEN templong1& = templong2&
   IF templong2& = 0 THEN templong2& = templong1&
   IF (templong1& < 0) = (templong2& < 0) THEN
	 templong0& = (posx& - xa1&(l2%)) * (ya2&(l2%) - ya1&(l2%)) - (xa2&(l2%) - xa1&(l2%)) * (posy& - ya1&(l2%))      'pos vs. l2
	 IF (templong1& < 0) = (templong0& < 0) THEN front% = l1% ELSE front% = l2%
	 EXIT FUNCTION
   END IF

   front% = -2: EXIT FUNCTION
  
END FUNCTION

SUB scan (thelin%)
  
   sortcnt% = 0
  
   sort1%(sortcnt%) = thelin%: sort2%(sortcnt%) = 0

   WHILE sortcnt% >= 0
	 got%(sort1%(sortcnt%)) = 1
	 WHILE sort2%(sortcnt%) < lintalplc%
	    IF got%(sort2%(sortcnt%)) = 0 THEN
		  IF front%(theline%(sort2%(sortcnt%)), theline%(sort1%(sortcnt%))) = theline%(sort2%(sortcnt%)) THEN
			sortcnt% = sortcnt% + 1
			sort1%(sortcnt%) = sort2%(sortcnt% - 1)
			sort2%(sortcnt%) = 0
			got%(sort2%(sortcnt% - 1)) = 1
		  END IF
	    END IF
	    sort2%(sortcnt%) = sort2%(sortcnt%) + 1
	 WEND
	 CALL drawline(sort1%(sortcnt%))
	 sortcnt% = sortcnt% - 1
   WEND


   'IF numhits% <= 0 THEN EXIT SUB
   'got%(thelin%) = 1
   '
   'FOR i% = 0 TO lintalplc% - 1
   '   IF got%(i%) = 0 THEN
   '      IF front%(theline%(i%), theline%(thelin%)) = theline%(i%) THEN
   '         CALL scan(i%)
   '         IF numhits% <= 0 THEN EXIT SUB
   '      END IF
   '   END IF
   'NEXT i%
   '
   'call drawline (thelin%)

END SUB

