#define MAIN                 //For variable declarations (see top of build.h)
#include "build.h"           //Allows you to access variables from build.
main()
{
	int i;

	loadpics("pics.dat");     //Load pics.dat into the artwork buffer
	loadboard("boards.dat");  //Load boards.dat into the board buffer
	setgamemode();            //Set to 320*200*256 mode with proper palette
	initengine();             //Install Interrupt vectors, setup mouse, etc.

	load2board("2board.dat");
	for(i=0;i<2048;i+=8)
		draw2board(16777216L*32L,16777216L*32L-(((long)i)<<15),4096L,i);

	while (keystatus[1] == 0) //Beginning of main loop (while ESC not pressed)
	{
		drawscreen(0);         //Draw the screen! (The technology lies here!)
		engineinput();         //Check arrow keys, mouse, and move proplerly
		nextpage();            //Make newly drawn screen visible
	}
	uninitengine();           //Restore Interrupt vectors, free buffers, etc.
	setvmode(0x3);            //Set back to text mode
}

