#define MAIN
#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#include "build.h"

static char tempbuf[64000];

#pragma aux hlinscrew =\
	"push ebp",\
	"beghlinscrew: mov ebp, ebx",\
	"shr ebp, 16",\
	"add ebx, edx",\
	"mov al, byte ptr [esi+ebp]",\
	"mov ebp, ebx",\
	"shr ebp, 16",\
	"mov ah, byte ptr [esi+ebp]",\
	"add ebx, edx",\
	"mov word ptr [edi], ax",\
	"mov ebp, ebx",\
	"shr ebp, 16",\
	"add ebx, edx",\
	"mov al, byte ptr [esi+ebp]",\
	"mov ebp, ebx",\
	"shr ebp, 16",\
	"mov ah, byte ptr [esi+ebp]",\
	"add ebx, edx",\
	"mov word ptr [edi+2], ax",\
	"add edi, 4",\
	"loop beghlinscrew",\
	"pop ebp",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux drawpixel =\
	"mov ah, al",\
	"mov word ptr [edi], ax",\
	parm [edi][eax]\

main(int argc,char **argv)
{
	short int picnum, heinum, x, y, siz, type;
	long int i, j, k, templong, y1, y2, y3, y4, vel, scale, extrashift, p;

	type = 2;
	if (argc == 2)
	{
		type = atoi(argv[1]);
		if ((type < 0) || (type > 4))
			type = 0;
	}
	for(i=0;i<320;i++)
	{
		umost[i] = 0;
		dmost[i] = 200;
	}
	loadtables();
	loadpics("pics.dat");

	posx = 0;
	posy = 0;
	posz = 8192;
	ang = 0;
	picnum = 0;
	heinum = 55;
	x = 160;
	y = 100;
	siz = 128;
	scale = 1024;
	extrashift = 0;

	setgamemode();
	initengine();
	resettiming();
	while (keystatus[1] == 0)
	{
		if (keystatus[0x13] > 0)
			resettiming();
		if ((keystatus[0x4e] > 0) && (picnum < maxtiles-1))
		{
			picnum++;
			keystatus[0x4e] = 0;
		}
		if ((keystatus[0x4a] > 0) && (picnum > 0))
		{
			picnum--;
			keystatus[0x4a] = 0;
		}
		if (type == 0)
		{
			if (keystatus[0xcb] > 0) ang -= 10;
			if (keystatus[0xcd] > 0) ang += 10;
			vel = 0;
			if (keystatus[0xc8] > 0) vel = 6;
			if (keystatus[0xd0] > 0) vel = -6;
			posx += ((sintable[(2560+ang)&2047]*vel)>>12);
			posy += ((sintable[(2048+ang)&2047]*vel)>>12);
			if ((keystatus[0x1e] > 0) && (posz > 128)) posz -= 128;
			if ((keystatus[0x2c] > 0) && (posz < 16256)) posz += 128;
			for(i=0;i<100;i++)
				hline(0,319,i,posz,picnum,(char)0);
			for(i=100;i<200;i++)
				hline(0,319,i,16383-posz,picnum,(char)0);
		}
		else if (type == 1)
		{
			for(i=0;i<320;i+=2)
			{
				y1 = -16-(sintable[((numframes<<4)+(i<<4))&2047]>>10);
				y2 = 216+(sintable[(2560-((i*23)-(numframes<<6)))&2047]>>10);
				y3 = -16-(sintable[((numframes<<4)+((i+1)<<4))&2047]>>10);
				y4 = 216+(sintable[(2560-(((i+1)*23)-(numframes<<6)))&2047]>>10);
				/*if ((i&2) == 0)
				{
					vline(i,y1<<16,y2<<16,(y2-y1)<<18,picnum,i<<6,(char)0);
					vline(i+1,y3<<16,y4<<16,(y4-y3)<<18,picnum,(i+1)<<6,(char)0);
				}
				else*/
				vline2(i,y1<<16,y2<<16,y3<<16,y4<<16,(y2-y1)<<18,(y4-y3)<<18,picnum,i<<6,(i+1)<<6,(char)0);
			}
		}
		else if (type == 2)
		{
			if (keystatus[0xcb] > 0) x--;
			if (keystatus[0xcd] > 0) x++;
			if (keystatus[0xc8] > 0) y--;
			if (keystatus[0xd0] > 0) y++;
			if ((keystatus[0xc9] > 0) && (siz > 1)) siz--;
			if (keystatus[0xd1] > 0) siz++;
			//clearvscreen();
			drawsprite((long)x,(long)y,(long)siz,picnum,(char)0);
		}
		else if (type == 3)
		{
			if (keystatus[0xcb] > 0) extrashift = 1;
			if (keystatus[0xcd] > 0) extrashift = 0;
			if ((keystatus[0x1e] > 0) && (scale < 65536))
				scale += (scale>>4);
			if ((keystatus[0x2c] > 0) && (scale > 512))
			{
				scale -= (scale>>4);
				if (scale < 512)
					scale = 512;
			}
			frameplace = ((long)&tempbuf);
			for(i=0;i<320;i+=2)
			{
				y1 = -32-(sintable[((numframes<<4)+(i<<4))&2047]/scale);
				y2 = 232+(sintable[(2560-((i*23)-(numframes<<6)))&2047]/scale);
				y3 = -32-(sintable[((numframes<<4)+((i+1)<<4))&2047]/scale);
				y4 = 232+(sintable[(2560-(((i+1)*23)-(numframes<<6)))&2047]/scale);
				vline2(i,y1<<16,y2<<16,y3<<16,y4<<16,(y2-y1)<<18,(y4-y3)<<18,picnum,i<<(5+extrashift),(i+1)<<(5+extrashift),(char)0);
			}
			frameplace = 0x000a0000;
			p = 0L;
			for(i=0;i<200;i++)
			{
				y1 = 32-(sintable[((numframes<<4)+(numframes<<3)+(i*14))&2047]/scale);
				y2 = 288+(sintable[(2560-((i*17)-(numframes<<5)))&2047]/scale);
				hlinscrew(0L,y1<<16,80L,((y2-y1)<<16)/320L,((long)&tempbuf)+p,frameplace+p);
				p += 320L;
			}
		}
		else if (type == 4)
		{
			for(i=0;i<xdim;i++)
			{
				umost[i] = 0;
				dmost[i] = 200;
				grouvline((long)i,((long)48)<<8,65536L*16384L,65536L*512L,picnum,heinum,0);
				finishline(i);
			}
			if ((keystatus[0xc9] > 0) && (heinum < maxtiles-1))
			{
				heinum++;
				keystatus[0xc9] = 0;
			}
			if ((keystatus[0xd1] > 0) && (heinum > 0))
			{
				heinum--;
				keystatus[0xd1] = 0;
			}
			if (keystatus[0xcb] > 0) ang = (ang+2016)&2047;
			if (keystatus[0xcd] > 0) ang = (ang+32)&2047;
			vel = 0;
			if (keystatus[0xc8] > 0) vel = 6;
			if (keystatus[0xd0] > 0) vel = -6;
			posx += ((sintable[(2560+ang)&2047]*vel)>>12);
			posy += ((sintable[(2048+ang)&2047]*vel)>>12);
			if ((keystatus[0x1e] > 0) && (posz > 128)) posz -= 128;
			if ((keystatus[0x2c] > 0) && (posz < 16256)) posz += 128;
		}
		nextpage();
	}
	uninitengine();
	showengineinfo(0);
}

finishline(i)
long i;
{
	long j, plc;

	plc = i+0x000a0000;
	for(j=0;j<=dmost[i];j++)
	{
		drawpixel(plc,0L);
		plc += 320L;
	}
	dmost[i] = 0;
}
