DECLARE SUB cliploadlocal ()
DECLARE SUB clipmove (vel&)
DECLARE SUB loadstuff (nowx&, nowy&)
DECLARE SUB drawline (x0%, y0%, x1%, y1%, col%)
COMMON SHARED posx&, posy&, nowx&, nowy&, ang%

COMMON SHARED numlines%, numpics%, clipbufsiz%
numpics% = 64
clipbufsiz% = 128
numlines% = 2048

DIM SHARED clipbuf%(clipbufsiz%, clipbufsiz%)
DIM SHARED x1%(numlines%), y1%(numlines%), x2%(numlines%), y2%(numlines%)
DIM SHARED picnum%(numlines%), picnum1%(numlines%), picnum2%(numlines%)
DIM SHARED heinum1%(numlines%), heinum2%(numlines%), repeat%(numlines%)
DIM SHARED shade%(numlines%), shade1%(numlines%), shade2%(numlines%)
DIM SHARED z1%(numlines%), z2%(numlines%), zosc%(numlines%), cstat%(numlines%)
DIM SHARED lintaladdr%(4097), lintal%(12288), tempbuf%(numlines%)
DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())

GOSUB loadboards
'GOSUB drawboard
'DO: LOOP WHILE INKEY$ = ""
SOUND 262, 1
GOSUB convertboard
posx& = posx% * 32: posy& = posy% * 32: ang% = 0
DO
   GOSUB choosebox
   IF z$ = CHR$(13) THEN GOSUB showbox
LOOP WHILE z$ <> CHR$(27)
SCREEN 12: CLS
PRINT "Lintalcnt = "; lintalcnt%;
END

convertboard:
   gap% = numlines% \ 2
   DO
      FOR z% = 0 TO numlines% - gap% - 1
         IF x1%(z%) > x1%(z% + gap%) THEN
            temp% = z%
            DO WHILE x1%(temp%) > x1%(temp% + gap%)
               SWAP x1%(temp%), x1%(temp% + gap%)
               SWAP y1%(temp%), y1%(temp% + gap%)
               SWAP x2%(temp%), x2%(temp% + gap%)
               SWAP y2%(temp%), y2%(temp% + gap%)
               SWAP picnum%(temp%), picnum%(temp% + gap%)
               SWAP picnum1%(temp%), picnum1%(temp% + gap%)
               SWAP picnum2%(temp%), picnum2%(temp% + gap%)
               SWAP heinum1%(temp%), heinum1%(temp% + gap%)
               SWAP heinum2%(temp%), heinum2%(temp% + gap%)
               SWAP shade%(temp%), shade%(temp% + gap%)
               SWAP shade1%(temp%), shade1%(temp% + gap%)
               SWAP shade2%(temp%), shade2%(temp% + gap%)
               SWAP z1%(temp%), z1%(temp% + gap%)
               SWAP z2%(temp%), z2%(temp% + gap%)
               SWAP zosc%(temp%), zosc%(temp% + gap%)
               SWAP repeat%(temp%), repeat%(temp% + gap%)
               SWAP cstat%(temp%), cstat%(temp% + gap%)
               temp% = temp% - gap%
               IF temp% < 0 THEN EXIT DO
            LOOP
         END IF
      NEXT z%
      gap% = gap% \ 2
   LOOP WHILE gap% > 0
   SOUND 523, 1
  
   totcnt% = 0
   FOR z% = 0 TO 4096
      lintaladdr%(z%) = 0
   NEXT z%
   FOR z% = 0 TO 64
      tempbuf%(z%) = 0
   NEXT z%
   lintalcnt% = 0
   FOR z% = 0 TO numlines% - 1
      IF x1%(z%) = x2%(z%) THEN
         x% = x1%(z%) \ 32
         IF y1%(z%) < y2%(z%) THEN
            y% = y1%(z%) \ 32
            lasty% = (y2%(z%) - 1) \ 32
         ELSE
            y% = y2%(z%) \ 32
            lasty% = (y1%(z%) - 1) \ 32
         END IF
         DO
            GOSUB addit
            y% = y% + 1
         LOOP WHILE y% <= lasty%
      ELSEIF y1%(z%) = y2%(z%) THEN
         y% = y1%(z%) \ 32
         IF x1%(z%) < x2%(z%) THEN
            x% = x1%(z%) \ 32
            lastx% = (x2%(z%) - 1) \ 32
         ELSE
            x% = x2%(z%) \ 32
            lastx% = (x1%(z%) - 1) \ 32
         END IF
         DO
            GOSUB addit
            x% = x% + 1
         LOOP WHILE x% <= lastx%
      ELSE
         clipx% = -1: clipy% = -1
         IF x2%(z%) > x1%(z%) AND (x2%(z%) AND 31) = 0 THEN clipx% = x2%(z%)
         IF y2%(z%) > y1%(z%) AND (y2%(z%) AND 31) = 0 THEN clipy% = y2%(z%)
         IF x1%(z%) > x2%(z%) AND (x1%(z%) AND 31) = 0 THEN clipx% = x1%(z%)
         IF y1%(z%) > y2%(z%) AND (y1%(z%) AND 31) = 0 THEN clipy% = y1%(z%)
         xz% = -1: yz% = -1
         FOR zx% = 0 TO 16 STEP 2
            oldxz% = xz%: oldyz% = yz%
            xz% = (x1%(z%) * zx% + x2%(z%) * (16 - zx%)) \ 16
            yz% = (y1%(z%) * zx% + y2%(z%) * (16 - zx%)) \ 16
            IF (xz% OR 31) <> (oldxz% OR 31) OR (yz% OR 31) <> (oldyz% OR 31) THEN
               IF xz% <> clipx% AND yz% <> clipy% THEN
                  x% = xz% \ 32
                  y% = yz% \ 32
                  GOSUB addit
               END IF
            END IF
         NEXT zx%
      END IF
   NEXT z%
   FOR z% = 1 TO 4096
      lintaladdr%(z%) = lintaladdr%(z% - 1) + lintaladdr%(z%)
   NEXT z%
RETURN

choosebox:
   SCREEN 0: WIDTH 80, 50
   DEF SEG = &HB800
   OUT &H3D4, &H13: OUT &H3D5, 65
   COLOR 7, 0
   POKE 0, ASC(""): POKE 256, ASC("")
   FOR z% = 2 TO 254 STEP 2
      IF (z% AND 3) = 0 THEN POKE z%, ASC("") ELSE POKE z%, ASC("")
   NEXT z%
   FOR zz% = 1 TO 127
      px& = zz% * 260&
      IF (zz% AND 1) = 0 THEN
         POKE px&, ASC(""): POKE px& + 256, ASC("")
         FOR z% = 2 TO 254 STEP 2
            IF (z% AND 3) = 0 THEN POKE px& + z%, ASC("") ELSE POKE px& + z%, ASC("")
         NEXT z%
      ELSE
         POKE px&, ASC(""): POKE px& + 256, ASC("")
         FOR z% = 4 TO 252 STEP 4
            POKE px& + z%, ASC("")
         NEXT z%
      END IF
   NEXT zz%
   COLOR 14, 6
   FOR z% = 1 TO 4096
      leng% = lintaladdr%(z%) - lintaladdr%(z% - 1)
      IF leng% > 0 THEN
         x% = (z% - 1) AND 63
         y% = (z% - 1) \ 64
         px& = (x% * 2 + 1) * 260& + y% * 4 + 2
         IF leng% < 9 THEN
            POKE px&, leng% + 48
         ELSE
            POKE px&, leng% + 55
         END IF
      END IF
   NEXT z%
   DO
      z$ = INKEY$
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      mousx% = regs%(2) \ 2
      mousy% = regs%(3) \ 2
      POKE ((posy& \ 1024) * 2 + 1) * 260& + (posx& \ 1024) * 4 + 3, 7
      IF z$ = CHR$(0) + CHR$(75) THEN posx& = posx& - 1024
      IF z$ = CHR$(0) + CHR$(77) THEN posx& = posx& + 1024
      IF z$ = CHR$(0) + CHR$(72) THEN posy& = posy& - 1024
      IF z$ = CHR$(0) + CHR$(80) THEN posy& = posy& + 1024
      posx& = posx& + mousx% * 32
      posy& = posy& + mousy% * 32
      IF posx& < 0 THEN posx& = 0
      IF posy& < 0 THEN posy& = 0
      IF posx& > 65535 THEN posx& = 65535
      IF posy& > 65535 THEN posy& = 65535
      POKE ((posy& \ 1024) * 2 + 1) * 260& + (posx& \ 1024) * 4 + 3, 39
      thex& = posx& \ 64 - 200: they& = posy& \ 64 - 200
      IF thex& < 0 THEN thex& = 0
      IF they& < 0 THEN they& = 0
      IF thex& > 392 THEN thex& = 392
      IF they& > 512 THEN they& = 512
      p& = (they& \ 8) * 130& + (thex& \ 8)
      WAIT &H3DA, &H8, &H8
      OUT &H3D4, &HC: OUT &H3D5, p& \ 256
      OUT &H3D4, &HD: OUT &H3D5, p& AND 255
      WAIT &H3DA, &H8
      OUT &H3C0, &H33: OUT &H3C0, thex& AND 7
      OUT &H3D4, &H8: OUT &H3D5, they& AND 7
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27)
RETURN

loadboards:
   IF COMMAND$ <> "" THEN
      fil$ = COMMAND$
      IF INSTR(fil$, ".") = 0 THEN fil$ = fil$ + ".dat"
   ELSE
      fil$ = "boards.dat"
   END IF
   OPEN fil$ FOR BINARY AS #1
   z$ = "  ": GET #1, , z$: posx% = CVI(z$)
   z$ = "  ": GET #1, , z$: posy% = CVI(z$)
   z$ = "  ": GET #1, , z$: ang% = CVI(z$)
   z$ = "  ": GET #1, , z$: numlines% = CVI(z$)
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      x1%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      y1%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      x2%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      y2%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      picnum%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      picnum1%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      picnum2%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      heinum1%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines% * 2, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      heinum2%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      shade%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
     shade1%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      shade2%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      z1%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      z2%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      cstat%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      zosc%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   z$ = STRING$(numlines%, 0): GET #1, , z$
   FOR z% = 0 TO numlines% - 1
      repeat%(z%) = ASC(MID$(z$, z% + 1, 1))
   NEXT z%
   CLOSE #1
RETURN

drawboard:
   regs%(0) = &H38: CALL int86old(&H10, regs%(), regs%())
   FOR z% = 0 TO 1023 STEP 16
      CALL drawline(z%, 0, z%, 1023, 7)
   NEXT z%
   FOR z% = 0 TO 1023 STEP 16
      CALL drawline(0, z%, 1023, z%, 8)
   NEXT z%
   FOR z% = 0 TO numlines% - 1
      CALL drawline(x1%(z%) \ 2, y1%(z%) \ 2, x2%(z%) \ 2, y2%(z%) \ 2, (picnum%(z%) MOD 7) + 9)
      CALL drawline(x1%(z%) \ 2 + 1, y1%(z%) \ 2, x2%(z%) \ 2 + 1, y2%(z%) \ 2, (picnum%(z%) MOD 7) + 9)
      CALL drawline(x1%(z%) \ 2, y1%(z%) \ 2 + 1, x2%(z%) \ 2, y2%(z%) \ 2 + 1, (picnum%(z%) MOD 7) + 9)
   NEXT z%
RETURN
    
addit:
   p% = x% * 64 + y% + 1
   hereplc% = 0
   FOR zz% = 0 TO x% - 1
      hereplc% = hereplc% + tempbuf%(zz%)
   NEXT zz%
   zxz% = x% * 64
   FOR zz% = zxz% + 1 TO p% - 1
      hereplc% = hereplc% + lintaladdr%(zz%)
   NEXT zz%
   FOR zz% = lintalcnt% TO hereplc% + 1 STEP -1
      lintal%(zz%) = lintal%(zz% - 1)
   NEXT zz%
   lintaladdr%(p%) = lintaladdr%(p%) + 1
   tempbuf%(x%) = tempbuf%(x%) + 1
   lintal%(hereplc%) = z%
   lintalcnt% = lintalcnt% + 1
RETURN

showbox:
   pag% = 0
   SCREEN 7, , pag%, 1 - pag%
   nowx& = ((posx& - 256) AND &HFC00)
   nowy& = ((posy& - 256) AND &HFC00)
   xoffses& = 160
   yoffses& = 100
   CALL cliploadlocal
   DO
      LINE (0, 0)-(319, 199), 1, BF

      xoffs& = posx& \ 32 - xoffses&
      yoffs& = posy& \ 32 - yoffses&
     
      FOR xz& = posx& \ 32 - xoffses& TO posx& \ 32 + xoffses& + 32 STEP 32
         LINE ((xz& AND &HFFE0) - xoffs&, 0)-((xz& AND &HFFE0) - xoffs&, 199), 0
      NEXT xz&
      FOR yz& = posy& \ 32 - yoffses& TO posy& \ 32 + yoffses& + 32 STEP 32
         LINE (0, (yz& AND &HFFE0) - yoffs&)-(319, (yz& AND &HFFE0) - yoffs&), 0
      NEXT yz&
     
      LINE (xoffses& - 3, yoffses& - 3)-(xoffses& + 3, yoffses& + 3), 6, BF
      LINE (xoffses&, yoffses&)-(xoffses& + 7 * COS(ang% * 3.141592 / 1024), yoffses& + 7 * SIN(ang% * 3.141592 / 1024)), 15
      LINE (xoffses&, yoffses&)-(xoffses& + 256 * COS((ang% + 256) * 3.141592 / 1024), yoffses& + 256 * SIN((ang% + 256) * 3.141592 / 1024)), 13
      LINE (xoffses&, yoffses&)-(xoffses& + 256 * COS((ang% - 256) * 3.141592 / 1024), yoffses& + 256 * SIN((ang% - 256) * 3.141592 / 1024)), 13

      FOR z% = 0 TO numlines% - 1
         tempbuf%(z%) = 0
      NEXT z%
      FOR xz& = nowx& TO nowx& + 1024 STEP 1024
         FOR yz& = nowy& TO nowy& + 1024 STEP 1024
            p% = (xz& \ 1024) * 64 + (yz& \ 1024)
            FOR z% = lintaladdr%(p%) TO lintaladdr%(p% + 1) - 1
               linti% = lintal%(z%)
               IF tempbuf%(linti%) = 0 THEN
                  IF (cstat%(linti%) AND 15) = 3 THEN col% = 15 ELSE col% = 12
                  LINE (x1%(linti%) - xoffs&, y1%(linti%) - yoffs&)-(x2%(linti%) - xoffs&, y2%(linti%) - yoffs&), col%
                  tempbuf%(linti%) = 1
               END IF
            NEXT z%
         NEXT yz&
      NEXT xz&
      FOR xz& = posx& \ 32 - xoffses& TO posx& \ 32 + xoffses& + 32 STEP 32
         FOR yz& = posy& \ 32 - yoffses& TO posy& \ 32 + yoffses& + 32 STEP 32
            p% = (xz& \ 32) * 64 + (yz& \ 32)
            FOR z% = lintaladdr%(p%) TO lintaladdr%(p% + 1) - 1
               linti% = lintal%(z%)
               IF tempbuf%(linti%) = 0 THEN
                  LINE (x1%(linti%) - xoffs&, y1%(linti%) - yoffs&)-(x2%(linti%) - xoffs&, y2%(linti%) - yoffs&), 2
                  tempbuf%(linti%) = 1
               END IF
            NEXT z%
         NEXT yz&
      NEXT xz&
     
      pag% = 1 - pag%
      SCREEN 7, , pag%, 1 - pag%
     
      DO
         z$ = INKEY$
      LOOP WHILE z$ = ""
      IF z$ = CHR$(0) + CHR$(75) THEN ang% = ((ang% + 2016) AND 2047)
      IF z$ = CHR$(0) + CHR$(77) THEN ang% = ((ang% + 32) AND 2047)
      IF z$ = CHR$(0) + CHR$(72) THEN CALL clipmove(16)
      IF z$ = CHR$(0) + CHR$(80) THEN CALL clipmove(-16)
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27)
RETURN

SUB cliploadlocal
   FOR i% = 0 TO numlines% - 1
      tempbuf%(i%) = 0
   NEXT i%
 
   FOR i% = 0 TO 127
      FOR j% = 0 TO 127
         clipbuf%(i%, j%) = 0
      NEXT j%
   NEXT i%
   FOR xz& = nowx& TO nowx& + 1024 STEP 1024
      FOR yz& = nowy& TO nowy& + 1024 STEP 1024
         p% = (xz& \ 1024) * 64 + (yz& \ 1024)
         FOR i% = lintaladdr%(p%) TO lintaladdr%(p% + 1) - 1
            linti% = lintal%(i%)
            IF tempbuf%(linti%) = 0 AND ((ABS(z1%(linti%) - z2%(linti%)) > 32 AND (cstat%(linti%) AND 15) = 6) OR (cstat%(linti%) AND 15) = 3 OR (cstat%(linti%) AND 15) = 0) THEN
               tempbuf%(linti%) = 1
               xc1% = x1%(linti%) * 2 - nowx& \ 16
               yc1% = y1%(linti%) * 2 - nowy& \ 16
               xc2% = x2%(linti%) * 2 - nowx& \ 16
               yc2% = y2%(linti%) * 2 - nowy& \ 16

               incr1& = xc2% - xc1%
               incr2& = yc2% - yc1%
               IF incr1& < 0 THEN
                  xdir% = -1
                  incr1& = -incr1&
               ELSEIF incr1& > 0 THEN
                  xdir% = 1
               ELSE
                  xdir% = 0
               END IF
               IF incr2& < 0 THEN
                  ydir% = -1
                  incr2& = -incr2&
               ELSEIF incr2& > 0 THEN
                  ydir% = 1
               ELSE
                  ydir% = 0
               END IF
               xc& = 0
               x% = xc1%: y% = yc1%
               DO
                  IF ((x% OR y%) AND &HFF80) = 0 THEN clipbuf%(x%, y%) = 1
                  IF xc& < 0 THEN
                     xc& = xc& + incr2&: x% = x% + xdir%
                  ELSE
                     xc& = xc& - incr1&: y% = y% + ydir%
                  END IF
               LOOP WHILE x% <> xc2% OR y% <> yc2%
            END IF
         NEXT i%
      NEXT yz&
   NEXT xz&
END SUB

SUB clipmove (vel&)
   incr1& = vel& * 256& * COS(ang% * 3.141592 / 1024)
   incr2& = vel& * 256& * SIN(ang% * 3.141592 / 1024)
   IF incr1& < 0 THEN
      xdir% = -1
      incr1& = -incr1&
   ELSEIF incr1& > 0 THEN
      xdir% = 1
   ELSE
      xdir% = 0
   END IF
   IF incr2& < 0 THEN
      ydir% = -1
      incr2& = -incr2&
   ELSEIF incr2& > 0 THEN
      ydir% = 1
   ELSE
      ydir% = 0
   END IF
   xdiredge% = xdir% * 8: ydiredge% = ydir% * 8
   d& = incr2& - incr1&
   bad1% = 0: bad2% = 0
   x% = (posx& - nowx&) \ 16: y% = (posy& - nowy&) \ 16
   FOR z% = 1 TO ABS(vel&)
      IF d& < 0 THEN
         d& = d& + incr2&
         bad1% = 0
         IF clipbuf%(x% + xdiredge%, y% - 7) = 1 THEN bad1% = 2
         IF clipbuf%(x% + xdiredge%, y% + 7) = 1 THEN bad1% = 2
         FOR zx% = -6 TO 6
            IF clipbuf%(x% + xdiredge%, y% + zx%) = 1 THEN bad1% = 1
         NEXT zx%
         IF bad1% = 0 THEN x% = x% + xdir%
      ELSE
         d& = d& - incr1&
         bad2% = 0
         IF clipbuf%(x% - 7, y% + ydiredge%) = 1 THEN bad2% = 2
         IF clipbuf%(x% + 7, y% + ydiredge%) = 1 THEN bad2% = 2
         FOR zx% = -6 TO 6
            IF clipbuf%(x% + zx%, y% + ydiredge%) = 1 THEN bad2% = 1
         NEXT zx%
         IF bad2% = 0 THEN y% = y% + ydir%
      END IF
      IF (bad1% = 2 OR bad2% = 2) AND (bad1% > 0 AND bad2% > 0) THEN
         IF bad1% = 2 THEN
            bad% = 0
            FOR zx% = -7 TO 7
               bad% = bad% OR clipbuf%(x% + zx%, y% - ydiredge%)
            NEXT zx%
            IF bad% = 0 THEN y% = y% - ydir%: d% = 0
         END IF
         IF bad2% = 2 THEN
            bad% = 0
            FOR zx% = -7 TO 7
               bad% = bad% OR clipbuf%(x% - xdiredge%, y% + zx%)
            NEXT zx%
            IF bad% = 0 THEN x% = x% - xdir%: d% = -1
         END IF
      END IF
      bad% = 0
      IF x% <= 8 THEN
         nowx& = nowx& - 1024
         x% = x% + 64
         bad% = 1
      END IF
      IF x% >= 119 THEN
         nowx& = nowx& + 1024
         x% = x% - 64
         bad% = 1
      END IF
      IF y% <= 8 THEN
         nowy& = nowy& - 1024
         y% = y% + 64
         bad% = 1
      END IF
      IF y% >= 119 THEN
         nowy& = nowy& + 1024
         y% = y% - 64
         bad% = 1
      END IF
      IF bad% = 1 THEN CALL cliploadlocal
   NEXT z%
   posx& = nowx& + x% * 16
   posy& = nowy& + y% * 16
END SUB

SUB drawline (x0%, y0%, x1%, y1%, col%)
   DEF SEG = &HA000
   xdim% = ABS(x1% - x0%)
   ydim% = ABS(y1% - y0%)
   IF xdim% >= ydim% THEN
      IF x1% < x0% THEN SWAP x0%, x1%: SWAP y0%, y1%
      p& = (y0% AND 63) * 1024& + x0%
      pag% = y0% \ 64
      OUT &H3CD, pag%
      cnt% = 0
      IF y1% > y0% THEN pinc& = 1024 ELSE pinc& = -1024
      FOR zx% = 0 TO xdim%
         POKE p&, col%
         cnt% = cnt% + ydim%
         IF cnt% >= xdim% THEN
            cnt% = cnt% - xdim%
            p& = p& + pinc&
            IF p& < 0 THEN pag% = pag% - 1: OUT &H3CD, pag%: p& = p& + 65536
            IF p& > 65535 THEN pag% = pag% + 1: OUT &H3CD, pag%: p& = p& - 65536
         END IF
         p& = p& + 1
      NEXT zx%
   END IF
   IF xdim% < ydim% THEN
      IF y1% < y0% THEN SWAP x0%, x1%: SWAP y0%, y1%
      p& = (y0% AND 63) * 1024& + x0%
      pag% = y0% \ 64
      OUT &H3CD, pag%
      cnt% = 0
      IF x1% > x0% THEN pinc& = 1 ELSE pinc& = -1
      FOR zx% = 0 TO ydim%
         POKE p&, col%
         cnt% = cnt% + xdim%
         IF cnt% >= ydim% THEN
            cnt% = cnt% - ydim%
            p& = p& + pinc&
         END IF
         p& = p& + 1024
         IF p& < 0 THEN pag% = pag% - 1: OUT &H3CD, pag%: p& = p& + 65536
         IF p& > 65535 THEN pag% = pag% + 1: OUT &H3CD, pag%: p& = p& - 65536
      NEXT zx%
   END IF
END SUB

