DECLARE SUB printext256 (xpos&, ypos&, col%, backcol%, z$)
SCREEN 13: DEF SEG = &HA000

CONST XDIM = 1024
DIM SHARED textfont%(128, 8), reversemask%(16)

reversemask%(0) = 0: reversemask%(1) = 8
reversemask%(2) = 4: reversemask%(3) = 12
reversemask%(4) = 2: reversemask%(5) = 10
reversemask%(6) = 6: reversemask%(7) = 14
reversemask%(8) = 1: reversemask%(9) = 9
reversemask%(10) = 5: reversemask%(11) = 13
reversemask%(12) = 3: reversemask%(13) = 11
reversemask%(14) = 7: reversemask%(15) = 15

OUT &H3C4, &H4: OUT &H3C5, &H6
OUT &H3D4, &H14: OUT &H3D5, &H0
OUT &H3D4, &H17: OUT &H3D5, &HE3

OUT &H3C4, 2: OUT &H3C5, 15
FOR p& = 0 TO 65535
   POKE p&, 0
NEXT p&

OUT &H3D4, &H13: OUT &H3D5, XDIM \ 8

OPEN "tables.dat" FOR BINARY AS #1
   z$ = STRING$(4096, 0): GET #1, , z$
   z$ = STRING$(4096, 0): GET #1, , z$
   z$ = STRING$(640, 0): GET #1, , z$
   z$ = STRING$(1024, 0): GET #1, , z$
   FOR z% = 0 TO 127
      FOR zz% = 0 TO 7
         textfont%(z%, zz%) = ASC(MID$(z$, z% * 8 + zz% + 1, 1))
      NEXT zz%
   NEXT z%
CLOSE #1

x& = 0: y& = 0
DO
   CALL printext256(x&, y&, 16 * RND, 1, "Hello there!")
   x& = x& + 1: y& = y& + 1
LOOP WHILE INKEY$ = ""

SUB printext256 (xpos&, ypos&, col%, backcol%, z$)
   DEF SEG = &HA000
   OUT &H3C4, 2
   startp& = (ypos& * XDIM) \ 4 + (xpos& \ 4)
  
   FOR zx% = 1 TO LEN(z$)
      dat% = ASC(MID$(z$, zx%, 1))
      
      IF (xpos& AND 3) = 0 THEN
         p& = startp&
         FOR z% = 0 TO 7
            IF backcol% >= 0 THEN
               OUT &H3C5, 15 - reversemask%(textfont%(dat%, z%) \ 16): POKE p&, backcol%
               OUT &H3C5, 15 - reversemask%(textfont%(dat%, z%) AND 15): POKE p& + 1, backcol%
            END IF
            OUT &H3C5, reversemask%(textfont%(dat%, z%) \ 16): POKE p&, col%
            OUT &H3C5, reversemask%(textfont%(dat%, z%) AND 15): POKE p& + 1, col%
            p& = p& + (XDIM \ 4)
         NEXT z%
      ELSE
         shift% = (xpos& AND 3)

         p& = startp&
         FOR z% = 0 TO 7
            IF backcol% >= 0 THEN
               OUT &H3C5, (16 - 2 ^ shift%) - (reversemask%((textfont%(dat%, z%) \ (2 ^ (shift% + 4))) AND reversemask%(16 - 2 ^ shift%))): POKE p&, backcol%
               OUT &H3C5, 15 - (reversemask%((textfont%(dat%, z%) \ (2 ^ shift%)) AND 15)): POKE p& + 1, backcol%
               OUT &H3C5, (2 ^ shift% - 1) - (reversemask%((textfont%(dat%, z%) * (2 ^ (4 - shift%))) AND reversemask%(2 ^ shift% - 1))): POKE p& + 2, backcol%
            END IF
            OUT &H3C5, (reversemask%((textfont%(dat%, z%) \ (2 ^ (shift% + 4))) AND reversemask%(16 - 2 ^ shift%))): POKE p&, col%
            OUT &H3C5, (reversemask%((textfont%(dat%, z%) \ (2 ^ shift%)) AND 15)): POKE p& + 1, col%
            OUT &H3C5, (reversemask%((textfont%(dat%, z%) * (2 ^ (4 - shift%))) AND reversemask%(2 ^ shift% - 1))): POKE p& + 2, col%
            p& = p& + (XDIM \ 4)
         NEXT z%
      END IF

      startp& = startp& + 2
   NEXT zx%
END SUB

