; "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
; Ken Silverman's official web site: "http://www.advsys.net/ken"
; See the included license file "BUILDLIC.TXT" for license info.

.386P

EXTRN _asm1 : dword
EXTRN _asm2 : dword
EXTRN _asm3 : dword
EXTRN _asm4 : dword
EXTRN _palookup : near

CODE SEGMENT BYTE PUBLIC USE32 'CODE'
ASSUME cs:CODE

PUBLIC hlineasm64_
hlineasm64_:
	push ebp
	mov ebp, ebx

	sub _asm3, 4
	jc hline64skip1

beginhline64:

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov al, byte ptr _palookup[ebx]
	add esi, _asm1
	add edx, _asm2

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov ah, byte ptr _palookup[ebx]
	shl eax, 16
	add esi, _asm1
	add edx, _asm2

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov al, byte ptr _palookup[ebx]
	add esi, _asm1
	add edx, _asm2

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov ah, byte ptr _palookup[ebx]
	add esi, _asm1
	add edx, _asm2

	rol eax, 16
	stosd

	sub _asm3, 4
	jnc beginhline64

hline64skip1:
	cmp _asm3, -2
	jl hline64skip2

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov al, byte ptr _palookup[ebx]
	add esi, _asm1
	add edx, _asm2

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov ah, byte ptr _palookup[ebx]
	add esi, _asm1
	add edx, _asm2

	stosw

	add _asm3, 2
hline64skip2:
	test _asm3, 1
	jz hline64skip3

	xor ebx, ebx
	shld ebx, esi, 6
	shld ebx, edx, 6
	mov bl, byte ptr [ebp+ebx]
	mov bh, cl
	mov al, byte ptr _palookup[ebx]
	add esi, _asm1
	add edx, _asm2

	stosb

hline64skip3:
	pop ebp
	ret

CODE ENDS
END
